C     NIPER BLACK OIL PRIMARY AND SECONDARY RECOVERY MODEL
C       (MEOR TRANSPORT SIMULATION) 
C       --- SLANTED/HORIZONTAL/VERTICAL WELL MODEL  
C       --- 'RESTART' OPTION
C       --- MEOR OPTION (SOLVE MICROBE IMPLICITLY USING CRANK-NICHOLSON METHOD)
C     MARCH, 1988
C       --- IMPROVED RATE CONSTRAINT IN "QRATE" SUBROUTINE (SEPT. 89)
C *****  REWRITTEN FROM "BOST36.FOR" ......
C          INPUT  : BE3.DAT
C          OUTPUT : BE3.OUT, BE3.RATE, BE3.MAP
C
C ***** 'MEOR.PAR' IS INCLUDED FOR RE-DIMENSION ......
C          COMPILE THIS WHEN 'MEOR.PAR' IS IN THE SAME ACCOUNT
C
      INCLUDE 'MEOR.PAR' 
      REAL KX,KY,KZ,KROT,KRWT,KRGT,MUOT,MUWT,MUGT,MCFG,MCFG1,MCFGT,
     & MCFGI,MBEO,MBEW,MBEG,MIN,K1,K2
      CHARACTER*2 TITLE(80),FNAME,MNAME,TAG
      CHARACTER*5 WELLID
      CHARACTER*4 LNAME
      COMMON /IDEN/ WELLID(NW)
      COMMON /IO/ NI,NO
      COMMON /BUBBLE/ PBO,VSLOPE,BSLOPE,RSLOPE,PMAXT,IREPRS,RHOROCK,
     & RHOSCO,RHOSCG,RHOSCW,MSAT,MPOT,MPWT,MPGT,PBOT(NX,NY,NZ)
      COMMON /COEF/ AW(NX,NY,NZ),AE(NX,NY,NZ),AN(NX,NY,NZ),
     & AS(NX,NY,NZ),AB(NX,NY,NZ),AT(NX,NY,NZ),E(NX,NY,NZ),B(NX,NY,NZ)
      COMMON /SARRAY/ PN(NX,NY,NZ),
     & SON(NX,NY,NZ),SWN(NX,NY,NZ),SGN(NX,NY,NZ),
     & SO1(NX,NY,NZ),SW1(NX,NY,NZ),SG1(NX,NY,NZ),
     & A1(NX,NY,NZ),A2(NX,NY,NZ),A3(NX,NY,NZ),
     & SUM(NX,NY,NZ),GAM(NX,NY,NZ),QS(NX,NY,NZ)
      COMMON /PERM/ KX(NX,NY,NZ),KY(NX,NY,NZ),KZ(NX,NY,NZ)
      COMMON /TRAN/ TX(NX+1,NY,NZ),TY(NX,NY+1,NZ),TZ(NX,NY,NZ+1)
      COMMON /ELEV/ EL(NX,NY,NZ)
      COMMON /PRTP/ P(NX,NY,NZ)
      COMMON /PRTS/ SO(NX,NY,NZ),SW(NX,NY,NZ),SG(NX,NY,NZ)
      COMMON /SPVT/ SAT(NTE),KROT(NTE),KRWT(NTE),KRGT(NTE),PCOWT(NTE),
     & PCGOT(NTE),POT(NTE),MUOT(NTE),BOT(NTE),BOPT(NTE),RSOT(NTE),RSOPT
     & (NTE),PWT(NTE),MUWT(NTE),BWT(NTE),BWPT(NTE),RSWT(NTE),RSWPT(NTE),
     & PGT(NTE),MUGT(NTE),BGT(NTE),BGPT(NTE),CRT(NTE)
      COMMON /SRATE/ PID(NW,NL),PWF(NW,NL),PWFC(NW,NL),KIP(NW),
     & GMO(NW,NL),GMW(NW,NL),GMG(NW,NL),LAYER(NW),QVO(NW),
     & QVW(NW),QVG(NW),QVT(NW),CUMO(NW,NL),CUMW(NW,NL),CUMG(NW,NL)
      COMMON /VOLFAC/ BO(NX,NY,NZ),BW(NX,NY,NZ),BG(NX,NY,NZ)
      COMMON /RATE/ QO(NX,NY,NZ),QW(NX,NY,NZ),QG(NX,NY,NZ)
      COMMON /RATEQ/ QO0(NX,NY,NZ),QW0(NX,NY,NZ),QG0(NX,NY,NZ),ITFLAG
      COMMON /TERM1/ GOWT(NX,NY,NZ),GWWT(NX,NY,NZ),GGWT(NX,NY,NZ),
     & OW(NX+1,NY,NZ),OE(NX+1,NY,NZ),WW(NX+1,NY,NZ),WE(NX+1,NY,NZ),
     & OS(NX,NY+1,NZ),ON(NX,NY+1,NZ),WS(NX,NY+1,NZ),WN(NX,NY+1,NZ),
     & OT(NX,NY,NZ+1),OB(NX,NY,NZ+1),WT(NX,NY,NZ+1),WB(NX,NY,NZ+1)
      COMMON /TERM2/ QOWG(NX,NY,NZ)
      COMMON /COMPRS/ CT(NX,NY,NZ)
      COMMON /PORE/ VP(NX,NY,NZ),POR(NX,NY,NZ),PV
      COMMON /VECTOR/ DX(NX,NY,NZ),DY(NX,NY,NZ),DZ(NX,NY,NZ)
      COMMON /IQN/ IQN1(NW),IQN2(NW),IQN3(NW)
      COMMON /IQH/ IQH1(NW,NL),IQH2(NW,NL),IQH3(NW,NL),COND(NW)
      COMMON /CODE/ KSM1,KSN1,KCO1,NN,FACT1,FACT2,TMAX,KSOL,MITER,
     & OMEGA,TOL,TOL1,KSN,KSM,KCO,KTR,KCOFF,DSMAX,DPMAX,WORMAX,
     & GORMAX,PAMIN,PAMAX
      COMMON /ADD1/ IM,JM,KM,ETI,FT,FTMAX
      COMMON /ADD2/ COP,CWP,CGP,CWI,CGI,CPOI,PVWI,POIR
      COMMON /PSCNTL/ KPI,KSI
      COMMON /MBE/ MBEO,MBEW,MBEG
      COMMON /NUMBER/ II,JJ,KK
      COMMON /VOL/ SCFO,SCFW,SCFG,SCFG1,STBO,STBW,MCFG,MCFG1,MCFGT,
     & MCFGI,STBOI,STBWI,RESVOL
      COMMON /BAL/ OP,WP,GP,WI,GI,PAVG0,PAVG,OPR,WPR,GPR,WIR,GIR,CWOR,
     & WOR,CGOR,GOR
      COMMON /PRTCNT/ IWLCNG,ICHANG,IWLREP,ISUMRY,
     & IPMAP,ISOMAP,ISWMAP,ISGMAP,IPBMAP,ICHMAP,CHEMAP
      COMMON /IO2/ NO2
      COMMON /CHRCTR/ FNAME,MNAME(NUM),LNAME,TAG
      COMMON /TTEST/ NUMPRD,SONTVL
      COMMON /SWTCH/ NGRSW,NTRSW,NRESTART,NGEL
      COMMON /R1XYZ/ R11X,R21X,R31X,R41X,R11Y,R21Y,R31Y,R41Y,
     & R11Z,R21Z,R31Z,R41Z
      COMMON /T1XYZ/ T1X,T2X,T3X,T4X,T1Y,T2Y,T3Y,T4Y,T1Z,T2Z,T3Z,T4Z
      COMMON /DXYZ/ DX0,DXP,DXM,XW,DY0,DYP,DYM,YW,DZ0,DZP,DZM,ZW
      COMMON /RXYZ/ RX,RY,RZ,AX,AY,AZ,I,J,K
      COMMON /COUNT/ N1READ,N2READ
      COMMON /DT/ DELT,DELT0
      COMMON /RSO9/ RSO9,RSW9
      COMMON /MEORB/ C(NX,NY,NZC),SIGMA(NX,NY,NZ),RF(NX,NY,NZ),AKC,
     & AKD,AKY,AKS,AMUM,YIELD,RHOMIC,CQI(NW,NC),MAPWI(NX,NY,NZ),RFT
      COMMON /MEOR2/ AKDN,AKM,DTUMB,ALPHAL,ALPHAT,SIGMAX,GASMEOR,REDK
      COMMON /DIFF/ DDX(NC),DDY(NC),DDZ(NC)
      COMMON /FLUX/ UX(NX,NY,NZ),UY(NX,NY,NZ),UZ(NX,NY,NZ)
      COMMON /CONC/ CC(NX,NY,NZ),QG1(NX,NY,NZ)

      COMMON /BE4C/ UW(NX,NY,NZ),UE(NX,NY,NZ),
     & US(NX,NY,NZ),UN(NX,NY,NZ),UT(NX,NY,NZ),UB(NX,NY,NZ)
C      COMMON /GEL/ DDX,DDY,DDZ,K1,K2,NRX,C(NX,NY,NZC),
C     & UX(NX,NY,NZ),UY(NX,NY,NZ),UZ(NX,NY,NZ),MAPWI(NX,NY,NZ),
C     & CQI(NW,5),MORDER,FIPV(NZ,5),UW(NX,NY,NZ),UE(NX,NY,NZ),
C     & US(NX,NY,NZ),UN(NX,NY,NZ),UT(NX,NY,NZ),UB(NX,NY,NZ)
      COMMON /FLORAT/ UWN(NX,NY,NZ),UEN(NX,NY,NZ),USN(NX,NY,NZ),
     & UNN(NX,NY,NZ),UTN(NX,NY,NZ),UBN(NX,NY,NZ)
C      COMMON /ADSORB/ AA(5),BB(5),CL(5),GAMA(5),RF(NX,NY,NZ),RFT
C      COMMON /SHEAR/GAMMA0,GAMMA1,GAMMA2,GAMMA3,SHEARA,SHEARB
C      COMMON /VIS/ ALPHA1,ALPHA2,ALPHA3,BETA1,BETA2,BETA3,CGC,
C     & DTMUW(NX,NY,NZ)
C      COMMON /CNEXT/ CNEXT(NX,NY,NZC),CC3(NX,NY,NZ),C5TOT0
C      COMMON /TIMESTEP/ N
C      COMMON /MAXC/ C1MAX,C2MAX,C3MAX,C4MAX,C5MAX
      DIMENSION OOIP(NZ),OWIP(NZ),ODGIP(NZ),OFGIP(NZ)
      DIMENSION SOTE(NX,NY,NZ),SWTE(NX,NY,NZ)
C
      CHARACTER*12 OUTPUT, OUTRATE
      BYTE FLAG1
      NI=5
      NO=6
      OPEN(UNIT=NI,FILE='BE3.DAT',STATUS='OLD')
      OPEN(UNIT=13,FILE='OTNAM.TXT',STATUS='UNKNOWN')
      READ(NI,3009)OUTPUT
      READ(NI,3009)OUTRATE
      WRITE(13,2018)'  Output Files: '
      WRITE(13,2009) OUTPUT
      WRITE(13,2009) OUTRATE
CH      WRITE(13,2009) OUTGEL
CH      WRITE(13,2009) OUTMAT
2018  FORMAT(A16)
2009  FORMAT(A28)
3009  FORMAT(A12)
      OPEN(UNIT=NO,FILE=OUTPUT,STATUS='UNKNOWN')
      OPEN(UNIT=14,FILE=OUTRATE,STATUS='UNKNOWN')
      DIFCNT = 0
      DIFTOT = 0
C      OPEN(NI,FILE='BE3.DAT',STATUS='OLD')
C      OPEN(NO,FILE='BE3.OUT',STATUS='NEW')
C      OPEN(14,FILE='BE3.RATE',STATUS='NEW')
C      OPEN(10,FILE='BE3.DAT2',STATUS='NEW')
      WRITE(NO,3005)
      WRITE(NO,3007)
      WRITE(NO,3006)
 3007 FORMAT(T30,'*',T50,'           NIPER: ',T98,'*',/T30,'*',
     & T50,'MICROBIAL TRANSPORT SIMULATOR',T98,'*',
     & /T30,'*',T59,'(VERSION 1)',T98,'*')
 3005 FORMAT(//T30,69('*'),/T30,'*',T98,'*'/T30,'*',T98,'*')
 3006 FORMAT(T30,'*',T98,'*'/T30,'*',T98,'*'/T30,69('*'),///)
C
C**** ESTABLISH RESERVOIR AND BLOCK DIMENSIONS
C
      CALL GRID1
C
C**** ESTABLISH POROSITY AND PERMEABILITY AT EACH ZONE
C
      CALL PARM1
C
C**** CALCULATE INTERBLOCK TRANSMISSIBILITIES
C
       RFT=0.
      CALL TRAN1
C
C**** EMPIRICAL DATA
C
      CALL TABLE
C
C**** READ GELATION DATA IF THIS OPTION IS INVOKED
C
      IF(NGEL.EQ.1)CALL MEORDATA
C
C**** ESTABLISH INITIAL CONDITIONS
C
      CALL UINIT1
C
C**** SOLUTION METHOD, DEBUG PRINT, AND TIME-STEP CONTROL PARAMETERS.
C
      CALL CODES
      READ(NI,69)(TITLE(IH),IH=1,40)
      READ(NI,*) SUREP
      PRIN=SUREP
69    FORMAT(40A2)
      D5615 = 1./5.615
      D288  = 1./288.
      D114  = 1./144.
      NMAX  = NN+1
      DO 1000 N=1,NMAX
C
C*** NLOOP DEFINED TO AVOID INDEX MODIFICATION WARNINGS IN
C    CALLS TO MATBAL, SOLMAT, LSOR.
      NLOOP=N
C
C**** RECURRENT DATA.
C
      IF(FT.LT.FTMAX) GO TO 46
      READ(NI,*) IWLCNG,ICHANG,IWLREP,ISUMRY,
     & IPMAP,ISOMAP,ISWMAP,ISGMAP,IPBMAP,ICHMAP,CHEMAP,NGEL
      READ(NI,*) DAY,DTMIN,DTMAX
      IF(IWLCNG.EQ.0) GO TO 45
      CALL NODES(NVQN,NVQNH,NVQNS)
C   45 DELT=DAY+HOUR/24.+MIN/1440.+SEC/86400.
   45 DELT=DAY
      FTMAX=ETI+ICHANG*DELT
   46 IF(N.EQ.1)DELT0=DELT
      IF(N.EQ.1)GO TO 1050
      IF(DSMC.LT.DSMAX.AND.DPMC.LT.DPMAX)DELT=DELT*FACT1
      IF(DSMC.GT.DSMAX.OR.DPMC.GT.DPMAX)DELT=DELT*FACT2
      IF(DELT.LT.DTMIN)DELT=DTMIN
      IF(DELT.GT.DTMAX)DELT=DTMAX
      IF(ETI+DELT.GT.FTMAX)DELT=FTMAX-ETI
1050  FT=ETI+DELT
C      WRITE(*,*) FT
      IF(ETI+DELT*0.5.GE.TMAX) GO TO 1010
C****ITFLAG COUNTS THE NUMBER OF TIME STEP REPITITIONS.
      ITFLAG=0
C****REENTRY POINT FOR REPEATED TIME STEP.
1060  CONTINUE
      DIV1 = 1./DELT
      IF(N.GT.1.OR.ITFLAG.GT.0) GO TO 105
      RESVOL=0.0
      SCFO=0.0
      SCFG=0.0
      SCFG1=0.0
      DO 102 K=1,KK
      OOIP(K)=0.
      OWIP(K)=0.
      ODGIP(K)=0.
      OFGIP(K)=0.
      DO 100 J=1,JJ
      DO 100 I=1,II
      PP=P(I,J,K)
      BPT=PBOT(I,J,K)
      VP(I,J,K)=VP(I,J,K)*DX(I,J,K)*DY(I,J,K)*DZ(I,J,K)
      RESVOL=RESVOL+VP(I,J,K)
C**** NOTE: WE ARE ASSUMING INITIAL PHI IS AT INITIAL RESERVOIR PRESSURE
      CALL INTPVT(BPT,RSLOPE,POT,RSOT,MPOT,PP,RSO)
      CALL INTERP(PWT,RSWT,MPWT,PP,RSW)
      CALL INTPVT(BPT,BSLOPE,POT,BOT,MPOT,PP,BO(I,J,K))
      CALL INTERP(PWT,BWT,MPWT,PP,BW(I,J,K))
      CALL INTERP(PGT,BGT,MPGT,PP,BG(I,J,K))
      FF1=SO(I,J,K)/BO(I,J,K)
      FF2=SW(I,J,K)/BW(I,J,K)
      SCFO=SCFO+VP(I,J,K)*FF1
      SCFW=SCFW+VP(I,J,K)*FF2
      SCFG=SCFG+VP(I,J,K)*SG(I,J,K)/BG(I,J,K)
      SCFG1=SCFG1+VP(I,J,K)*(RSO*FF1+RSW*FF2)
      CALL INTERP(POT,BOPT,MPOT,PP,BODER)
      CALL INTERP(POT,RSOPT,MPOT,PP,RSODER)
      CALL INTERP(PWT,BWPT,MPWT,PP,BWDER)
      CALL INTERP(PWT,RSWPT,MPWT,PP,RSWDER)
      CALL INTERP(PGT,BGPT,MPGT,PP,BGDER)
      IF(PP.GT.PBOT(I,J,K))BODER=BSLOPE
      IF(PP.GT.PBOT(I,J,K))RSODER=RSLOPE
      CO=-(BODER-BG(I,J,K)*RSODER)/BO(I,J,K)
      CW=-(BWDER-BG(I,J,K)*RSWDER)/BW(I,J,K)
      CG=-BGDER/BG(I,J,K)
      CALL INTERP(PGT,CRT,MPGT,PP,CR)
      CT(I,J,K)=CR + CO*SO(I,J,K) +CW*SW(I,J,K) + CG*SG(I,J,K)
      OOIP(K)=OOIP(K)+D5615*.000001*SON(I,J,K)*VP(I,J,K)/BO(I,J,K)
      OWIP(K)=OWIP(K)+D5615*.000001*SWN(I,J,K)*VP(I,J,K)/BW(I,J,K)
      ODGIP(K)=ODGIP(K)+.001*.000001*(RSO*SON(I,J,K)*VP(I,J,K)/BO(I,J,K)
     & +RSW*SWN(I,J,K)*VP(I,J,K)/BW(I,J,K))
      OFGIP(K)=OFGIP(K)+.001*.000001*SGN(I,J,K)*VP(I,J,K)/BG(I,J,K)
      IF(KCO1.EQ.0)GO TO 100
      WRITE(NO,21)I,J,K,VP(I,J,K),CT(I,J,K),BO(I,J,K),SO(I,J,K),
     &BW(I,J,K),SW(I,J,K),BG(I,J,K),SG(I,J,K)
  21  FORMAT(1X,3I3,8E15.6)
  100 CONTINUE
      WRITE(NO,110)K,OOIP(K),OWIP(K),ODGIP(K),OFGIP(K)
  110 FORMAT(/,1X,'LAYER',I3,' INITIAL FLUID VOLUMES:',
     & /,10X,'OIL IN PLACE (MILLION STB)',T60,F10.4,
     & /,10X,'WATER IN PLACE (MILLION STB)',T60,F10.4,
     & /,10X,'SOLUTION GAS IN PLACE (BILLION SCF)',T60,F10.4,
     & /,10X,'FREE GAS IN PLACE (BILLION SCF)',T60,F10.4/)
  102 CONTINUE
      TOOIP=0.
      TOWIP=0.
      TODGIP=0.
      TOFGIP=0.
      DO 103 K=1,KK
      TOOIP=TOOIP+OOIP(K)
      TOWIP=TOWIP+OWIP(K)
      TODGIP=TODGIP+ODGIP(K)
  103 TOFGIP=TOFGIP+OFGIP(K)
      WRITE(NO,115) TOOIP,TOWIP,TODGIP,TOFGIP
  115 FORMAT(/,1X,'TOTAL INITIAL FLUID VOLUMES IN RESERVOIR:',
     & /,10X,'OIL IN PLACE (MILLION STB)',T60,F10.4,
     & /,10X,'WATER IN PLACE (MILLION STB)',T60,F10.4,
     & /,10X,'SOLUTION GAS IN PLACE (BILLION SCF)',T60,F10.4,
     & /,10X,'FREE GAS IN PLACE (BILLION SCF)',T60,F10.4/)
      STBO=SCFO*D5615
      STBW=SCFW*D5615
      MCFG=SCFG*0.001
      MCFG1=SCFG1*0.001
      STBOI=STBO
      STBWI=STBW
      MCFGI=MCFG+MCFG1
      IF(MCFGI.LE.1.D-7.AND.MCFGT.LE.1.D-7)MBEG=0.0
105   IF(N.EQ.1.AND.ITFLAG.LE.0) CALL PRTPS(N,DELT0)
      IF(N.EQ.NMAX) GO TO 1010
C
C**** ESTABLISH RATES & CALCULATE BHFP(IF PID IS NONZERO)
C
      IF(NVQN.NE.0)CALL QRATE(1,NVQN,NVQNH)
      IF(NVQNH.NE.0)CALL QRATE(2,NVQN,NVQNH) 
      IF(NVQNS.NE.0)CALL QRATE(2,NVQN+NVQNH,NVQNS)
C      CALL QRATE(NVQN)
C
C**** CALCULATE SEVEN DIAGONAL MATRIX FOR PRESSURE SOLUTION

      IF(RFT.GT.1.)CALL TRAN1
1160  CALL SOLMAT(DIV1,D288,D144,N)

C**** MODIFY MATRIX ELEMENTS FOR WELLS UNDER IMPLICIT CONTROL.
C
      IF(NVQN.NE.0) CALL PRATEI(1,NVQN,NVQNH)
      IF(NVQNH.NE.0)CALL PRATEI(2,NVQN,NVQNH) 
      IF(NVQNS.NE.0)CALL PRATEI(2,NVQN+NVQNH,NVQNS)
C      CALL PRATEI(NVQN)
C
C**** CALCULATE NEW PRESSURE DISTRIBUTION
C
1170  CALL LSOR(DELT,DELT0,N)
C
C**** CALCULATE IMPLICIT RATES.
C
      IF(NVQN.NE.0) CALL PRATEO(1,NVQN,NVQNH)
      IF(NVQNH.NE.0)CALL PRATEO(2,NVQN,NVQNH) 
      IF(NVQNS.NE.0)CALL PRATEO(2,NVQN+NVQNH,NVQNS)
C      CALL PRATEO(NVQN)
 2051 CONTINUE
C
C**** CALCULATE NEW FLUID SATURATIONS
C
      SCFO=0.0
      SCFW=0.0
      SCFG=0.0
      SCFG1=0.0
      RESVOL=0.0
      DO 400 K=1,KK
      DO 400 J=1,JJ
      DO 400 I=1,II
      PPN=PN(I,J,K)
      PP=P(I,J,K)
      BPT=PBOT(I,J,K)
      CALL INTPVT(BPT,RSLOPE,POT,RSOT,MPOT,PP,RSO)
      CALL INTERP(PWT,RSWT,MPWT,PP,RSW)
      CALL INTERP(PGT,CRT,MPGT,PPN,CR)
      BPT=PBOT(I,J,K)
      CALL INTPVT(BPT,BSLOPE,POT,BOT,MPOT,PP,BBO)
      CALL INTERP(PWT,BWT,MPWT,PP,BBW)
      CALL INTERP(PGT,BGT,MPGT,PP,BBG)
      VPP=VP(I,J,K) * (1.0+CR*(P(I,J,K)-PPN))
      RESVOL=RESVOL+VPP
C
      DP1=0.0
      DP2=0.0
      DP3=0.0
      DP4=0.0
      DP5=0.0
      DP6=0.0
      IF((I-1).GT.0)  DP1=P(I-1,J,K)-PP
      IF((I+1).LE.II) DP2=P(I+1,J,K)-PP
      IF((J-1).GT.0)  DP3=P(I,J-1,K)-PP
      IF((J+1).LE.JJ) DP4=P(I,J+1,K)-PP
      IF((K-1).GT.0)  DP5=P(I,J,K-1)-PP
      IF((K+1).LE.KK) DP6=P(I,J,K+1)-PP
C
      DAODP=OW(I,J,K)*DP1+OE(I,J,K)*DP2+OS(I,J,K)*DP3
     &     +ON(I,J,K)*DP4+OT(I,J,K)*DP5+OB(I,J,K)*DP6
      DAWDP=WW(I,J,K)*DP1+WE(I,J,K)*DP2+WS(I,J,K)*DP3
     &     +WN(I,J,K)*DP4+WT(I,J,K)*DP5+WB(I,J,K)*DP6
      SW(I,J,K)=((DAWDP+GWWT(I,J,K)-QW(I,J,K))*DELT +VP(I,J,K)*
     & SWN(I,J,K)/BW(I,J,K)) * BBW/VPP
      SO(I,J,K)=((DAODP+GOWT(I,J,K)-QO(I,J,K))*DELT +VP(I,J,K)*
     & SON(I,J,K)/BO(I,J,K)) * BBO/VPP

      IF(SO(I,J,K).LE.RSO9)SO(I,J,K)=RSO9
      IF(SW(I,J,K).LE.RSW9)SW(I,J,K)=RSW9
      IF(SO(I,J,K).GE.(1.-RSW9))SO(I,J,K)=1.-RSW9
      IF(SW(I,J,K).GE.(1.-RSO9))SW(I,J,K)=1.-RSO9

      SG(I,J,K)=1.0-SO(I,J,K)-SW(I,J,K)
      IF(SG(I,J,K).LT.0.)THEN
        SG(I,J,K)=0.
        SW(I,J,K)=1-SO(I,J,K)
       ENDIF
      IF(RSO.LE.0.0.AND.RSW.LE.0.0)SG(I,J,K)=0.0
C
      RW=(RHOSCW + RSW*RHOSCG)/BBW
      SSW=SW(I,J,K)
      CALL INTERP(SAT,PCOWT,MSAT,SSW,PCOW)
      IF(I.EQ.1) GO TO 152
      PP1=P(I-1,J,K)
      SSW1=SW(I-1,J,K)      
      CALL INTERP(PWT,RSWT,MPWT,PP1,RSW1)
      CALL INTERP(PWT,BWT,MPWT,PP1,BBW1)
      CALL INTERP(SAT,PCOWT,MSAT,SSW1,PCOW1)
      RW1=(RHOSCW + RSW1*RHOSCG)/BBW1
      GW1=(RW1+RW)*D288*(EL(I-1,J,K)-EL(I,J,K))-
     & PCOW+PCOW1
 152  IF(I.EQ.II) GO TO 154
      PP2=P(I+1,J,K)
      SSW2=SW(I+1,J,K)
      CALL INTERP(PWT,RSWT,MPWT,PP2,RSW2)
      CALL INTERP(PWT,BWT,MPWT,PP2,BBW2)
      CALL INTERP(SAT,PCOWT,MSAT,SSW2,PCOW2)
      RW2=(RHOSCW + RSW2*RHOSCG)/BBW2
      GW2=(RW2+RW)*D288*(EL(I+1,J,K)-EL(I,J,K))-
     & PCOW+PCOW2
C
 154  IF(J.EQ.1) GO TO 156
      PP3=P(I,J-1,K)
      SSW3=SW(I,J-1,K)
      CALL INTERP(PWT,RSWT,MPWT,PP3,RSW3)
      CALL INTERP(PWT,BWT,MPWT,PP3,BBW3)
      CALL INTERP(SAT,PCOWT,MSAT,SSW3,PCOW3)
      RW3=(RHOSCW + RSW3*RHOSCG)/BBW3
      GW3=(RW3+RW)*D288*(EL(I,J-1,K)-EL(I,J,K))-
     & PCOW+PCOW3
 156  IF(J.EQ.JJ) GO TO 158
      PP4=P(I,J+1,K)
      SSW4=SW(I,J+1,K)
      CALL INTERP(PWT,RSWT,MPWT,PP4,RSW4)
      CALL INTERP(PWT,BWT,MPWT,PP4,BBW4)
      CALL INTERP(SAT,PCOWT,MSAT,SSW4,PCOW4)
      RW4=(RHOSCW + RSW4*RHOSCG)/BBW4
      GW4=(RW4+RW)*D288*(EL(I,J+1,K)-EL(I,J,K))-
     & PCOW+PCOW4
C
 158  IF(K.EQ.1) GO TO 162
      PP5=P(I,J,K-1)
      SSW5=SW(I,J,K-1)
      CALL INTERP(PWT,RSWT,MPWT,PP5,RSW5)
      CALL INTERP(PWT,BWT,MPWT,PP5,BBW5)
      CALL INTERP(SAT,PCOWT,MSAT,SSW5,PCOW5)
      RW5=(RHOSCW +RSW5*RHOSCG)/BBW5
      GW5=(RW5+RW)*D288*(EL(I,J,K-1)-EL(I,J,K))-
     & PCOW+PCOW5
 162  IF(K.EQ.KK) GO TO 164
      PP6=P(I,J,K+1)
      SSW6=SW(I,J,K+1)
      CALL INTERP(PWT,RSWT,MPWT,PP6,RSW6)
      CALL INTERP(PWT,BWT,MPWT,PP6,BBW6)
      CALL INTERP(SAT,PCOWT,MSAT,SSW6,PCOW6)
      RW6=(RHOSCW +RSW6*RHOSCG)/BBW6
      GW6=(RW6+RW)*D288*(EL(I,J,K+1)-EL(I,J,K))-
     & PCOW+PCOW6
C
 164  UX(I,J,K)=0.
      IF((I-1).GT.0) UX(I,J,K)=UX(I,J,K)+
     & WW(I,J,K)*(DP1-GW1)/DY(I-1,J,K)/DZ(I-1,J,K)/2
      IF((I+1).LE.II) UX(I,J,K)= UX(I,J,K)-
     & WE(I,J,K)*(DP2-GW2)/DY(I+1,J,K)/DZ(I+1,J,K)/2
      IF(I.EQ.1.OR.I.EQ.II) UX(I,J,K)=UX(I,J,K)*2
      UY(I,J,K)=0.
      IF((J-1).GT.0) UY(I,J,K)=UY(I,J,K)+
     & WS(I,J,K)*(DP3-GW3)/DX(I,J-1,K)/DZ(I,J-1,K)/2
      IF((J+1).LE.JJ) UY(I,J,K)=UY(I,J,K)-
     & WN(I,J,K)*(DP4-GW4)/DX(I,J+1,K)/DZ(I,J+1,K)/2
      IF(J.EQ.1.OR.J.EQ.JJ) UY(I,J,K)=UY(I,J,K)*2
      UZ(I,J,K)=0.
      IF((K-1).GT.0) UZ(I,J,K)=UZ(I,J,K)+
     & WT(I,J,K)*(DP5-GW5)/DY(I,J,K-1)/DX(I,J,K-1)/2
      IF((K+1).LE.KK)UZ(I,J,K)=UZ(I,J,K)-
     & WB(I,J,K)*(DP6-GW6)/DY(I,J,K+1)/DX(I,J,K+1)/2
      IF(K.EQ.1.OR.K.EQ.KK) UZ(I,J,K)=UZ(I,J,K)*2
C
      IF((I-1).GT.0) UWN(I,J,K)=
     &  WW(I,J,K)*(DP1-GW1)/DY(I-1,J,K)/DZ(I-1,J,K)
      IF(I.EQ.1) UWN(I,J,K)=0.0
      IF((I+1).LE.II) UEN(I,J,K)=
     & -WE(I,J,K)*(DP2-GW2)/DY(I+1,J,K)/DZ(I+1,J,K)
      IF(I.EQ.II) UEN(I,J,K)=0.0
      IF((J-1).GT.0) USN(I,J,K)=
     &  WS(I,J,K)*(DP3-GW3)/DX(I,J-1,K)/DZ(I,J-1,K)
      IF(J.EQ.1) USN(I,J,K)=0.0
      IF((J+1).LE.JJ) UNN(I,J,K)=
     & -WN(I,J,K)*(DP4-GW4)/DX(I,J+1,K)/DZ(I,J+1,K)
      IF(J.EQ.JJ) UNN(I,J,K)=0.0
      IF((K-1).GT.0) UTN(I,J,K)=
     &  WT(I,J,K)*(DP5-GW5)/DX(I,J,K-1)/DY(I,J,K-1)
      IF(K.EQ.1) UTN(I,J,K)=0.0
      IF((K+1).LE.KK) UBN(I,J,K)=
     & -WB(I,J,K)*(DP6-GW6)/DX(I,J,K+1)/DY(I,J,K+1)
      IF(K.EQ.KK) UBN(I,J,K)=0.0
C

C
      IF(KCOFF.EQ.0) GO TO 397
      RHO1=VPP*SO(I,J,K)/BBO
      RHO2=VP(I,J,K)*SON(I,J,K)/BO(I,J,K)
      DIFFO=RHO1-RHO2
      RHW1=VPP*SW(I,J,K)/BBW
      RHW2=VP(I,J,K)*SWN(I,J,K)/BW(I,J,K)
      DIFFW=RHW1-RHW2
      RHG1=VPP*SG(I,J,K)/BBG
      RHG2=VP(I,J,K)*SGN(I,J,K)/BG(I,J,K)
      DIFFG=RHG1-RHG2
      WRITE(NO,33)
      WRITE(NO,21)I,J,K,P(I,J,K),SO(I,J,K),SON(I,J,K),SW(I,J,K),
     &SWN(I,J,K),SG(I,J,K),SGN(I,J,K),VPP
      WRITE(NO,21)I,J,K,GOWT(I,J,K),QO(I,J,K),GWWT(I,J,K),
     &QW(I,J,K)
      WRITE(NO,21)I,J,K,DAODP,DAWDP,DELT
      WRITE(NO,21)I,J,K,RHO1,RHO2,DIFFO
      WRITE(NO,21)I,J,K,RHW1,RHW2,DIFFW
      WRITE(NO,21)I,J,K,RHG1,RHG2,DIFFG,GGWT(I,J,K),QG(I,J,K)
C
 397  VP(I,J,K)=VPP
      BO(I,J,K)=BBO
      BW(I,J,K)=BBW
      BG(I,J,K)=BBG
      FF1=SO(I,J,K)/BO(I,J,K)
      FF2=SW(I,J,K)/BW(I,J,K)
      SCFO=SCFO+VP(I,J,K)*FF1
      SCFW=SCFW+VP(I,J,K)*FF2
      SCFG=SCFG+VP(I,J,K)*SG(I,J,K)/BG(I,J,K)
      SCFG1=SCFG1+VP(I,J,K)*(RSO*FF1+RSW*FF2)
      CALL INTERP(POT,BOPT,MPOT,PP,BODER)
      CALL INTERP(POT,RSOPT,MPOT,PP,RSODER)
      CALL INTERP(PWT,BWPT,MPWT,PP,BWDER)
      CALL INTERP(PWT,RSWPT,MPWT,PP,RSWDER)
      CALL INTERP(PGT,BGPT,MPGT,PP,BGDER)
      IF(PP.GT.PBOT(I,J,K))BODER=BSLOPE
      IF(PP.GT.PBOT(I,J,K))RSODER=RSLOPE
      CO=-(BODER-BG(I,J,K)*RSODER)/BO(I,J,K)
      CW=-(BWDER-BG(I,J,K)*RSWDER)/BW(I,J,K)
      CG=-BGDER/BG(I,J,K)
      CALL INTERP(PGT,CRT,MPGT,PP,CR)
      CT(I,J,K)=CR + CO*SO(I,J,K) +CW*SW(I,J,K) + CG*SG(I,J,K)
      IF(N.EQ.KCO)WRITE(NO,21)I,J,K,CR,CO,RSO,CW,RSW,CG
C
  400 CONTINUE
C      AUTO. TIME STEP CONTROL CALC. OF PRESSURE AND SAT. MAXIMA.
      PPM=0.
      SOM=0.
      SWM=0.
      SGM=0.
      DO 240 K=1,KK
      DO 240 J=1,JJ
      DO 240 I=1,II
      DPO=P(I,J,K)-PN(I,J,K)
      DSO=SO(I,J,K)-SON(I,J,K)
      DSW=SW(I,J,K)-SWN(I,J,K)
      DSG=SG(I,J,K)-SGN(I,J,K)
      IF(ABS(DPO).GT.ABS(PPM)) PPM=DPO
      IF(ABS(DSO).GT.ABS(SOM)) SOM=DSO
      IF(ABS(DSW).GT.ABS(SWM)) SWM=DSW
      IF(ABS(DSG).GT.ABS(SGM)) SGM=DSG
 240  CONTINUE
      DPMC=ABS(PPM)
      DSMC=ABS(SOM)
      IF(DSMC.LT.ABS(SGM))DSMC=ABS(SGM)
      IF(DSMC.LT.ABS(SWM))DSMC=ABS(SWM)
C****REPEAT TIME STEP?
      IF(DSMC.LT.DSMAX.AND.DPMC.LT.DPMAX) GO TO 402
      IF(DELT.LE.DTMIN.OR.FACT2.GE.1.0) GO TO 402
      ITFLAG=ITFLAG+1
      DELT=DELT*FACT2
      IF(DELT.LT.DTMIN) DELT=DTMIN
      FT=ETI+DELT
      IF(FT.GT.FTMAX) DELT=FTMAX-ETI
C****RESET VARIABLES.
      DO 250 I=1,II
      DO 250 J=1,JJ
      DO 250 K=1,KK
      P(I,J,K)=PN(I,J,K)
      SO(I,J,K)=SON(I,J,K)
      SW(I,J,K)=SWN(I,J,K)
      SG(I,J,K)=SGN(I,J,K)
  250 CONTINUE
C
  33  FORMAT(//)
C
      GO TO 1060
 402  CONTINUE
C
C****UNDERSATURATED GRID BLOCK SATURATION CALCULATION.
C
      DO 410 I=1,II
      DO 410 J=1,JJ
      DO 410 K=1,KK
      IF(P(I,J,K).GT.PN(I,J,K)) GO TO 410
      IF(P(I,J,K).LT.PBOT(I,J,K)) GO TO 410
      IP=I+1
      IM=I-1
      JP=J+1
      JM=J-1
      KP=K+1
      KM=K-1
      IF(IP.GT.II) GO TO 412
      IF(SGN(IP,J,K).GT.0.0001) GO TO 410
  412 IF(IM.LT.1) GO TO 414
      IF(SGN(IM,J,K).GT.0.0001) GO TO 410
  414 IF(JP.GT.JJ) GO TO 416
      IF(SGN(I,JP,K).GT.0.0001) GO TO 410
  416 IF(JM.LT.1) GO TO 418
      IF(SGN(I,JM,K).GT.0.0001) GO TO 410
  418 IF(KP.GT.KK) GO TO 420
      IF(SGN(I,J,KP).GT.0.0001) GO TO 410
  420 IF(KM.LT.1) GO TO 422
      IF(SGN(I,J,KM).GT.0.0001) GO TO 410
  422 SG(I,J,K)=0.0
  410 CONTINUE
C
C**** CALCULATE CHEMICAL CONCENTRATION FOR MEOR OPTION 
C
      IF(NGEL.EQ.1)CALL MEOR
C
C**** REPRESSURIZATION ALGORITHM.
      IF(IREPRS.EQ.1) GO TO 51
      DO 50 I=1,II
      DO 50 J=1,JJ
      DO 50 K=1,KK
      IF(SG(I,J,K).LE.0.0001) GO TO 50
      PP=P(I,J,K)
      IF(P(I,J,K).GT.PBOT(I,J,K)) PP=PBOT(I,J,K)
      CALL INTERP(POT,BOT,MPOT,PP,BBO)
      CALL INTERP(POT,RSOT,MPOT,PP,RSO)
      CALL INTERP(PGT,BGT,MPGT,PP,BBG)
      IF(SO(I,J,K).EQ.0.0) GO TO 50
      RSONEW=RSO + SG(I,J,K)*BBO/(SO(I,J,K)*BBG)
      CALL INTERP(RSOT,POT,MPOT,RSONEW,PBONEW)
      PBOT(I,J,K)=PBONEW
   50 CONTINUE
   51 CONTINUE
C**** UPDATE OLD FLUID VOLUMES FOR MATERIAL BALANCE.
      STBOI=STBO
      STBWI=STBW
      MCFGI=MCFGT
C**** UPDATE  NEW FLUID VOLUMES.
      STBO=SCFO*D5615
      STBW=SCFW*D5615
      MCFG=SCFG*0.001
      MCFG1=SCFG1*0.001
      MCFGT=MCFG+MCFG1
C
C***** DEBUG PRINT OF PRESENT AND FUTURE P,SO,SW,SG VALUES.
      IF(KCOFF.EQ.0)GO TO 291
      DO 290 K=1,KK
      DO 290 J=1,JJ
      DO 290 I=1,II
      WRITE(NO,21)I,J,K,PN(I,J,K),SON(I,J,K),SWN(I,J,K),SGN(I,J,K)
      WRITE(NO,21)I,J,K,P(I,J,K),SO(I,J,K),SW(I,J,K),SG(I,J,K)
290   CONTINUE
291   CONTINUE
C
C**** WELL REPORT (ALL RATE & PRESSURE DATA APPLICABLE THIS STEP)
C
      IJ=0
      TOR=0.
      TGR=0.
      TWR=0.
      TOC=0.
      TGC=0.
      TWC=0.
      N2=NVQN+NVQNH+NVQNS
      DO 2050 J=1,N2
      GOR=0.
      WOR=0.
      IJ=IJ+1
      IF (J.LE.NVQN)THEN 
       IQ1=IQN1(J)
       IQ2=IQN2(J)
       IQ3=IQN3(J)
       LAY=IQ3+(LAYER(J)-1)
      ELSE
       IQ3=1
       LAY=LAYER(J)
      ENDIF
      DO 2050 KKK=IQ3,LAY
      K=KKK
      IF (J.GT.NVQN)THEN 
       IQ1=IQH1(J,KKK)
       IQ2=IQH2(J,KKK)
       K=IQH3(J,KKK)
      ENDIF
      QO0(IQ1,IQ2,K)=QO(IQ1,IQ2,K)
      QW0(IQ1,IQ2,K)=QW(IQ1,IQ2,K)
      QG0(IQ1,IQ2,K)=QG(IQ1,IQ2,K)
      QOO=QO(IQ1,IQ2,K)*D5615
      QWW=QW(IQ1,IQ2,K)*D5615
      QGG=QG(IQ1,IQ2,K)*.001
      CUMO(J,KKK)=CUMO(J,KKK)+QOO*DELT*.001
      CUMW(J,KKK)=CUMW(J,KKK)+QWW*DELT*.001
      CUMG(J,KKK)=CUMG(J,KKK)+QGG*DELT*.001
      IF(IWLREP.EQ.0) GO TO 2050
  891 IF(IJ.EQ.1.AND.KKK.EQ.IQ3)WRITE(NO,591)FT
      IF(IJ.EQ.1.AND.KKK.EQ.IQ3)WRITE(NO,5911)
 5911 FORMAT(/,T56,'------ RATE ------',22X,'--- CUMULATIVE ---',
     & /,13X,'WELL LOCATION',4X,'CALC    SPEC    SPEC',4X,
     & 'OIL     GAS    WATER    GOR     WOR',5X,
     & 'OIL     GAS    WATER',/,
     & 14X,'ID',3X,'I  J  K    BHFP    BHFP     PI',
     & 3X,'STB/D    MCF/D   STB/D',20X,'MSTB    MMCF    MSTB',/)
      IF(QOO.EQ.0.)GO TO 998
      GOR=QGG*1000./QOO
      WOR=QWW/QOO
  998 WRITE(NO,592)WELLID(J),IQ1,IQ2,K,PWFC(J,KKK),PWF(J,KKK),
     & PID(J,KKK),QOO,QGG,QWW,GOR,WOR,CUMO(J,KKK),CUMG(J,KKK),
     & CUMW(J,KKK)
  592 FORMAT(11X,A5,1X,3I3,2F8.0,F7.3,3F9.0,F7.0,F7.3,3F8.0)
      TOR=TOR+QOO
      TGR=TGR+QGG
      TWR=TWR+QWW
      TOC=TOC+CUMO(J,KKK)
      TGC=TGC+CUMG(J,KKK)
      TWC=TWC+CUMW(J,KKK)
 2050 CONTINUE
      IF(IWLREP.EQ.0)GO TO 2052
  791 WRITE(NO,5912)TOR,TGR,TWR,TOC,TGC,TWC
 5912 FORMAT(12X,102('-'),/,
     &12X,'TOTALS',31X,3F9.0,14X,3F8.0,/)
 2052 CONTINUE
C
C*****CALCULATE MATERIAL BALANCE ERRORS & AVERAGE RESERVOIR PRESSURE
C
      DELT0=DELT
      ETI=ETI+DELT
      CALL MATBAL(DELT0,D5615)
C
      IF(WOR.GT.WORMAX) GO TO 1002
      IF(GOR.GT.GORMAX) GO TO 1003
      IF(PAVG.LT.PAMIN) GO TO 1004
      IF(PAVG.GT.PAMAX) GO TO 1005
C
C***** SUMMARY REPORT.
      IF(ETI.LT.PRIN) GO TO 988
      FOR=COP/TOOIP/1E+6
C      EFFLUENT1=(C(II-1,1,1)+C(II-2,1,1))/2.
C      EFFLUENT2=(C(II-1,1,KK+1)+C(II-2,1,KK+1))/2.
C      WRITE(14,987) N,ETI,PAVG,OPR/5.615,COP,GPR,CGP,FOR,
C     & WPR/5.615,CWP,WOR,PVWI,WIR
      WRITE(14,987) N,ETI,PAVG,OPR,COP,GPR,CGP,FOR,
     & WPR,CWP,WOR,PVWI,WIR
C     & WPR/5.615,CWP,WOR,PVWI,WIR,EFFLUENT1,EFFLUENT2
       PRIN=ETI+SUREP
 987  FORMAT(1X,I6,F8.2,2F8.1,F10.1,F8.1,F8.1,F8.5,F8.1,F10.1,
     & F8.2,F9.4,F10.1,F7.1,F8.3,F8.3)
 988  IF(NGRSW.EQ.1.AND.(ETI-NUMPRD*SONTVL).GE.0.0)CALL GRPHCS
      IF(ISUMRY.EQ.0) GO TO 2057  
      NLP=N+1
  691 CALL PRTPS(NLP,DELT0)
 2057 IF(N.NE.KCO.OR.KCO1.EQ.0)GO TO 500
      DO 300 K=1,KK
      DO 300 J=1,JJ
      DO 300 I=1,II
      WRITE(NO,21)I,J,K,VP(I,J,K),CT(I,J,K),BO(I,J,K),SO(I,J,K),
     &BW(I,J,K),SW(I,J,K),BG(I,J,K),SG(I,J,K)
300   CONTINUE
C
  500 CONTINUE
      IF(N.EQ.KSN)KSN=KSN+KSN1
      IF(N.EQ.KSM)KSM=KSM+KSM1
      IF(N.EQ.KCO)KCO=KCO+KCO1
C**** UPDATE ARRAYS.
      DO 1150 K=1,KK
      DO 1150 J=1,JJ
      DO 1150 I=1,II
      QO(I,J,K)=0.0
      QW(I,J,K)=0.0
      QG(I,J,K)=QG1(I,J,K)
      PN(I,J,K)=P(I,J,K)
      SON(I,J,K)=SO(I,J,K)
      SWN(I,J,K)=SW(I,J,K)
      SGN(I,J,K)=SG(I,J,K)
C
      IF((I-1).GT.0) UW(I,J,K)=UWN(I,J,K)
      IF(I.EQ.1) UW(I,J,K)=0.0
      IF((I+1).LE.II) UE(I,J,K)=UEN(I,J,K)
      IF(I.EQ.II) UE(I,J,K)=0.0
      IF((J-1).GT.0) US(I,J,K)=USN(I,J,K)
      IF(J.EQ.1) US(I,J,K)=0.0
      IF((J+1).LE.JJ) UN(I,J,K)=UNN(I,J,K)
      IF(J.EQ.JJ) UN(I,J,K)=0.0
      IF((K-1).GT.0) UT(I,J,K)=UTN(I,J,K)
      IF(K.EQ.1) UT(I,J,K)=0.0
      IF((K+1).LE.KK) UB(I,J,K)=UBN(I,J,K)
      IF(K.EQ.KK) UB(I,J,K)=0.0          
1150  CONTINUE
C
591   FORMAT(///T5,10('*'),' WELL REPORT FOR ALL ACTIVE WELLS ',
     &4X,'ELAPSED TIME =',F11.6,' DAYS FROM BEGINNING OF SIMULATION ',
     &10('*'),//)
C
      IF(WOR.GT.WORMAX) GO TO 1002
      IF(GOR.GT.GORMAX) GO TO 1003
      IF(PAVG.LT.PAMIN) GO TO 1004
      IF(PAVG.GT.PAMAX) GO TO 1005
1000  CONTINUE
C
1002  WRITE(NO,2002)
      GO TO 1010
1003  WRITE(NO,2003)
      GO TO 1010
1004  WRITE(NO,2004)
      GO TO 1010
1005  WRITE(NO,2005)
1010  CALL PRTPS(N,DELT0)
      CLOSE(UNIT=NI)
      CLOSE(UNIT=NO)
      IF(NRESTART.EQ.1)CALL RESTART
      STOP
C
2002  FORMAT(/T15,'MAXIMUM WOR HAS BEEN EXCEEDED --- SIMULATION',
     &' IS BEING TERMINATED'//)
2003  FORMAT(/T15,'MAXIMUM GOR HAS BEEN EXCEEDED --- SIMULATION',
     &' IS BEING TERMINATED'//)
2004  FORMAT(/T15,'MINIMUM AVERAGE RESERVOIR PRESSURE WAS NOT',
     &' ACHIEVED --- SIMULATION IS BEING TERMINATED'//)
2005  FORMAT(/T15,'MAXIMUM AVERAGE RESERVOIR PRESSURE
     &HAS BEEN EXCEEDED --- SIMULATION IS BEING TERMINATED'//)
C
      END
C
      BLOCK DATA
      INCLUDE 'MEOR.PAR' 
      COMMON /IO/ NI,NO
      COMMON /TRAN/ TX(NX+1,NY,NZ),TY(NX,NY+1,NZ),TZ(NX,NY,NZ+1)
      COMMON /SRATE/ PID(NW,NL),PWF(NW,NL),PWFC(NW,NL),KIP(NW),
     & GMO(NW,NL),GMW(NW,NL),GMG(NW,NL),LAYER(NW),QVO(NW),
     & QVW(NW),QVG(NW),QVT(NW),CUMO(NW,NL),CUMW(NW,NL),CUMG(NW,NL)
      COMMON /COEF/ AW(NX,NY,NZ),AE(NX,NY,NZ),AN(NX,NY,NZ),
     & AS(NX,NY,NZ),AB(NX,NY,NZ),AT(NX,NY,NZ),E(NX,NY,NZ),B(NX,NY,NZ)
      COMMON /TERM1/ GOWT(NX,NY,NZ),GWWT(NX,NY,NZ),GGWT(NX,NY,NZ),
     & OW(NX+1,NY,NZ),OE(NX+1,NY,NZ),WW(NX+1,NY,NZ),WE(NX+1,NY,NZ),
     & OS(NX,NY+1,NZ),ON(NX,NY+1,NZ),WS(NX,NY+1,NZ),WN(NX,NY+1,NZ),
     & OT(NX,NY,NZ+1),OB(NX,NY,NZ+1),WT(NX,NY,NZ+1),WB(NX,NY,NZ+1)
C      COMMON /VIS/ ALPHA1,ALPHA2,ALPHA3,BETA1,BETA2,BETA3,CGC,
C     & DTMUW(NX,NY,NZ)
C      COMMON /ADSORB/ AA(5),BB(5),CL(5),GAMA(5),RF(NX,NY,NZ),RFT
      COMMON /MEORB/ C(NX,NY,NZC),SIGMA(NX,NY,NZ),RF(NX,NY,NZ),AKC,
     & AKD,AKY,AKS,AMUM,YIELD,RHOMIC,CQI(NW,NC),MAPWI(NX,NY,NZ),RFT
      COMMON /ADD1/ IM,JM,KM,ETI,FT,FTMAX
      COMMON /ADD2/ COP,CWP,CGP,CWI,CGI,CPOI,PVWI,POIR
      DATA NI,NO/5,6/
      DATA TX,TY,TZ/NXPYZ*0.0,NXYPZ*0.0,NXYZP*0.0/
      DATA CUMO,CUMW,CUMG/NWZ*0.0,NWZ*0.0,NWZ*0.0/
      DATA AW,AS,AT/MAX*0.0,MAX*0.0,MAX*0.0/
      DATA AE,AN,AB/MAX*0.0,MAX*0.0,MAX*0.0/
      DATA OW,OE,WW,WE/NXPYZ*0.0,NXPYZ*0.0,NXPYZ*0.0,NXPYZ*0.0/
      DATA OS,ON,WS,WN/NXYPZ*0.0,NXYPZ*0.0,NXYPZ*0.0,NXYPZ*0.0/
      DATA OT,OB,WT,WB/NXYZP*0.0,NXYZP*0.0,NXYZP*0.0,NXYZP*0.0/
      DATA IM,JM,KM,ETI,FT,FTMAX/NX,NY,NZ,0.0,0.0,0.0/
      DATA COP,CWP,CGP,CWI,CPOI,CGI/0.0,0.0,0.0,0.0,0.0,0.0/
      DATA SIGMA,RF/MAX*0.0,MAX*1.0/
      END
C
      
      BLOCK DATA FILNAM
C
C============================================BLOCK DATA FILNAM
C
C    CHARACTER VARIABLE INITIALIZATION FOR GRAPHICS.
C
C=============================================================
C
      INCLUDE 'MEOR.PAR' 
      CHARACTER*2 FNAME,MNAME,TAG
      CHARACTER*4 LNAME
      COMMON /CHRCTR/ FNAME,MNAME(NUM),LNAME,TAG
      COMMON /TTEST/ NUMPRD,SONTVL
      COMMON /IO2/ NO2
      DATA NO2/7/
      DATA NUMPRD/1/
      DATA FNAME,LNAME/'SO','.DAT'/
      DATA MNAME/'01','02','03','04','05','06','07','08','09',
     & '10','11','12','13','14','15','16','17','18','19','20',
     & '21','22','23','24','25','26','27','28','29','30','31',
     & '32','33','34','35','36','37','38','39','40'/
      END
C
C
C
      SUBROUTINE INTPVT(BPT,RM,X,Y,N,XO,YO)
C
C=================================================================INTPVT
C
C   PERFORM LINEAR INTERPOLATION WITH FLOATING BUBBLE POINT CALCULATION
C   OF UNDERSATURATED OIL PVT PROPERTIES.
C
C=======================================================================
C
      INCLUDE 'MEOR.PAR' 
      DIMENSION X(NTE),Y(NTE)
      IF(XO.GT.BPT)GO TO 100
      IF(XO.GE.X(N))YO=Y(N)
      IF(XO.GE.X(N))RETURN
      DO 10 I=2,N
      IF(XO.GE.X(I))GO TO 10
      YO=Y(I-1)+(XO-X(I-1))*(Y(I)-Y(I-1))/(X(I)-X(I-1))
      RETURN
   10 CONTINUE
  100 CONTINUE
      DO 200 I=2,N
      IF(BPT.GE.X(I))GO TO 200
      YOBP=Y(I-1)+(BPT-X(I-1))*(Y(I)-Y(I-1))/(X(I)-X(I-1))
      YO=YOBP+RM*(XO-BPT)
      RETURN
  200 CONTINUE
      END
C
C
C
      SUBROUTINE INTERP(X,Y,N,XO,YO)
C
C=================================================================INTERP
C
C   PERFORM LINEAR INTERPOLATION.
C
C=======================================================================
C
      INCLUDE 'MEOR.PAR' 
      DIMENSION X(NTE),Y(NTE)
      IF(XO.GE.X(N)) YO=Y(N)
      IF(XO.GE.X(N)) RETURN
      DO 10 I=2,N
      IF(XO.GE.X(I)) GO TO 10
      YO=Y(I-1) +(XO-X(I-1))*(Y(I)-Y(I-1))/(X(I)-X(I-1))
      RETURN
  10  CONTINUE
      END
C
      SUBROUTINE GRID1
C
C==================================================================GRID1
C
C   READ GRID BLOCK SIZES AND COMPUTE NODE ELEVATIONS
C
C=======================================================================
C
      INCLUDE 'MEOR.PAR' 
      CHARACTER*2 TITLE(80)
      COMMON /IO/ NI,NO
      COMMON /NUMBER/ II,JJ,KK
      COMMON /ELEV/ EL(NX,NY,NZ)
      COMMON /VECTOR/ DX(NX,NY,NZ),DY(NX,NY,NZ),DZ(NX,NY,NZ)
      COMMON /SWTCH/ NGRSW,NTRSW,NRESTART,NGEL
      COMMON /COUNT/ N1READ,N2READ
      DIMENSION SUM(NX,NY),VAREL(NX,NY),RDXL(NX),RDYL(NY),RDZL(NZ)
      READ(NI,69) (TITLE(IH),IH=1,40)
      N1READ=N1READ+1
      WRITE(NO,70) (TITLE(IH),IH=1,40)
      WRITE(14,69) (TITLE(IH),IH=1,40)
      WRITE(14,2999)
      WRITE(14,3003)
      WRITE(14,3001)
      WRITE(14,3002)
 2999 FORMAT('   NIPER : MICROBIAL TRANSPORT SIMULATOR',
     & //,'   SUMMARY REPORT',/)
 3003 FORMAT('                AVE     OIL       CUM     GAS
     &      CUM      OIL    WATER     CUM      W-O    WATER
     &     WATER')
 3001 FORMAT('  N     TIME   PRES.    RATE      OIL    RATE
     &      GAS      REC     RATE    WATER    RATIO    INJ 
     &      INJ')
 3002 FORMAT('       (DAY)   (PSI)   (B/D)     (BBL)  (MCF/D)
     &   (MCF)  (OOIP)    (B/D)    (BBL)    (B/B)   (PV)   
     &   (B/D)',/)
      READ(NI,*) II,JJ,KK
      N1READ=N1READ+1
      READ(NI,69) (TITLE(IH),IH=1,40)
      N1READ=N1READ+1
      READ(NI,*) NGRSW,NTRSW,NRESTART,NGEL
      N1READ=N1READ+1
      IF(NGRSW.EQ.1) CALL GRINT
      READ(NI,69) (TITLE(IH),IH=1,40)
      N1READ=N1READ+1
C
C*****READ INPUT CODES FOR DX,DY,DZ
C
      READ(NI,*)KDX,KDY,KDZ
      N1READ=N1READ+1
C
C*****ESTABLISH GRID BLOCK LENGTH (DX) DISTRIBUTION
C
      IF(KDX.GE.0)GO TO 180
      READ(NI,*)DXC
      N1READ=N1READ+1
      DO 175 K=1,KK
      DO 175 J=1,JJ
      DO 175 I=1,II
175   DX(I,J,K)=DXC
      WRITE(NO,56)
      WRITE(NO,29)DXC
      GO TO 195
  180 IF(KDX.GT.0)GO TO 185
      READ(NI,*)(RDXL(I),I=1,II)
      N1READ=N1READ+1+INT(II/10)
      IF(MOD(II,10).EQ.0)N1READ=N1READ-1
C 998  format(10f8.1)
      DO 187 K=1,KK
      DO 187 J=1,JJ
      DO 187 I=1,II
  187 DX(I,J,K)=RDXL(I)
      DO 182 I=1,II
  182 WRITE(NO,511)I,RDXL(I)
      GO TO 195
185   WRITE(NO,43)
      K=1
      WRITE(NO,38)K
      DO 190 J=1,JJ
      READ(NI,*)  (DX(I,J,K),I=1,II)
      N1READ=N1READ+1+INT(II/10)
      IF(MOD(II,10).EQ.0)N1READ=N1READ-1
  190 WRITE(NO,72)(DX(I,J,K),I=1,II)
      DO 194 K=2,KK
      WRITE(NO,38) K
      DO 194 J=1,JJ
      DO 193 I=1,II
  193 DX(I,J,K)=DX(I,J,1)
  194 WRITE(NO,72) (DX(I,J,K),I=1,II)
195   CONTINUE
      WRITE(NO,56)
C
C*****ESTABLISH GRID BLOCK LENGTH (DY) DISTRIBUTION
C
      IF(KDY.GE.0)GO TO 200
      READ(NI,*)DYC
      N1READ=N1READ+1
      DO 202 K=1,KK
      DO 202 J=1,JJ
      DO 202 I=1,II
202   DY(I,J,K)=DYC
      WRITE(NO,56)
      WRITE(NO,33)DYC
      GO TO 220
  200 IF(KDY.GT.0)GO TO 207
      READ(NI,*)(RDYL(J),J=1,JJ)
      N1READ=N1READ+1+INT(JJ/10)
      IF(MOD(JJ,10).EQ.0)N1READ=N1READ-1
      DO 205 K=1,KK
      DO 205 J=1,JJ
      DO 205 I=1,II
  205 DY(I,J,K)=RDYL(J)
      DO 210 J=1,JJ
  210 WRITE(NO,512)J,RDYL(J)
      GO TO 220
207   WRITE(NO,47)
      K=1
      WRITE(NO,38)K
      DO 215 I=1,II
      READ(NI,*)(DY(I,J,K),J=1,JJ)
      N1READ=N1READ+1+INT(JJ/10)
      IF(MOD(JJ,10).EQ.0)N1READ=N1READ-1
  215 WRITE(NO,72)(DY(I,J,K),J=1,JJ)
      DO 214 K=2,KK
      WRITE(NO,38) K
      DO 214 J=1,JJ
      DO 213 I=1,II
  213 DY(I,J,K)=DY(I,J,1)
  214 WRITE(NO,72) (DY(I,J,K),I=1,II)
220   CONTINUE
      WRITE(NO,56)
C
C*****ESTABLISH GRID BLOCK LENGTH (DZ) DISTRIBUTION
C
      IF(KDZ.GE.0)GO TO 225
      READ(NI,*)DZC
      N1READ=N1READ+1
      DO 230 K=1,KK
      DO 230 J=1,JJ
      DO 230 I=1,II
230   DZ(I,J,K)=DZC
      WRITE(NO,56)
      WRITE(NO,36)DZC
      GO TO 245
  225 IF(KDZ.GT.0)GO TO 232
      READ(NI,*)(RDZL(K),K=1,KK)
      N1READ=N1READ+1+INT(KK/10)
      IF(MOD(KK,10).EQ.0)N1READ=N1READ-1
      DO 235 K=1,KK
      DO 235 J=1,JJ
      DO 235 I=1,II
  235 DZ(I,J,K)=RDZL(K)
      DO 237 K=1,KK
  237 WRITE(NO,513)K,RDZL(K)
      GO TO 245
232   WRITE(NO,48)
      DO 240 K=1,KK
      WRITE(NO,38)K
      DO 242 J=1,JJ
      READ(NI,*)(DZ(I,J,K),I=1,II)
      N1READ=N1READ+1+INT(KK/10)
      IF(MOD(KK,10).EQ.0)N1READ=N1READ-1
  242 WRITE(NO,72)(DZ(I,J,K),I=1,II)
240   CONTINUE
245   CONTINUE
      WRITE(NO,56)
C
C********GRID BLOCK LENGTH MODIFICATIONS
C
      READ(NI,69) (TITLE(IH),IH=1,40)
      N1READ=N1READ+1
      READ(NI,*) NUMDX,NUMDY,NUMDZ,IDCODE
      N1READ=N1READ+1
      IF(NUMDX.EQ.0) GO TO 8530
      WRITE(NO,31)
      DO 275 L=1,NUMDX
      READ(NI,*)I,J,K,DX(I,J,K)
      N1READ=N1READ+1
  275 WRITE(NO,32)I,J,K,DX(I,J,K)
      IF(IDCODE.NE.1)GO TO 8530
      WRITE(NO,43)
      DO 853 K=1,KK
      WRITE(NO,38)K
      DO 854 J=1,JJ
  854 WRITE(NO,72)(DX(I,J,K),I=1,II)
853   CONTINUE
8530  CONTINUE
      IF(NUMDY.EQ.0) GO TO 8550
      WRITE(NO,34)
      DO 276 L=1,NUMDY
      READ(NI,*)I,J,K,DY(I,J,K)
      N1READ=N1READ+1
  276 WRITE(NO,32)I,J,K,DY(I,J,K)
      IF(IDCODE.NE.1) GO TO 8550
      WRITE(NO,47)
      DO 855 K=1,KK
      WRITE(NO,38)K
      DO 856 J=1,JJ
  856 WRITE(NO,72)(DY(I,J,K),I=1,II)
855   CONTINUE
8550  CONTINUE
      IF(NUMDZ.EQ.0) GO TO 8570
      WRITE(NO,37)
      DO 277 L=1,NUMDZ
      READ(NI,*)I,J,K,DZ(I,J,K)
      N1READ=N1READ+1
  277 WRITE(NO,32)I,J,K,DZ(I,J,K)
      IF(IDCODE.NE.1) GO TO 8570
      WRITE(NO,48)
      DO 857 K=1,KK
      WRITE(NO,38)K
      DO 858 J=1,JJ
  858 WRITE(NO,72)(DZ(I,J,K),I=1,II)
857   CONTINUE
8570  CONTINUE
C
C*****ESTABLISH NODE MID-POINT ELEVATION.
C
      READ(NI,69) (TITLE(IH),IH=1,40)
      N1READ=N1READ+1
      READ(NI,*)KEL
      N1READ=N1READ+1
      IF(KEL.EQ.1)GO TO 920
      READ(NI,*)ELEV
      N1READ=N1READ+1
      DO 910 J=1,JJ
      DO 910 I=1,II
  910 VAREL(I,J)=ELEV
  920 IF(KEL.NE.1)GO TO 930
      DO 922 J=1,JJ
      READ(NI,*)(VAREL(I,J),I=1,II)
      N1READ=N1READ+1+INT(II/10)
      IF(MOD(II,10).EQ.0)N1READ=N1READ-1
  922 CONTINUE
  930 CONTINUE
      DO 923 I=1,II
      DO 923 J=1,JJ
  923 SUM(I,J)=0.
      DO 926 K=1,KK
      DO 926 J=1,JJ
      DO 926 I=1,II
      DEL=SUM(I,J)+DZ(I,J,K)*0.5
      EL(I,J,K)=VAREL(I,J)+DEL
  926 SUM(I,J)=DZ(I,J,K)+SUM(I,J)
      WRITE(NO,390)
      DO 600 K=1,KK
      WRITE(NO,38)K
      DO 600 J=1,JJ
      WRITE(NO,72)(EL(I,J,K),I=1,II)
600   CONTINUE
69    FORMAT(40A2)
56    FORMAT(//)
70    FORMAT(T24,82('*'),/,T24,('*'),T105,('*'),/,
     & T24,('*'),40A2,T105,('*'),/,T24,('*'),T105,
     & ('*'),/,T24,82('*'),//)
72    FORMAT(1X,20F6.0)
29    FORMAT(T15,'GRID BLOCK LENGTH (DX) IS INITIALLY',
     &' SET AT',F10.4,' FOR ALL NODES'//)
31    FORMAT(//T15,'********GRID BLOCK LENGTH (DX) NODE MODIFICATIONS',
     &'**********',//T15,'     I    J    K         NEW DX VALUE')
32    FORMAT(15X,3I5,5X,F14.4)
33    FORMAT(T15,'GRID BLOCK WIDTH  (DY) IS INITIALLY',
     &' SET AT',F10.4,' FOR ALL NODES'//)
34    FORMAT(//T15,'********GRID BLOCK WIDTH  (DY) NODE MODIFICATIONS',
     &'**********',//T15,'     I    J    K         NEW DY VALUE')
36    FORMAT(T15,'GRID BLOCK DEPTH  (DZ) IS INITIALLY',
     &' SET AT',F10.4,' FOR ALL NODES'//)
37    FORMAT(//T15,'********GRID BLOCK DEPTH  (DZ) NODE MODIFICATIONS',
     &'**********',//T15,'     I    J    K         NEW DZ VALUE')
38    FORMAT(/1X,'K =',I2/)
390   FORMAT(//T15,'********** NODE MIDPOINT ELEVATIONS **********'/)
43    FORMAT(//T15,'********GRID BLOCK LENGTH (DX) DISTRIBUTION********'
     &/)
47    FORMAT(//T15,'********GRID BLOCK WIDTH  (DY) DISTRIBUTION********'
     &/)
48    FORMAT(//T15,'********GRID BLOCK DEPTH  (DZ) DISTRIBUTION********'
     &/)
  511 FORMAT(T15,'GRID SIZE (DX) IN COLUMN',I5,' IS INITIALLY SET AT'
     &,F8.2,' FOR ALL NODES',/)
  512 FORMAT(T15,'GRID SIZE (DY) IN ROW   ',I5,' IS INITIALLY SET AT'
     &,F8.2,' FOR ALL NODES',/)
  513 FORMAT(T15,'GRID SIZE (DZ) IN LAYER ',I5,' IS INITIALLY SET AT'
     &,F8.2,' FOR ALL NODES',/)
      RETURN
      END
      SUBROUTINE PARM1
C
C==================================================================PARM1
C
C   READ POROSITY AND PERMEABILITY ARRAYS.
C
C       When KKX = -1, a single Kx is read for all grid blocks
C            KKX =  0, a constant Kx is read for each of KK layers
C            KKX =  1, a seperate Kx is read for each II x JJ x KK grid block
C            KKX =  2, a constant Kx is read for each II x KK grid block
C       The same rule is applied to KKY and KKZ
C
C=======================================================================
C
      INCLUDE 'MEOR.PAR' 
      REAL KX,KY,KZ,KXC,KYC,KZC
      CHARACTER*2 TITLE(80)
      COMMON /IO/ NI,NO
      COMMON /NUMBER/ II,JJ,KK
      COMMON /PORE/ VP(NX,NY,NZ),POR(NX,NY,NZ),PV
      COMMON /VECTOR/ DX(NX,NY,NZ),DY(NX,NY,NZ),DZ(NX,NY,NZ)
      COMMON /PERM/ KX(NX,NY,NZ),KY(NX,NY,NZ),KZ(NX,NY,NZ)
      COMMON /COUNT/ N1READ,N2READ
      DIMENSION RPHL(NZ),RKXL(NZ),RKYL(NZ),RKZL(NZ)
      DIMENSION XKX(NX),YKX(NX),ZKX(NX)
      READ(NI,69) (TITLE(IH),IH=1,40)
      N1READ=N1READ+1
C
C*****READ INPUT CODES FOR PHI,KX,KY,KZ
C
      READ(NI,*)KPH,KKX,KKY,KKZ
      N1READ=N1READ+1
C
C*****ESTABLISH POROSITY (PHI) DISTRIBUTION
C
      PV=0.0
      IF(KPH.GE.0)GO TO 135
      READ(NI,*)PHIC
      N1READ=N1READ+1
      DO 140 K=1,KK
      DO 140 J=1,JJ
      DO 140 I=1,II
140   VP(I,J,K)=PHIC
      WRITE(NO,56)
      WRITE(NO,26)PHIC
      GO TO 165
  135 IF(KPH.GT.0)GO TO 145
      READ(NI,*)(RPHL(K),K=1,KK)
      N1READ=N1READ+1+INT(KK/10)
      IF(MOD(KK,10).EQ.0)N1READ=N1READ-1
      DO 550 K=1,KK
      DO 550 J=1,JJ
      DO 550 I=1,II
  550 VP(I,J,K)=RPHL(K)
      DO 560 K=1,KK
  560 WRITE(NO,510)K,RPHL(K)
      GO TO 165
145   WRITE(NO,39)
      DO 160 K=1,KK
      WRITE(NO,38)K
      DO 155 J=1,JJ
      READ(NI,*)(VP(I,J,K),I=1,II)
      N1READ=N1READ+1+INT(II/10)
      IF(MOD(II,10).EQ.0)N1READ=N1READ-1
  155 WRITE(NO,73)(VP(I,J,K),I=1,II)
160   CONTINUE
165   DO 170 K=1,KK
      DO 170 J=1,JJ
      DO 170 I=1,II
      PV=PV+VP(I,J,K)*DX(I,J,K)*DY(I,J,K)*DZ(I,J,K)
170   POR(I,J,K)=VP(I,J,K)
      WRITE(NO,56)
C
C*****ESTABLISH PERMEABILITY (KX) DISTRIBUTION
C
      IF(KKX.GE.0)GO TO 180
C *** A single constant Kx is read for all grid blocks  
      READ(NI,*)KXC
      N1READ=N1READ+1
      DO 175 K=1,KK
      DO 175 J=1,JJ
      DO 175 I=1,II
175   KX(I,J,K)=KXC
      WRITE(NO,56)
      WRITE(NO,29)KXC
      GO TO 195
C *** a constant value Kx is read for each of the KK layers
  180 IF(KKX.GT.0)GO TO 185
      READ(NI,*)(RKXL(K),K=1,KK)
      N1READ=N1READ+1+INT(KK/10)
      IF(MOD(KK,10).EQ.0)N1READ=N1READ-1
      DO 187 K=1,KK
      DO 187 J=1,JJ
      DO 187 I=1,II
  187 KX(I,J,K)=RKXL(K)
      DO 182 K=1,KK
  182 WRITE(NO,511)K,RKXL(K)
      GO TO 195
C *** a sperate Kx value is read for each (II x JJ x KK) grid block
185   IF(KKX.GT.1)GO TO 193
      WRITE(NO,43)
      DO 192 K=1,KK
      WRITE(NO,38)K
      DO 190 J=1,JJ
      READ(NI,*)(KX(I,J,K),I=1,II)
      N1READ=N1READ+1+INT(II/10)
      IF(MOD(II,10).EQ.0)N1READ=N1READ-1
  190 WRITE(NO,72)(KX(I,J,K),I=1,II)
192   CONTINUE
      GO TO 195
C *** a Kx value is read for each (II) column and each (KK) layer : (II x KK)
193   WRITE(NO,43)
      DO 194 K=1,KK
      WRITE(NO,38)K
      READ(NI,*)(XKX(I),I=1,II)
      N1READ=N1READ+1+INT(II/10)
      IF(MOD(II,10).EQ.0)N1READ=N1READ-1
      DO 196 J=1,JJ
      DO 197 I=1,II
  197  KX(I,J,K)=XKX(I)
  196 WRITE(NO,72)(KX(I,J,K),I=1,II)
194   CONTINUE
195   CONTINUE
      WRITE(NO,56)
C
C*****ESTABLISH PERMEABILITY (KY) DISTRIBUTION
C
      IF(KKY.GE.0)GO TO 200
      READ(NI,*)KYC
      N1READ=N1READ+1
      DO 202 K=1,KK
      DO 202 J=1,JJ
      DO 202 I=1,II
202   KY(I,J,K)=KYC
      WRITE(NO,56)
      WRITE(NO,33)KYC
      GO TO 220
  200 IF(KKY.GT.0)GO TO 207
      READ(NI,*)(RKYL(K),K=1,KK)
      N1READ=N1READ+1+INT(KK/10)
      IF(MOD(KK,10).EQ.0)N1READ=N1READ-1
      DO 205 K=1,KK
      DO 205 J=1,JJ
      DO 205 I=1,II
  205 KY(I,J,K)=RKYL(K)
      DO 210 K=1,KK
  210 WRITE(NO,512)K,RKYL(K)
      GO TO 220
 207  IF(KKY.GT.1)GO TO 216
      WRITE(NO,47)
      DO 212 K=1,KK
      WRITE(NO,38)K
      DO 215 J=1,JJ
      READ(NI,*)(KY(I,J,K),I=1,II)
      N1READ=N1READ+1+INT(II/10)
      IF(MOD(II,10).EQ.0)N1READ=N1READ-1
  215 WRITE(NO,72)(KY(I,J,K),I=1,II)
212   CONTINUE
      GO TO 220
C *** a Ky value is read for each (II) column and each (KK) layer : (II x KK)
216   WRITE(NO,47)
      DO 217 K=1,KK
      WRITE(NO,38)K
      READ(NI,*)(YKX(I),I=1,II)
      N1READ=N1READ+1+INT(II/10)
      IF(MOD(II,10).EQ.0)N1READ=N1READ-1
      DO 218 J=1,JJ
      DO 219 I=1,II
  219  KY(I,J,K)=YKX(I)
  218 WRITE(NO,72)(KY(I,J,K),I=1,II)
217   CONTINUE
220   CONTINUE
      WRITE(NO,56)
C
C*****ESTABLISH PERMEABILITY (KZ) DISTRIBUTION
C
      IF(KKZ.GE.0)GO TO 225
      READ(NI,*)KZC
      N1READ=N1READ+1
      DO 230 K=1,KK
      DO 230 J=1,JJ
      DO 230 I=1,II
230   KZ(I,J,K)=KZC
      WRITE(NO,56)
      WRITE(NO,36)KZC
      GO TO 245
  225 IF(KKZ.GT.0)GO TO 232
      READ(NI,*)(RKZL(K),K=1,KK)
      N1READ=N1READ+1+INT(KK/10)
      IF(MOD(KK,10).EQ.0)N1READ=N1READ-1
      DO 235 K=1,KK
      DO 235 J=1,JJ
      DO 235 I=1,II
  235 KZ(I,J,K)=RKZL(K)
      DO 237 K=1,KK
  237 WRITE(NO,513)K,RKZL(K)
      GO TO 245
 232  IF(KKZ.GT.1)GO TO 243
      WRITE(NO,48)
      DO 240 K=1,KK
      WRITE(NO,38)K
      DO 242 J=1,JJ
      READ(NI,*)(KZ(I,J,K),I=1,II)
      N1READ=N1READ+1+INT(II/10)
      IF(MOD(II,10).EQ.0)N1READ=N1READ-1
  242 WRITE(NO,72)(KZ(I,J,K),I=1,II)
240   CONTINUE
      GO TO 245
C *** a Kz value is read for each (II) column and each (KK) layer : (II x KK)
243   WRITE(NO,48)
      DO 244 K=1,KK
      WRITE(NO,38)K
      READ(NI,*)(ZKX(I),I=1,II)
      N1READ=N1READ+1+INT(II/10)
      IF(MOD(II,10).EQ.0)N1READ=N1READ-1
      DO 246 J=1,JJ
      DO 247 I=1,II
  247  KZ(I,J,K)=ZKX(I)
  246 WRITE(NO,72)(KZ(I,J,K),I=1,II)
244   CONTINUE
245   CONTINUE
      WRITE(NO,56)
C
C**********POROSITY AND PERMEABILITY MODIFICATIONS
C
      READ(NI,69) (TITLE(IH),IH=1,40)
      N1READ=N1READ+1
      READ(NI,*) NUMP,NUMKX,NUMKY,NUMKZ,IPCODE
      N1READ=N1READ+1
      IF(NUMP.EQ.0) GO TO 8510
      WRITE(NO,27)
      DO 274 L=1,NUMP
      READ(NI,*)I,J,K,VP(I,J,K)
      N1READ=N1READ+1
  274 WRITE(NO,32)I,J,K,VP(I,J,K)
      IF(IPCODE.NE.1) GO TO 8510
      WRITE(NO,39)
      DO 851 K=1,KK
      WRITE(NO,38)K
      DO 852 J=1,JJ
  852 WRITE(NO,73)(VP(I,J,K),I=1,II)
  851 CONTINUE
8510  CONTINUE
      IF(NUMKX.EQ.0) GO TO 8530
      WRITE(NO,31)
      DO 275 L=1,NUMKX
      READ(NI,*)I,J,K,KX(I,J,K)
      N1READ=N1READ+1
  275 WRITE(NO,32)I,J,K,KX(I,J,K)
      IF(IPCODE.NE.1)GO TO 8530
      WRITE(NO,43)
      DO 853 K=1,KK
      WRITE(NO,38)K
      DO 854 J=1,JJ
  854 WRITE(NO,72)(KX(I,J,K),I=1,II)
853   CONTINUE
8530  CONTINUE
      IF(NUMKY.EQ.0) GO TO 8550
      WRITE(NO,34)
      DO 276 L=1,NUMKY
      READ(NI,*)I,J,K,KY(I,J,K)
      N1READ=N1READ+1
  276 WRITE(NO,32)I,J,K,KY(I,J,K)
      IF(IPCODE.NE.1) GO TO 8550
      WRITE(NO,47)
      DO 855 K=1,KK
      WRITE(NO,38)K
      DO 856 J=1,JJ
  856 WRITE(NO,72)(KY(I,J,K),I=1,II)
855   CONTINUE
8550  CONTINUE
      IF(NUMKZ.EQ.0) GO TO 8570
      WRITE(NO,37)
      DO 277 L=1,NUMKZ
      READ(NI,*)I,J,K,KZ(I,J,K)
      N1READ=N1READ+1
  277 WRITE(NO,32)I,J,K,KZ(I,J,K)
      IF(IPCODE.NE.1) GO TO 8570
      WRITE(NO,48)
      DO 857 K=1,KK
      WRITE(NO,38)K
      DO 858 J=1,JJ
  858 WRITE(NO,72)(KZ(I,J,K),I=1,II)
857   CONTINUE
8570  CONTINUE
C
69    FORMAT(40A2)
56    FORMAT(//)
72    FORMAT(1X,20F6.2)
73    FORMAT(1X,20F6.4)
26    FORMAT(T15,'POROSITY (PHI) IS INITIALLY SET AT',F8.4,' FOR ALL',
     &' NODES'//)
27    FORMAT(//T15,'**********POROSITY NODE MODIFICATIONS**********',
     &//T15,'     I    J    K         NEW PHI VALUE')
29    FORMAT(T15,'PERMEABILITY (KX) IS INITIALLY',
     &' SET AT',F10.4,' FOR ALL NODES'//)
31    FORMAT(//T15,'**********PERMEABILITY (KX) NODE MODIFICATIONS',
     &'**********',//T15,'     I    J    K         NEW KX VALUE')
32    FORMAT(15X,3I5,5X,F14.4)
33    FORMAT(T15,'PERMEABILITY (KY) IS INITIALLY',
     &' SET AT',F10.4,' FOR ALL NODES'//)
34    FORMAT(//T15,'**********PERMEABILITY (KY) NODE MODIFICATIONS',
     &'**********',//T15,'     I    J    K         NEW KY VALUE')
36    FORMAT(T15,'PERMEABILITY (KZ) IS INITIALLY',
     &' SET AT',F10.4,' FOR ALL NODES'//)
37    FORMAT(//T15,'**********PERMEABILITY (KZ) NODE MODIFICATIONS',
     &'**********',//T15,'     I    J    K         NEW KZ VALUE')
38    FORMAT(/1X,'K =',I2/)
39    FORMAT(//T15,'**********POROSITY DISTRIBUTION FOLLOWS**********'/)
390   FORMAT(//T15,'********** NODE MIDPOINT ELEVATIONS **********'/)
43    FORMAT(//T15,'**********PERMEABILITY (KX) DISTRIBUTION**********'
     &/)
445   FORMAT(13F10.2)
47    FORMAT(//T15,'**********PERMEABILITY (KY) DISTRIBUTION**********'
     &/)
48    FORMAT(//T15,'**********PERMEABILITY (KZ) DISTRIBUTION**********'
     &/)
510   FORMAT(//T15,'POROSITY IN LAYER',I5,' IS INITIALLY SET AT',F8.5,
     &' FOR ALL NODES',/)
511   FORMAT(T15,'PERMEABILITY (KX) IN LAYER',I5,' IS INITIALLY SET AT'
     &,F8.2,' FOR ALL NODES',/)
512   FORMAT(T15,'PERMEABILITY (KY) IN LAYER',I5,' IS INITIALLY SET AT'
     &,F8.2,' FOR ALL NODES',/)
513   FORMAT(T15,'PERMEABILITY (KZ) IN LAYER',I5,' IS INITIALLY SET AT'
     &,F8.2,' FOR ALL NODES',/)
      RETURN
      END
      SUBROUTINE TRAN1
C
C==================================================================TRAN1
C
C   COMPUTE GEOMETRIC PART OF TRANSMISSIBILITIES.
C
C======================================================================
C
      INCLUDE 'MEOR.PAR' 
      CHARACTER*2 TITLE(80)
      COMMON /IO/ NI,NO
      COMMON /NUMBER/ II,JJ,KK
      COMMON /SARRAY/ PN(NX,NY,NZ),
     & SON(NX,NY,NZ),SWN(NX,NY,NZ),SGN(NX,NY,NZ),
     & SO1(NX,NY,NZ),SW1(NX,NY,NZ),SG1(NX,NY,NZ),
     & A1(NX,NY,NZ),A2(NX,NY,NZ),A3(NX,NY,NZ),
     & SUM(NX,NY,NZ),GAM(NX,NY,NZ),QS(NX,NY,NZ)
      COMMON /PERM/ KX(NX,NY,NZ),KY(NX,NY,NZ),KZ(NX,NY,NZ)
      COMMON /TRAN/ TX(NX+1,NY,NZ),TY(NX,NY+1,NZ),TZ(NX,NY,NZ+1)
      COMMON /VECTOR/ DX(NX,NY,NZ),DY(NX,NY,NZ),DZ(NX,NY,NZ)
      COMMON /CODE/ KSM1,KSN1,KCO1,NN,FACT1,FACT2,TMAX,KSOL,MITER,
     & OMEGA,TOL,TOL1,KSN,KSM,KCO,KTR,KCOFF,DSMAX,DPMAX,WORMAX,
     & GORMAX,PAMIN,PAMAX
C      COMMON /ADSORB/ AA(5),BB(5),CL(5),GAMA(5),RF(NX,NY,NZ),RFT
      COMMON /SWTCH/ NGRSW,NTRSW,NRESTART,NGEL
      COMMON /COUNT/ N1READ,N2READ

      COMMON /MEORB/ C(NX,NY,NZC),SIGMA(NX,NY,NZ),RF(NX,NY,NZ),AKC,
     & AKD,AKY,AKS,AMUM,YIELD,RHOMIC,CQI(NW,NC),MAPWI(NX,NY,NZ),RFT
C
      REAL KX,KY,KZ
      DO 30 K=1,KK
      DO 30 J=1,JJ
      DO 30 I=1,II
      FACX=1.0
      FACY=1.0
      FACZ=1.0
      IF(I.GT.1.AND.I.LT.II)
     & FACX=4.*DX(I,J,K)/(2.*DX(I,J,K)+DX(I+1,J,K)+DX(I-1,J,K))
      IF(J.GT.1.AND.J.LT.JJ)
     & FACY=4.*DY(I,J,K)/(2.*DY(I,J,K)+DY(I,J+1,K)+DY(I,J-1,K))
      IF(K.GT.1.AND.K.LT.KK)
     & FACZ=4.*DZ(I,J,K)/(2.*DZ(I,J,K)+DZ(I,J,K+1)+DZ(I,J,K-1))
C
      A1(I,J,K)=FACX*KX(I,J,K)*DY(I,J,K)*DZ(I,J,K)
      A2(I,J,K)=FACY*KY(I,J,K)*DX(I,J,K)*DZ(I,J,K)
      A3(I,J,K)=FACZ*KZ(I,J,K)*DX(I,J,K)*DY(I,J,K)
C------------------------------------------------------------------------
C **** Reduce Permeability Caused by Adsorption (RF is Resistance Factor)
      IF(RF(I,J,K).GT.1.)THEN
       A1(I,J,K)=A1(I,J,K)/RF(I,J,K)
       A2(I,J,K)=A2(I,J,K)/RF(I,J,K)
       A3(I,J,K)=A3(I,J,K)/RF(I,J,K)
      ENDIF
C------------------------------------------------------------------------
   30 CONTINUE
      IF(II.EQ.1)GO TO 501
      DO 50 K=1,KK
      DO 50 J=1,JJ
      DO 50 I=2,II
      TX(I,J,K)=.012656*A1(I-1,J,K)*A1(I,J,K)/(DX(I-1,J,K)*A1(I,J,K)
     &+DX(I,J,K)*A1(I-1,J,K))
   50 CONTINUE
  501 CONTINUE
      IF(JJ.EQ.1)GO TO 551
      DO 55 K=1,KK
      DO 55 J=2,JJ
      DO 55 I=1,II
      TY(I,J,K)=.012656*A2(I,J-1,K)*A2(I,J,K)/(DY(I,J-1,K)*A2(I,J,K)
     &+DY(I,J,K)*A2(I,J-1,K))
   55 CONTINUE
  551 CONTINUE
      IF(KK.EQ.1)GO TO 600
      DO 60 K=2,KK
      DO 60 J=1,JJ
      DO 60 I=1,II
      TZ(I,J,K)=.012656*A3(I,J,K-1)*A3(I,J,K)/(DZ(I,J,K-1)*A3(I,J,K)
     &+DZ(I,J,K)*A3(I,J,K-1))
   60 CONTINUE
600   CONTINUE
C
      IF(RFT.GT.1.)RETURN
C
C****** TRANSMISSIBILITY MODIFICATIONS
C
      IF(NTRSW.EQ.1) CALL SHALE
      READ(NI,69) (TITLE(IH),IH=1,40)
      N1READ=N1READ+1
      READ(NI,*) NUMTX,NUMTY,NUMTZ,ITCODE
      N1READ=N1READ+1
      IF(NUMTX.EQ.0) GO TO 100
      WRITE(NO,31)
      DO 275 L=1,NUMTX
      READ(NI,*)I,J,K,TX(I,J,K)
      N1READ=N1READ+1
  275 WRITE(NO,32)I,J,K,TX(I,J,K)
  100 IF(ITCODE.NE.1)GO TO 8530
      WRITE(NO,44)
      DO 853 K=1,KK
      WRITE(NO,38)K
      DO 854 J=1,JJ
  854 WRITE(NO,72)(TX(I,J,K),I=1,II)
  853 CONTINUE
8530  CONTINUE
      IF(NUMTY.EQ.0) GO TO 110
      WRITE(NO,34)
      DO 276 L=1,NUMTY
      READ(NI,*)I,J,K,TY(I,J,K)
      N1READ=N1READ+1
  276 WRITE(NO,32)I,J,K,TY(I,J,K)
  110 IF(ITCODE.NE.1) GO TO 8550
      WRITE(NO,47)
      DO 855 K=1,KK
      WRITE(NO,38)K
      DO 856 J=1,JJ
  856 WRITE(NO,72)(TY(I,J,K),I=1,II)
  855 CONTINUE
8550  CONTINUE
      IF(NUMTZ.EQ.0) GO TO 120
      WRITE(NO,37)
      DO 277 L=1,NUMTZ
      READ(NI,*)I,J,K,TZ(I,J,K)
      N1READ=N1READ+1
  277 WRITE(NO,32)I,J,K,TZ(I,J,K)
  120 IF(ITCODE.NE.1) GO TO 8570
      WRITE(NO,48)
      DO 857 K=1,KK
      WRITE(NO,38)K
      DO 858 J=1,JJ
  858 WRITE(NO,72)(TZ(I,J,K),I=1,II)
  857 CONTINUE
8570  CONTINUE
C
      IF(KTR.EQ.0)RETURN
C
      WRITE(NO,43)
      DO 42 K=1,KK
      DO 42 J=1,JJ
      DO 42 I=1,II
      WRITE(NO,41)I,J,K,A1(I,J,K),A2(I,J,K),A3(I,J,K),
     &TX(I,J,K),TY(I,J,K),TZ(I,J,K)
42    CONTINUE
      RETURN
C
   69 FORMAT(40A2)
   31 FORMAT(//T15,'**********TRANSMISSIBILITY (TX) NODE MODIFICATIONS',
     & '**********',//T15,'     I    J    K         NEW TX VALUE')
   32 FORMAT(15X,3I5,5X,F14.4)
   34 FORMAT(//T15,'**********TRANSMISSIBILITY (TY) NODE MODIFICATIONS',
     & '**********',//T15,'     I    J    K         NEW TY VALUE')
   37 FORMAT(//T15,'**********TRANSMISSIBILITY (TZ) NODE MODIFICATIONS',
     & '**********',//T15,'     I    J    K         NEW TZ VALUE')
   38 FORMAT(/1X,'K =',I2/)
   41 FORMAT(1X,3I5,6F15.3)
   43 FORMAT(//1X,'    I    J    K        A1            A2      ',
     & '      A3            TX            TY            TZ'/)
   44 FORMAT(//T15,'**********TRANSMISSIBILITY (TX) DISTRIBUTION'
     & ,'**********'/)
   47 FORMAT(//T15,'**********TRANSMISSIBILITY (TY) DISTRIBUTION'
     & ,'**********'/)
   48 FORMAT(//T15,'**********TRANSMISSIBILITY (TZ) DISTRIBUTION'
     & ,'**********'/)
   72 FORMAT(1X,20F6.1)
C
      END
      SUBROUTINE TABLE
C
C==================================================================TABLE
C
C   READ PVT AND RELATIVE PERMEABLITY DATA.
C
C=======================================================================
C
      INCLUDE 'MEOR.PAR' 
      CHARACTER*2 TITLE(80)
      REAL KROT,KRWT,KRGT,MUOT,MUWT,MUGT,KX,KY,KZ
      COMMON /IO/ NI,NO
      COMMON /BUBBLE/ PBO,VSLOPE,BSLOPE,RSLOPE,PMAXT,IREPRS,RHOROCK,
     & RHOSCO,RHOSCG,RHOSCW,MSAT,MPOT,MPWT,MPGT,PBOT(NX,NY,NZ)
      COMMON /SPVT/ SAT(NTE),KROT(NTE),KRWT(NTE),KRGT(NTE),PCOWT(NTE),
     & PCGOT(NTE),POT(NTE),MUOT(NTE),BOT(NTE),BOPT(NTE),RSOT(NTE),RSOPT
     & (NTE),PWT(NTE),MUWT(NTE),BWT(NTE),BWPT(NTE),RSWT(NTE),RSWPT(NTE),
     & PGT(NTE),MUGT(NTE),BGT(NTE),BGPT(NTE),CRT(NTE)
      COMMON /COUNT/ N1READ,N2READ
      COMMON /RSO9/ RSO9,RSW9
C
      WRITE(NO,111)
C
C****  RELATIVE PERMEABILITY & CAPILLARY PRESSURE TABLE
C
      READ(NI,1) (TITLE(IH),IH=1,40)
      N1READ=N1READ+1
      WRITE(NO,11) (TITLE(IH),IH=1,40)
      IOFLAG=0
      IWFLAG=0
      DO 5 I=1, NTE
       READ(NI,*) SAT(I),KROT(I),KRWT(I),KRGT(I),PCOWT(I),PCGOT(I)
       N1READ=N1READ+1
       WRITE(NO,21)SAT(I),KROT(I),KRWT(I),KRGT(I),PCOWT(I),PCGOT(I)
       IF(KROT(I).GT.0.AND.IOFLAG.EQ.0)THEN
	 RSO9=SAT(I-1)
         IOFLAG=1
        ENDIF
       IF(KRWT(I).GT.0.AND.IWFLAG.EQ.0)THEN
	 RSW9=SAT(I-1)
         IWFLAG=1
        ENDIF
       IF(SAT(I).GT.1.0) GO TO 10
5     CONTINUE
C
C****  BUBBLE POINT & MAXIMUM PRESSURES
C
10    MSAT=I
      READ(NI,1) (TITLE(IH),IH=1,40)
      N1READ=N1READ+1
      WRITE(NO,11)(TITLE(IH),IH=1,40)
      READ(NI,*) PBO,VSLOPE,BSLOPE,RSLOPE,PMAXT,IREPRS
      N1READ=N1READ+1
      WRITE(NO,31)PBO,VSLOPE,BSLOPE,RSLOPE,PMAXT,IREPRS
C
C****  OIL PVT TABLE
C
      READ(NI,1) (TITLE(IH),IH=1,40)
      N1READ=N1READ+1
      WRITE(NO,11) (TITLE(IH),IH=1,40)
      DO 15 I=1, NTE
      READ(NI,*) POT(I),MUOT(I),BOT(I),RSOT(I)
      N1READ=N1READ+1
      WRITE(NO,23)POT(I),MUOT(I),BOT(I),RSOT(I)
      RSOT(I)=0.17809*RSOT(I)
      IF(POT(I).GE.PMAXT)GO TO 20
15    CONTINUE
C
C****  WATER PVT TABLE
C
20    MPOT=I
      READ(NI,1) (TITLE(IH),IH=1,40)
      N1READ=N1READ+1
      WRITE(NO,11) (TITLE(IH),IH=1,40)
      DO 25 I=1,NTE
      READ(NI,*) PWT(I),MUWT(I),BWT(I),RSWT(I)
      N1READ=N1READ+1
      WRITE(NO,23) PWT(I),MUWT(I),BWT(I),RSWT(I)
      RSWT(I)=0.17809*RSWT(I)
      IF(PWT(I).GE.PMAXT)GO TO 30
25    CONTINUE
C
C****  GAS PVT & ROCK DATA TABLE
C
30    MPWT=I
      READ(NI,1) (TITLE(IH),IH=1,40)
      N1READ=N1READ+1
      WRITE(NO,11) (TITLE(IH),IH=1,40)
      DO 35 I=1,999
      READ(NI,*) PGT(I),MUGT(I),BGT(I),CRT(I)
      N1READ=N1READ+1
      WRITE(NO,24) PGT(I),MUGT(I),BGT(I),CRT(I)
      IF(PGT(I).GE.PMAXT) GO TO 40
35    CONTINUE
C
40    MPGT=I
      CONTINUE
C
C****  OIL, WATER, & GAS DENSITIES AT STOCK TANK CONDITIONS
C
      READ(NI,1) (TITLE(IH),IH=1,40)
      N1READ=N1READ+1
      WRITE(NO,11) (TITLE(IH),IH=1,40)
      READ(NI,*)RHOSCO,RHOSCW,RHOSCG,RHOROCK
      N1READ=N1READ+1
      WRITE(NO,4)RHOSCO,RHOSCW,RHOSCG
C
C**** CALCULATE SLOPES DBO/DP, DRSO/DP, DBW/DP, DRSW/DP, DBG/DP
C
      WRITE(NO,222)
      WRITE(NO,223)
      DO 100 I=2,MPOT
      DIV=1.0/(POT(I)-POT(I-1))
      BOPT(I)=(BOT(I)-BOT(I-1))*DIV
      RSOPT(I)=(RSOT(I)-RSOT(I-1))*DIV
100   WRITE(NO,224)POT(I),BOT(I),BOPT(I),RSOT (I),RSOPT(I)
      WRITE(NO,333)
      DO 200 I=2,MPWT
      DIV=1.0/(PWT(I)-PWT(I-1))
      BWPT(I)=(BWT(I)-BWT(I-1))*DIV
      RSWPT(I)=(RSWT(I)-RSWT(I-1))*DIV
200   WRITE(NO,224)PWT(I),BWT(I),BWPT(I),RSWT(I),RSWPT(I)
C
      WRITE(NO,444)
      DO 300 I=2,MPGT
      BGPT(I)=(BGT(I)-BGT(I-1))/(PGT(I)-PGT(I-1))
300   WRITE(NO,445)PGT(I),BGT(I),BGPT(I)
C
C**** NOTE: SLOPE AT POINT "I" IS BASED ON POINTS "I" AND "I-1"
C
1     FORMAT(40A2)
4     FORMAT(2X,8F10.4)
11    FORMAT(//,1X,40A2/)
21    FORMAT(1X,4F10.4,2F10.2)
23    FORMAT(3X,F10.1,1X,F8.4,2X,F8.4,2X,F8.2)
24    FORMAT(3X,F10.1,1X,F8.4,E10.3,E10.3)
31    FORMAT(F10.2,E10.3,1X,E10.3,2F10.2,I5)
111   FORMAT(//T15,'***** EMPIRICAL DATA TABLE *****'//)
222   FORMAT(//T15,'***** SLOPES FOR COMPRESSIBILITY CALCULATIONS',
     &' ****')
223   FORMAT(//T16,'P',T25,'BO',T33,'DBO/DP',T47,'RSO',
     &T55,'DRSO/DP'/)
224   FORMAT( T13,F7.1,F8.4,3X,E11.4,F8.1,2X,E11.4)
333   FORMAT(//T16,'P',T25,'BW',T33,'DBW/DP',T47,'RSW',
     &T55,'DRSW/DP'/)
444   FORMAT(//15X,'P',12X,'BG',12X,'DBGDP')
445   FORMAT(10X,F9.1,1X,2E15.4)
C
      RETURN
      END
      SUBROUTINE UINIT1
C
C=================================================================UINIT1
C
C   READ INITIAL PRESSURE AND SATURATION ARRAY.
C
C=======================================================================
C
      INCLUDE 'MEOR.PAR' 
      REAL MBEO,MBEW,MBEG,KX,KY,KZ,KROT,KRWT,KRGT,MUOT,MUWT,MUGT
      CHARACTER*2 TITLE(80)
      COMMON /IO/ NI,NO
      COMMON /NUMBER/ II,JJ,KK
      COMMON /MBE/ MBEO,MBEW,MBEG
      COMMON /PSCNTL/ KPI,KSI
      COMMON /BUBBLE/ PBO,VSLOPE,BSLOPE,RSLOPE,PMAXT,IREPRS,RHOROCK,
     & RHOSCO,RHOSCG,RHOSCW,MSAT,MPOT,MPWT,MPGT,PBOT(NX,NY,NZ)
      COMMON /SARRAY/ PN(NX,NY,NZ),
     & SON(NX,NY,NZ),SWN(NX,NY,NZ),SGN(NX,NY,NZ),
     & SO1(NX,NY,NZ),SW1(NX,NY,NZ),SG1(NX,NY,NZ),
     & A1(NX,NY,NZ),A2(NX,NY,NZ),A3(NX,NY,NZ),
     & SUM(NX,NY,NZ),GAM(NX,NY,NZ),QS(NX,NY,NZ)
      COMMON /ELEV/ EL(NX,NY,NZ)
      COMMON /PRTP/ P(NX,NY,NZ)
      COMMON /PRTS/ SO(NX,NY,NZ),SW(NX,NY,NZ),SG(NX,NY,NZ)
      COMMON /SPVT/ SAT(NTE),KROT(NTE),KRWT(NTE),KRGT(NTE),PCOWT(NTE),
     & PCGOT(NTE),POT(NTE),MUOT(NTE),BOT(NTE),BOPT(NTE),RSOT(NTE),RSOPT
     & (NTE),PWT(NTE),MUWT(NTE),BWT(NTE),BWPT(NTE),RSWT(NTE),RSWPT(NTE),
     & PGT(NTE),MUGT(NTE),BGT(NTE),BGPT(NTE),CRT(NTE)
      COMMON /COUNT/ N1READ,N2READ
      DIMENSION PPK(NZ),SOK(NZ),SWK(NZ)
C
      MBEO=0.0
      MBEW=0.0
      MBEG=0.0
C
C***   INITIALIZE BUBBLE POINT PRESSURE ARRAY
C
      DO 8 I=1,II
      DO 8 J=1,JJ
      DO 8 K=1,KK
 8    PBOT(I,J,K) = PBO
C
      READ(5,69) (TITLE(IH),IH=1,40)
      N2READ=N2READ+1
      READ(NI,*) KPI,KSI
      N2READ=N2READ+1
      IF(KPI.NE.0) GO TO 5601
      READ(5,*) PI,PGOC,WOC,GOC
      N2READ=N2READ+1
      DO 200 K=1,KK
      DO 200 J=1,JJ
      DO 200 I=1,II
      IF(EL(I,J,K).LT.GOC) GO TO 175
      IF(EL(I,J,K).GT.WOC)GO TO 150
      BPT=PBOT(I,J,K)
      CALL INTPVT(BPT,BSLOPE,POT,BOT,MPOT,PI,BBO)
      CALL INTPVT(BPT,RSLOPE,POT,RSOT,MPOT,PI,RSO)
      RHOO=(RHOSCO+RSO*RHOSCG)/BBO
      PN(I,J,K)=PI+RHOO*(EL(I,J,K)-WOC)/144.
      GO TO 200
  150 CALL INTERP(PWT,BWT,MPWT,PI,BBW)
      CALL INTERP(PWT,RSWT,MPWT,PI,RSW)
      RHOW=(RHOSCW+RSW*RHOSCG)/BBW
      PN(I,J,K)=PI+RHOW*(EL(I,J,K)-WOC)/144.
      GO TO 200
  175 CALL INTERP(PGT,BGT,MPGT,PGOC,BBG)
      RHOG=RHOSCG/BBG
      PN(I,J,K)=PGOC+RHOG*(EL(I,J,K)-GOC)/144.
  200 CONTINUE
      GO TO 3015
 5601 IF(KPI.NE.1) GO TO 5610
      DO 3010 K=1,KK
      DO 3005 J=1,JJ
 3005 READ(5,*)(PN(I,J,K),I=1,II)
      N2READ=N2READ+1+INT(II/10)
3010  CONTINUE
      GO TO 3015
C***  PRESSURE AT EACH LAYER TO BE READ ....
5610  READ(NI,*)(PPK(K),K=1,KK)
      N2READ=N2READ+1+INT(KK/10)
      IF(MOD(KK,10).EQ.0)N2READ=N2READ-1
      DO 3080 K=1,KK
      DO 3080 J=1,JJ
      DO 3080 I=1,II
3080  PN(I,J,K)=PPK(K)      
C
3015  CONTINUE
C**** INITIALIZE N+1 PRESSURE ARRAY.
      DO 3012 I=1,II
      DO 3012 J=1,JJ
      DO 3012 K=1,KK
 3012 P(I,J,K)=PN(I,J,K)
      IF(KSI.NE.0)GO TO 5600
      READ(5,*) SOI,SWI,SGI
      N2READ=N2READ+1
      DO 30 K=1,KK
      DO 30 J=1,JJ
      DO 30 I=1,II
      SON(I,J,K)=SOI
      SWN(I,J,K)=SWI
      SGI=1.0-SOI-SWI
      SGN(I,J,K)=SGI
      SO(I,J,K)=SOI
      SW(I,J,K)=SWI
      SG(I,J,K)=SGI
      IF(SG(I,J,K).LT.0.0) SG(I,J,K)=0.0
   30 CONTINUE
      RETURN
5600  IF(KSI.NE.1) GO TO 5620
      DO 3011 K=1,KK
      DO 3006 J=1,JJ
      READ(5,*)(SO(I,J,K),I=1,II)
3006  N2READ=N2READ+1+INT(II/10)
3011  CONTINUE
      DO 3020 K=1,KK
      DO 3007 J=1,JJ
      READ(5,*)(SW(I,J,K),I=1,II)
3007  N2READ=N2READ+1+INT(II/10)
3020  CONTINUE
      DO 3030 K=1,KK
      DO 3030 J=1,JJ
      DO 3030 I=1,II
      SG(I,J,K)=1.0-SO(I,J,K)-SW(I,J,K)
      IF(SG(I,J,K).LT.0.0) SG(I,J,K)=0.0
      SON(I,J,K)=SO(I,J,K)
      SWN(I,J,K)=SW(I,J,K)
      SGN(I,J,K)=SG(I,J,K)
 3030 CONTINUE
69    FORMAT(40A2)
      RETURN
C***  OIL/WATER SATURATIONS AT EACH LAYER TO BE READ ....
5620  READ(NI,*)(SOK(K),K=1,KK)
      N2READ=N2READ+1+INT(KK/10)
      IF(MOD(KK,10).EQ.0)N2READ=N2READ-1
      READ(NI,*)(SWK(K),K=1,KK)
      N2READ=N2READ+1+INT(KK/10)
      IF(MOD(KK,10).EQ.0)N2READ=N2READ-1
      DO 3090 K=1,KK
      DO 3090 J=1,JJ
      DO 3090 I=1,II
       SO(I,J,K)=SOK(K)
       SW(I,J,K)=SWK(K)
       SG(I,J,K)=1.-SOK(K)-SWK(K)
       SON(I,J,K)=SOK(K)
       SWN(I,J,K)=SWK(K)
       SGN(I,J,K)=1.-SOK(K)-SWK(K)
3090  CONTINUE
      RETURN
      END
C
      SUBROUTINE CODES
C
C==================================================================CODES
C
C   READ SOLUTION METHOD, SOLUTION PARAMETERS, AND DIAGNOSTIC CONTROLS
C
C=======================================================================
C
      CHARACTER*2 TITLE(80)
      COMMON /IO/ NI,NO
      COMMON /CODE/ KSM1,KSN1,KCO1,NN,
     &FACT1,FACT2,TMAX,KSOL,MITER,OMEGA,TOL,TOL1,
     & KSN,KSM,KCO,KTR,KCOFF,DSMAX,DPMAX,
     &WORMAX,GORMAX,PAMIN,PAMAX
      READ(NI,69) (TITLE(IH),IH=1,40)
      READ(NI,*) KSN1,KSM1,KCO1,KTR,KCOFF
C EVERY KSM1 TH STEP SOLUTION MATRIX WILL BE WRITTEN
C EVERY KSN1 TH STEP LSOR DATA WILL BE WRITTEN
C EVERY KCO1 TH STEP COMPRESSIBILITIES & VOLUME FACTORS WILL BE WRITTEN
C IF KTR IS NONZERO TRANSMISSIBILITIES WILL BE WRITTEN
      READ(NI,69) (TITLE(IH),I=1,40)
      READ(NI,*)NN,FACT1,FACT2,TMAX,WORMAX,GORMAX,PAMIN,PAMAX
      WRITE(NO,59) NN,FACT1,FACT2,TMAX,WORMAX,GORMAX,PAMIN,PAMAX
C NN--MAXIMUM NUMBER OF TIME-STEPS
C FACT1--FACTOR FOR INCREASING TIME-STEP SIZE
C FACT2--FACTOR FOR DECREASING TIME-STEP SIZE
C TMAX--MAXIMUM SIMULATION TIME
      READ(NI,69) (TITLE(IH),I=1,40)
      READ(NI,*)KSOL,MITER,OMEGA,TOL,TOL1,DSMAX,DPMAX
      IF(KSOL.EQ.1) WRITE(NO,73)
      IF(KSOL.EQ.2) WRITE(NO,75) MITER,OMEGA,TOL,TOL1
      IF(KSOL.EQ.3) WRITE(NO,77)
      WRITE(NO,79) DSMAX,DPMAX
      KSN=KSN1
      KSM=KSM1
      KCO=KCO1
      RETURN
C
   73 FORMAT(//T15,'SOLUTION METHOD IS BAND')
   75 FORMAT(//T15,'SOLUTION METHOD IS LSOR:',
     &/T20,'MAXIMUM NUMBER OF ITERATIONS      (MITR) = ',5X,I5,
     &/T20,'INITIAL ACCELERATION PARAMETER    (OMEGA) = ',F10.4,
     &/T20,'MAXIMUM PRESSURE RESIDUAL          (TOL) = ',F10.4,
     &/T20,'PARAMETER FOR CHANGING OMEGA      (TOL1) = ',F10.4)
   77 FORMAT(//T15,'SOLUTION METHOD IS D4.')
   79 FORMAT(/T15,'AUTOMATIC TIME STEP CRITERIA:',
     &/T20,'MAXIMUM ALLOWED SATURATION CHANGE (DSMAX) = ',F10.4,
     &/T20,'MAXIMUM ALLOWED PRESSURE CHANGE   (DPMAX) = ',F10.4/)
59    FORMAT(//T15,'MAXIMUM NUMBER OF TIME-STEPS =',I5/
     &T15,'FACTOR FOR INCREASING DELT =',F10.6,3X,
     &'WHEN DSMAX AND DPMAX NOT EXCEEDED.',/,
     &T15,'FACTOR FOR DECREASING DELT =',F10.6,3X,
     &'WHEN DSMAX OR DPMAX IS EXCEEDED.',/,
     &T15,'MAXIMUM SIMULATION TIME =',F11.6/,
     &T15,'MAXIMUM RESERVOIR WOR/TIME-STEP =',F8.0,' STB/STB'/
     &T15,'MAXIMUM RESERVOIR GOR/TIME-STEP =',F8.0,' SCF/STB'/
     &T15,'MINIMUM AVERAGE RESERVOIR PRESSURE/TIME-STEP =',F8.0/
     &T15,'MAXIMUM AVERAGE RESERVOIR PRESSURE/TIME-STEP =',F8.0//)
69    FORMAT(40A2)
311   FORMAT (I5,F10.0,I5)
      END
C
C
C
      SUBROUTINE NODES(NVQN,NVQNH,NVQNS)
C
C==================================================================NODES
C
C   READ TIME STEP AND VERTICAL WELL INFORMATION.
C
C         NVQN = # OF VERTICAL WELLS
C         NVQNH= # OF HORIZONTAL WELLS
C         NVQNS= # OF SLANT WELLS
C=======================================================================
C
      INCLUDE 'MEOR.PAR' 
      REAL KX,KY,KZ,RATIOK,RAT1,K1,K2
      CHARACTER*2 TITLE(80)
      CHARACTER*5 WELLID
      COMMON /IDEN/ WELLID(NW) 
      COMMON /IO/ NI,NO
      COMMON /NUMBER/ II,JJ,KK
      COMMON /SWTCH/ NGRSW,NTRSW,NRESTART,NGEL
      COMMON /PORE/ VP(NX,NY,NZ),POR(NX,NY,NZ),PV
      COMMON /VECTOR/ DX(NX,NY,NZ),DY(NX,NY,NZ),DZ(NX,NY,NZ)
      COMMON /PERM/ KX(NX,NY,NZ),KY(NX,NY,NZ),KZ(NX,NY,NZ)
      COMMON /SRATE/ PID(NW,NL),PWF(NW,NL),PWFC(NW,NL),KIP(NW),
     & GMO(NW,NL),GMW(NW,NL),GMG(NW,NL),LAYER(NW),QVO(NW),
     & QVW(NW),QVG(NW),QVT(NW),CUMO(NW,NL),CUMW(NW,NL),CUMG(NW,NL)
      COMMON /IQN/ IQN1(NW),IQN2(NW),IQN3(NW)
      COMMON /IQH/ IQH1(NW,NL),IQH2(NW,NL),IQH3(NW,NL),COND(NW)
      COMMON /R1XYZ/ R11X,R21X,R31X,R41X,R11Y,R21Y,R31Y,R41Y,
     & R11Z,R21Z,R31Z,R41Z
      COMMON /T1XYZ/ T1X,T2X,T3X,T4X,T1Y,T2Y,T3Y,T4Y,T1Z,T2Z,T3Z,T4Z
      COMMON /DXYZ/ DX0,DXP,DXM,XW,DY0,DYP,DYM,YW,DZ0,DZP,DZM,ZW
      COMMON /RXYZ/ RX,RY,RZ,AX,AY,AZ,I,J,K
C      COMMON /GEL/ DDX,DDY,DDZ,K1,K2,NRX,C(NX,NY,NZC),
C     & UX(NX,NY,NZ),UY(NX,NY,NZ),UZ(NX,NY,NZ),MAPWI(NX,NY,NZ),
C     & CQI(NW,5),MORDER,FIPV(NZ,5),UW(NX,NY,NZ),UE(NX,NY,NZ),
C     & US(NX,NY,NZ),UN(NX,NY,NZ),UT(NX,NY,NZ),UB(NX,NY,NZ)
      COMMON /SARRAY/ PN(NX,NY,NZ),
     & SON(NX,NY,NZ),SWN(NX,NY,NZ),SGN(NX,NY,NZ),
     & SO1(NX,NY,NZ),SW1(NX,NY,NZ),SG1(NX,NY,NZ),
     & A1(NX,NY,NZ),A2(NX,NY,NZ),A3(NX,NY,NZ),
     & SUM(NX,NY,NZ),GAM(NX,NY,NZ),QS(NX,NY,NZ)

      COMMON /MEORB/ C(NX,NY,NZC),SIGMA(NX,NY,NZ),RF(NX,NY,NZ),AKC,
     & AKD,AKY,AKS,AMUM,YIELD,RHOMIC,CQI(NW,NC),MAPWI(NX,NY,NZ),RFT
C
C**** ESTABLISH RATE-SPECIFIED & PRESSURE-SPECIFIED WELLS
C
      READ(5,69) (TITLE(IH),IH=1,40)
C      READ(5,*)NVQN,NVQNH,NVQNS
      READ(5,*)NVQN
      NVQNH=0
      NVQNS=0
      IF(NVQN.EQ.0)GO TO 2011
      WRITE(NO,67)
      WRITE(NO,68)
      DO 2000 J=1,NVQN
C**   INPUT RATE SIGNS BY CONVENTION:
C**   INJECTORS ARE NEGATIVE; PRODUCERS ARE POSITIVE.
      READ(NI,1) WELLID(J)
      READ(5,*) IQN1(J),IQN2(J),IQN3(J),LAYER(J),KIP(J),
     & QVO(J),QVW(J),QVG(J),QVT(J)
      IQ3=IQN3(J)
      LAY=IQ3+(LAYER(J)-1)
      SUMPID=0.
      DO 1900 K=IQ3,LAY
      READ(5,*) RWV,SV,PWF(J,K)
       I1=IQN1(J)
       I2=IQN2(J)
      RATIOK=SQRT(KY(I1,I2,K)/KX(I1,I2,K))
      RAT1=RATIOK**0.5
      RADIUSO=0.28*(RATIOK*DX(I1,I2,K)**2+1/RATIOK*DY(I1,I2,K)
     & **2)**0.5/(RAT1+1/RAT1)
      PID(J,K)=0.00708*SQRT(KX(I1,I2,K)*KY(I1,I2,K))*DZ(I1,I2,K)
     & /(ALOG(RADIUSO/RWV)+SV)
      WRITE(NO,70)IQN1(J),IQN2(J),K,QVO(J),QVW(J),QVG(J),
     & QVT(J),PWF(J,K),PID(J,K)
      MAPWI(IQN1(J),IQN2(J),K)=J
      SUMPID=SUMPID+PID(J,K)
 1900 CONTINUE
      IF(NGEL.NE.1.OR.QVW(J).GE.0.) GO TO 2000
       READ(NI,*)(CQI(J,KC),KC=1,2)
2000  CONTINUE
C
      WRITE(NO,33)
      DO 2999 J=1,NVQN
      IQ3=IQN3(J)
      LAY=IQ3+(LAYER(J)-1)
      DO 2999 K=IQ3,LAY
      IF(KIP(J).EQ.1) WRITE(NO,2995) IQN1(J),IQN2(J),K
      IF(KIP(J).EQ.2) WRITE(NO,2996) IQN1(J),IQN2(J),K
      IF(KIP(J).EQ.3) WRITE(NO,2997) IQN1(J),IQN2(J),K
      IF(KIP(J).EQ.-1) WRITE(NO,3005) IQN1(J),IQN2(J),K
      IF(KIP(J).EQ.-2) WRITE(NO,3006) IQN1(J),IQN2(J),K
      IF(KIP(J).EQ.-3) WRITE(NO,3007) IQN1(J),IQN2(J),K
      IF(KIP(J).EQ.-11) WRITE(NO,3015) IQN1(J),IQN2(J),K
      IF(KIP(J).EQ.-12) WRITE(NO,3016) IQN1(J),IQN2(J),K
      IF(KIP(J).EQ.-13) WRITE(NO,3017) IQN1(J),IQN2(J),K
2999  CONTINUE
C
2011  IF(NVQNH.NE.0) CALL NODESH(NVQN,NVQNH,NVQNS)
      IF(NVQNS.NE.0) CALL SLANT(NVQN,NVQNH,NVQNS)
C
1     FORMAT(A5)
69    FORMAT(40A2)
722   FORMAT(3F10.4)
721   FORMAT(4F10.0)
67    FORMAT(//T15,'RESERVOIR CONTAINS THE FOLLOWING RATE NODES
     & (FOR VERTICAL WELLS)'/)
68    FORMAT(T2,'   NODE   ',3X,'  OIL(STBD)',
     &3X,'WATER(STBD)',3X,'GAS(MCFD)',3X,'TOTAL(RBD)',3X,'BHFP(PSIA)'
     &,3X,'PID')
70    FORMAT(1X,3I3,3X,F11.2,4F13.2,F10.6)
71    FORMAT(9X,3I4,F10.2,3F5.1,10X,F10.2,3F5.1,F12.3)
33    FORMAT(/)
 2995 FORMAT(T15,'BLOCK ',3I3,
     & ' CONTAINS A RATE SPECIFIED PRODUCING WELL')
 2996 FORMAT(T15,'BLOCK ',3I3,
     & ' CONTAINS A RATE SPECIFIED WATER INJECTION WELL')
 2997 FORMAT(T15,'BLOCK ',3I3,
     & ' CONTAINS A RATE SPECIFIED GAS INJECTION WELL')
 3005 FORMAT(T15,'BLOCK ',3I3,' CONTAINS AN ',
     & 'EXPLICIT PRESSURE SPECIFIED PRODUCING WELL')
 3006 FORMAT(T15,'BLOCK ',3I3, ' CONTAINS AN ',
     & 'EXPLICIT PRESSURE SPECIFIED WATER INJECTION WELL')
 3007 FORMAT(T15,'BLOCK ',3I3,' CONTAINS AN ',
     & 'EXPLICIT PRESSURE SPECIFIED GAS INJECTION WELL')
 3015 FORMAT(T15,'BLOCK ',3I3,' CONTAINS AN ',
     & 'IMPLICIT PRESSURE SPECIFIED PRODUCING WELL')
 3016 FORMAT(T15,'BLOCK ',3I3,' CONTAINS AN ',
     & 'IMPLICIT PRESSURE SPECIFIED WATER INJECTION WELL')
 3017 FORMAT(T15,'BLOCK ',3I3,' CONTAINS AN ',
     & 'IMPLICIT PRESSURE SPECIFIED GAS INJECTION WELL')
      RETURN
      END
C
      SUBROUTINE NODESH(NVQN,NVQNH,NVQNS)
C
C=================================================================NODESH
C
C   READ HORIZONTAL WELL INFORMATION.
C
C      (NVQN,NVQNH,NVQNS ARE # OF VERTICAL, HORIZONTAL, AND SLANT WELLS,
C         RESPECTIVELY)
C=======================================================================
C
      INCLUDE 'MEOR.PAR' 
      REAL K1,K2
      CHARACTER*2 TITLE(80)
      CHARACTER*5 WELLID
      COMMON /IDEN/ WELLID(NW)
      COMMON /IO/ NI,NO
      COMMON /NUMBER/ II,JJ,KK
      COMMON /SWTCH/ NGRSW,NTRSW,NRESTART,NGEL
      COMMON /PORE/ VP(NX,NY,NZ),POR(NX,NY,NZ),PV
      COMMON /SRATE/ PID(NW,NL),PWF(NW,NL),PWFC(NW,NL),KIP(NW),
     & GMO(NW,NL),GMW(NW,NL),GMG(NW,NL),LAYER(NW),QVO(NW),
     & QVW(NW),QVG(NW),QVT(NW),CUMO(NW,NL),CUMW(NW,NL),CUMG(NW,NL)
      COMMON /IQN/ IQN1(NW),IQN2(NW),IQN3(NW)
      COMMON /IQH/ IQH1(NW,NL),IQH2(NW,NL),IQH3(NW,NL),COND(NW)

      COMMON /MEORB/ C(NX,NY,NZC),SIGMA(NX,NY,NZ),RF(NX,NY,NZ),AKC,
     & AKD,AKY,AKS,AMUM,YIELD,RHOMIC,CQI(NW,NC),MAPWI(NX,NY,NZ),RFT

C      COMMON /GEL/ DDX,DDY,DDZ,K1,K2,NRX,C(NX,NY,NZC),
C     & UX(NX,NY,NZ),UY(NX,NY,NZ),UZ(NX,NY,NZ),MAPWI(NX,NY,NZ),
C     & CQI(NW,5),MORDER,FIPV(NZ,5),UW(NX,NY,NZ),UE(NX,NY,NZ),
C     & US(NX,NY,NZ),UN(NX,NY,NZ),UT(NX,NY,NZ),UB(NX,NY,NZ)
C
C**** ESTABLISH RATE-SPECIFIED & PRESSURE-SPECIFIED WELLS
C
      WRITE(NO,607)
      WRITE(NO,608)
      N1=NVQN+1
      N2=NVQN+NVQNH
      DO 2010 J=N1,N2
C**    INPUT RATE SIGNS BY CONVENTION:
C**    INJECTORS ARE NEGATIVE; PRODUCERS ARE POSITIVE.
       READ(NI,1212) WELLID(J)
       READ(5,*) LAYER(J),KIP(J),QVO(J),QVW(J),QVG(J),QVT(J),COND(J)
       SUMPID=0
      DO 2001 K=1,LAYER(J)
       READ(5,*) IQH1(J,K),IQH2(J,K),IQH3(J,K),PID(J,K),PWF(J,K)
       WRITE(NO,703)IQH1(J,K),IQH2(J,K),IQH3(J,K),QVO(J),QVW(J),
     &  QVG(J),QVT(J),PWF(J,K),PID(J,K)
       MAPWI(IQH1(J,K),IQH2(J,K),IQH3(J,K))=J+NVQN
      SUMPID=SUMPID+PID(J,K)
2001  CONTINUE
      IF(NGEL.NE.1.OR.QVW(J).GE.0.) GO TO 2010
       READ(NI,*)(CQI(J,KC),KC=1,5)
       DO 2005 K=1,LAYER(J)
        I1=IQN1(J)
        I2=IQN2(J)
        DO 2005 KC=1,5
         I3=K+KK*(KC-1)
         C(I1,I2,I3)=(C(I1,I2,I3)*VP(I1,I2,IQN3(J))-CQI(J,KC)
     &    *QVW(J)*PID(J,K)/SUMPID*DELT)/VP(I1,I2,IQN3(J))
 2005  CONTINUE
2010  CONTINUE
C
      WRITE(NO,313)
      DO 2998 J=N1,N2
      IF(KIP(J).EQ.1) WRITE(NO,2905) WELLID(J)
      IF(KIP(J).EQ.2) WRITE(NO,2906) WELLID(J)
      IF(KIP(J).EQ.3) WRITE(NO,2907) WELLID(J)
      IF(KIP(J).EQ.-1) WRITE(NO,2915) WELLID(J)
      IF(KIP(J).EQ.-2) WRITE(NO,2916) WELLID(J)
      IF(KIP(J).EQ.-3) WRITE(NO,2917) WELLID(J)
      IF(KIP(J).EQ.-11) WRITE(NO,2925) WELLID(J)
      IF(KIP(J).EQ.-12) WRITE(NO,2926) WELLID(J)
      IF(KIP(J).EQ.-13) WRITE(NO,2927) WELLID(J)
      DO 2997 K=1,LAYER(J)
      WRITE(NO,2976) IQH1(J,K),IQH2(J,K),IQH3(J,K)
2997  CONTINUE
2998  CONTINUE
C
1212  FORMAT(A5)
607   FORMAT(//T15,'RESERVOIR CONTAINS FOLLOWING RATE NODES
     & (FOR HORIZONTAL OR SLANT WELLS) '/)
608    FORMAT(T2,'   NODE   ',3X,'  OIL(STBD)',
     &3X,'WATER(STBD)',3X,'GAS(MCFD)',3X,'TOTAL(RBD)',3X,'BHFP(PSIA)'
     &,3X,'PID')
703   FORMAT(1X,3I3,3X,F11.2,4F13.2,F10.6)
313   FORMAT(/)
 2976 FORMAT(T15,'BLOCK ',3I3)
 2905 FORMAT(T10,'HORIZONTAL OR SLANT WELL ',A5,
     & ' IS A RATE SPECIFIED PRODUCING WELL WHICH CONTAINS:')
 2906 FORMAT(T10,'HORIZONTAL OR SLANT WELL ',A5,
     & ' IS A RATE SPECIFIED WATER INJECTION WELL WHICH CONTAINS:')
 2907 FORMAT(T10,'HORIZONTAL OR SLANT WELL ',A5,
     & ' IS A RATE SPECIFIED GAS INJECTION WELL WHICH CONTAINS:')
 2915 FORMAT(T10,'HORIZONTAL OR SLANT WELL ',A5,' IS AN ',
     & 'EXPLICIT PRESSURE SPECIFIED PRODUCING WELL WHICH CONTAINS:')
 2916 FORMAT(T10,'HORIZONTAL OR SLANT WELL ',A5,' IS AN EXPLICIT ',
     & 'PRESSURE SPECIFIED WATER INJECTION WELL WHICH CONTAINS:')
 2917 FORMAT(T10,'HORIZONTAL OR SLANT WELL ',A5,' IS AN ',
     & 'EXPLICIT PRESSURE SPECIFIED GAS INJECTION WELL WHICH CONTAINS:')
 2925 FORMAT(T10,'HORIZONTAL OR SLANT WELL ',A5,' IS AN ',
     & 'IMPLICIT PRESSURE SPECIFIED PRODUCING WELL WHICH CONTAINS:')
 2926 FORMAT(T10,'HORIZONTAL OR SLANT WELL ',A5,' IS AN IMPLICIT ',
     & 'PRESSURE SPECIFIED WATER INJECTION WELL WHICH CONTAINS:')
 2927 FORMAT(T10,'HORIZONTAL OR SLANT WELL ',A5,' IS AN ',
     & 'IMPLICIT PRESSURE SPECIFIED GAS INJECTION WELL WHICH CONTAINS:')
      RETURN
      END
C
      SUBROUTINE QRATE(IWELTYPE,NVQN,NVQNH)
C
C==================================================================QRATE
C
C   COMPUTE WELL RATES WHEN RATE OR EXPLICIT PRESSURE CONSTRAIN
C   ACTIVATED;
C
C        (IWELTYPE = 1 FOR VERTICAL WELL OPTION        )
C        (         = 2 FOR HORIZONTAL/SLANT WELL OPTION) 
C=====================================================================
C
      INCLUDE 'MEOR.PAR' 
      REAL KROT,KRWT,KRGT,MUWT,MUOT,MUGT,KX,KY,KZ
     & ,MUO,MUW,MUG,KRO,KRW,KRG
      COMMON /ELEV/ EL(NX,NY,NZ)
      COMMON /BUBBLE/ PBO,VSLOPE,BSLOPE,RSLOPE,PMAXT,IREPRS,RHOROCK,
     & RHOSCO,RHOSCG,RHOSCW,MSAT,MPOT,MPWT,MPGT,PBOT(NX,NY,NZ)
      COMMON /SARRAY/ PN(NX,NY,NZ),
     & SON(NX,NY,NZ),SWN(NX,NY,NZ),SGN(NX,NY,NZ),
     & SO1(NX,NY,NZ),SW1(NX,NY,NZ),SG1(NX,NY,NZ),
     & A1(NX,NY,NZ),A2(NX,NY,NZ),A3(NX,NY,NZ),
     & SUM(NX,NY,NZ),GAM(NX,NY,NZ),QS(NX,NY,NZ)
      COMMON /PRTP/ P(NX,NY,NZ)
      COMMON /PRTS/ SO(NX,NY,NZ),SW(NX,NY,NZ),SG(NX,NY,NZ)
      COMMON /SPVT/ SAT(NTE),KROT(NTE),KRWT(NTE),KRGT(NTE),PCOWT(NTE),
     & PCGOT(NTE),POT(NTE),MUOT(NTE),BOT(NTE),BOPT(NTE),RSOT(NTE),RSOPT
     & (NTE),PWT(NTE),MUWT(NTE),BWT(NTE),BWPT(NTE),RSWT(NTE),RSWPT(NTE),
     & PGT(NTE),MUGT(NTE),BGT(NTE),BGPT(NTE),CRT(NTE)
      COMMON /SRATE/ PID(NW,NL),PWF(NW,NL),PWFC(NW,NL),KIP(NW),
     & GMO(NW,NL),GMW(NW,NL),GMG(NW,NL),LAYER(NW),QVO(NW),
     & QVW(NW),QVG(NW),QVT(NW),CUMO(NW,NL),CUMW(NW,NL),CUMG(NW,NL)
      COMMON /RATE/ QO(NX,NY,NZ),QW(NX,NY,NZ),QG(NX,NY,NZ)
      COMMON /RATEQ/ QO0(NX,NY,NZ),QW0(NX,NY,NZ),QG0(NX,NY,NZ),ITFLAG
      COMMON /IQN/ IQN1(NW),IQN2(NW),IQN3(NW)
      COMMON /IQH/ IQH1(NW,NL),IQH2(NW,NL),IQH3(NW,NL),COND(NW)
C      COMMON /ADSORB/ AA(5),BB(5),CL(5),GAMA(5),RF(NX,NY,NZ),RFT
C      COMMON /VIS/ ALPHA1,ALPHA2,ALPHA3,BETA1,BETA2,BETA3,CGC,
C     & DTMUW(NX,NY,NZ)
      COMMON /SWTCH/ NGRSW,NTRSW,NRESTART,NGEL
      COMMON /PRTCNT/ IWLCNG,ICHANG,IWLREP,ISUMRY,
     & IPMAP,ISOMAP,ISWMAP,ISGMAP,IPBMAP,ICHMAP,CHEMAP

      COMMON /MEORB/ C(NX,NY,NZC),SIGMA(NX,NY,NZ),RF(NX,NY,NZ),AKC,
     & AKD,AKY,AKS,AMUM,YIELD,RHOMIC,CQI(NW,NC),MAPWI(NX,NY,NZ),RFT
      COMMON /DIFF/ DDX(NC),DDY(NC),DDZ(NC)
      COMMON /FLUX/ UX(NX,NY,NZ),UY(NX,NY,NZ),UZ(NX,NY,NZ)
      COMMON /CONC/ CC(NX,NY,NZ),QG1(NX,NY,NZ)

      DIMENSION GRAVITY(NW,NL),GMTB(NW,NL)
C
      IF(IWELTYPE.EQ.1)THEN
       N1=1
       N2=NVQN
      ELSE 
       N1=NVQN+1
       N2=NVQN+NVQNH 
      ENDIF
C
      DO 105 J=N1,N2
      IF(IWELTYPE.EQ.1)THEN
       IQ1=IQN1(J)
       IQ2=IQN2(J)
       IQ3=IQN3(J)
       LAY=IQ3+(LAYER(J)-1)
      ELSE
       IQ3=1
       LAY=LAYER(J)
      ENDIF

      SUM1=0.
      SUM2=0.
      ITERQ=0
      IF(KIP(J).EQ.1)RHO=RHOSCO
      IF(KIP(J).EQ.2)RHO=RHOSCW
      IF(KIP(J).EQ.3)RHO=RHOSCG
 1172 ITERQ=ITERQ+1

      DO 1170 KKK=IQ3,LAY
      K=KKK
      IF(IWELTYPE.EQ.2)THEN
       IQ1=IQH1(J,KKK)
       IQ2=IQH2(J,KKK)
       K=IQH3(J,KKK)
      ENDIF

      IF(ITERQ.NE.1) GO TO 1210

C ******************** ITEQR = 1 **********************************
      PWFC(J,KKK)=-1.0
      PP=P(IQ1,IQ2,K)
      BPT=PBOT(IQ1,IQ2,K)
      CALL INTPVT(BPT,VSLOPE,POT,MUOT,MPOT,PP,MUO)
      CALL INTERP(PWT,MUWT,MPWT,PP,MUW)
C      IF(NGEL.EQ.1)MUW=MUW+DTMUW(IQ1,IQ2,K)
      CALL INTERP(PGT,MUGT,MPGT,PP,MUG)
      SSO=SO(IQ1,IQ2,K)
      SSW=SW(IQ1,IQ2,K)
      SSG=SG(IQ1,IQ2,K)
      CALL INTERP(SAT,KRWT,MSAT,SSW,KRW)
      CALL INTERP(SAT,KROT,MSAT,SSO,KRO)
      CALL INTERP(SAT,KRGT,MSAT,SSG,KRG)
      GMW(J,KKK)=KRW/MUW
      GMO(J,KKK)=KRO/MUO
      GMG(J,KKK)=KRG/MUG
      CALL INTPVT(BPT,BSLOPE,POT,BOT,MPOT,PP,BBO)
      CALL INTERP(PWT,BWT,MPWT,PP,BBW)
      CALL INTERP(PGT,BGT,MPGT,PP,BBG)
      CALL INTPVT(BPT,RSLOPE,POT,RSOT,MPOT,PP,RSO)
      CALL INTERP(PWT,RSWT,MPWT,PP,RSW)

      IF(KIP(J).LT.0) GO TO 1300

C ************************************************** RATE CONSTRAINT
      IF(KKK.EQ.IQ3) EL0=EL(IQ1,IQ2,K)
      PWFC(J,KKK)=0.0
      IF(PID(J,KKK)/RF(IQ1,IQ2,K).LE.0.0001) GO TO 1205
      FAC=PID(J,KKK)/RF(IQ1,IQ2,K)
      IF(KIP(J).EQ.1.AND.QVT(J).EQ.0.)THEN
        GMTB(J,KKK)=GMO(J,KKK)/BBO
       ELSE
        GMTB(J,KKK)=GMO(J,KKK)/BBO+GMW(J,KKK)/BBW+GMG(J,KKK)/BBG
       ENDIF
      GRAVITY(J,KKK)=RHO*(EL(IQ1,IQ2,K)-EL0)/144.
      SUM1=SUM1+GMTB(J,KKK)*FAC
      SUM2=SUM2+GMTB(J,KKK)*FAC*(PP-GRAVITY(J,KKK))
 1205 GO TO 1169

C ******************** ITEQR = 2 **********************************
 1210 CONTINUE
      IF(KIP(J).EQ.2) PWFC(J,IQ3)=(SUM2-QVW(J))/SUM1
      IF(KIP(J).EQ.3) PWFC(J,IQ3)=(SUM2-QVG(J)*1000./5.615)/SUM1
      IF(KIP(J).EQ.1.AND.QVT(J).NE.0.) PWFC(J,IQ3)=(SUM2-QVT(J))/SUM1
      IF(KIP(J).EQ.1.AND.QVT(J).EQ.0.) PWFC(J,IQ3)=(SUM2-QVO(J))/SUM1
      PWFC(J,KKK)=PWFC(J,IQ3)+GRAVITY(J,KKK)
      FACTOR=5.615*PID(J,KKK)*(P(IQ1,IQ2,K)-PWFC(J,KKK))/RF(IQ1,IQ2,K)

      PPN=PN(IQ1,IQ2,K)
      BPT=PBOT(IQ1,IQ2,K)
      CALL INTPVT(BPT,BSLOPE,POT,BOT,MPOT,PPN,BBO)
      CALL INTERP(PWT,BWT,MPWT,PPN,BBW)
      CALL INTERP(PGT,BGT,MPGT,PPN,BBG)
      CALL INTPVT(BPT,RSLOPE,POT,RSOT,MPOT,PPN,RSO)
      CALL INTERP(PWT,RSWT,MPWT,PPN,RSW)
      IF(KIP(J).EQ.2)THEN
        QW(IQ1,IQ2,K)=GMTB(J,KKK)*FACTOR/BBW
        IF(ITFLAG.GT.0.AND.IWLCNG.EQ.0)
     &   QW(IQ1,IQ2,K)=(QW(IQ1,IQ2,K)+QW0(IQ1,IQ2,K))/2
       ENDIF
      IF(KIP(J).EQ.3)THEN
        QG(IQ1,IQ2,K)=GMTB(J,KKK)*FACTOR/BBG
        IF(ITFLAG.GT.0.AND.IWLCNG.EQ.0)
     &   QG(IQ1,IQ2,K)=(QG(IQ1,IQ2,K)+QG0(IQ1,IQ2,K))/2
       ENDIF
      IF(KIP(J).EQ.1) THEN
        QO(IQ1,IQ2,K)=GMO(J,KKK)/BBO*FACTOR
        QW(IQ1,IQ2,K)=GMW(J,KKK)/BBW*FACTOR
        QG(IQ1,IQ2,K)=GMG(J,KKK)/BBG*FACTOR
     &   +RSO*QO(IQ1,IQ2,K)+RSW*QW(IQ1,IQ2,K)
        IF(ITFLAG.GT.0.AND.IWLCNG.EQ.0)THEN
          QO(IQ1,IQ2,K)=(QO(IQ1,IQ2,K)+QO0(IQ1,IQ2,K))/2
          QW(IQ1,IQ2,K)=(QW(IQ1,IQ2,K)+QW0(IQ1,IQ2,K))/2
          QG(IQ1,IQ2,K)=(QG(IQ1,IQ2,K)+QG0(IQ1,IQ2,K))/2
         ENDIF 
       ENDIF
      GO TO 1169

C ******************************************** EXPLICIT PRESSURE CONSTRAINT
 1300 CONTINUE
C**** OIL PRODUCER
      IF(KIP(J).NE.-1) GO TO 1310
      QO(IQ1,IQ2,K)=PID(J,KKK)*5.615*GMO(J,KKK)/RF(IQ1,IQ2,K)
     & *(PPN-PWF(J,KKK))/BBO
      IF(PPN.LE.PWF(J,KKK)) QO(IQ1,IQ2,K)=0.0
      QW(IQ1,IQ2,K)=QO(IQ1,IQ2,K)*GMW(J,KKK)*BBO
     & /(BBW*GMO(J,KKK))
      QG(IQ1,IQ2,K)=QO(IQ1,IQ2,K)*(GMG(J,KKK)*BBO
     & /(BBG*GMO(J,KKK))+RSO)+RSW*QW(IQ1,IQ2,K)
      GO TO 1340
C**** WATER INJECTOR
 1310 IF(KIP(J).NE.-2) GO TO 1320
      QW(IQ1,IQ2,K)=PID(J,KKK)/RF(IQ1,IQ2,K)*5.615*(GMO(J,KKK)
     & +GMW(J,KKK)+GMG(J,KKK))*(PPN-PWF(J,KKK))/BBW
      IF(PPN.GE.PWF(J,KKK)) QW(IQ1,IQ2,K)=0.0
      GO TO 1340
C**** GAS INJECTOR
 1320 IF(KIP(J).NE.-3) GO TO 1340
      QG(IQ1,IQ2,K)=PID(J,KKK)/RF(IQ1,IQ2,K)*5.615*(GMO(J,KKK)
     & +GMW(J,KKK)+GMG(J,KKK))*(PPN-PWF(J,KKK))/BBG
      IF(PPN.GE.PWF(J,KKK)) QG(IQ1,IQ2,K)=0.0
 1340 CONTINUE
      DO 1168 K=IQ3,LAY
 1168 QG(IQ1,IQ2,K)=QG(IQ1,IQ2,K)+QG1(IQ1,IQ2,K)

 1169 CONTINUE
 1170 CONTINUE
      IF(ITERQ.EQ.1.AND.KIP(J).GT.0) GO TO 1172
  105 CONTINUE
      RETURN
      END
C
      SUBROUTINE SOLMAT(DIV1,D288,D144,N)
C
C=================================================================SOLMAT
C
C   COMPUTE PRESSURE EQUATION COEFFICENTS.
C
C=======================================================================
C
      INCLUDE 'MEOR.PAR' 
      REAL KROT,KRWT,KRGT,MUOT,MUWT,MUGT,KX,KY,KZ
      REAL MUO4,MUW4,MUG4,MUO5,MUW5,MUG5,MUO6,MUW6,MUG6
     &,KRO1,KRW1,KRG1,KRO2,KRW2,KRG2,KRO3,KRW3,KRG3
     &,MUO1,MUW1,MUG1,MUO2,MUW2,MUG2,MUO3,MUW3,MUG3
     &,KRO4,KRW4,KRG4,KRO5,KRW5,KRG5,KRO6,KRW6,KRG6
     &,MO1,MW1,MG1,MO2,MW2,MG2,MO3,MW3,MG3
     &,MO4,MW4,MG4,MO5,MW5,MG5,MO6,MW6,MG6
     &,MUO,MUW,MUG
C
      COMMON /IO/ NI,NO
      COMMON /NUMBER/ II,JJ,KK
      COMMON /CODE/ KSM1,KSN1,KCO1,NN,FACT1,FACT2,TMAX,KSOL,MITER,
     & OMEGA,TOL,TOL1,KSN,KSM,KCO,KTR,KCOFF,DSMAX,DPMAX,WORMAX,
     & GORMAX,PAMIN,PAMAX
      COMMON /BUBBLE/ PBO,VSLOPE,BSLOPE,RSLOPE,PMAXT,IREPRS,RHOROCK,
     & RHOSCO,RHOSCG,RHOSCW,MSAT,MPOT,MPWT,MPGT,PBOT(NX,NY,NZ)
      COMMON /COEF/ AW(NX,NY,NZ),AE(NX,NY,NZ),AN(NX,NY,NZ),
     & AS(NX,NY,NZ),AB(NX,NY,NZ),AT(NX,NY,NZ),E(NX,NY,NZ),B(NX,NY,NZ)
      COMMON /SARRAY/ PN(NX,NY,NZ),
     & SON(NX,NY,NZ),SWN(NX,NY,NZ),SGN(NX,NY,NZ),
     & SO1(NX,NY,NZ),SW1(NX,NY,NZ),SG1(NX,NY,NZ),
     & A1(NX,NY,NZ),A2(NX,NY,NZ),A3(NX,NY,NZ),
     & SUM(NX,NY,NZ),GAM(NX,NY,NZ),QS(NX,NY,NZ)
      COMMON /ELEV/ EL(NX,NY,NZ)
      COMMON /TRAN/ TX(NX+1,NY,NZ),TY(NX,NY+1,NZ),TZ(NX,NY,NZ+1)
      COMMON /PRTP/ P(NX,NY,NZ)
      COMMON /PRTS/ SO(NX,NY,NZ),SW(NX,NY,NZ),SG(NX,NY,NZ)
      COMMON /SPVT/ SAT(NTE),KROT(NTE),KRWT(NTE),KRGT(NTE),PCOWT(NTE),
     & PCGOT(NTE),POT(NTE),MUOT(NTE),BOT(NTE),BOPT(NTE),RSOT(NTE),RSOPT
     & (NTE),PWT(NTE),MUWT(NTE),BWT(NTE),BWPT(NTE),RSWT(NTE),RSWPT(NTE),
     & PGT(NTE),MUGT(NTE),BGT(NTE),BGPT(NTE),CRT(NTE)
      COMMON /VOLFAC/ BO(NX,NY,NZ),BW(NX,NY,NZ),BG(NX,NY,NZ)
      COMMON /RATE/ QO(NX,NY,NZ),QW(NX,NY,NZ),QG(NX,NY,NZ)
      COMMON /TERM1/ GOWT(NX,NY,NZ),GWWT(NX,NY,NZ),GGWT(NX,NY,NZ),
     & OW(NX+1,NY,NZ),OE(NX+1,NY,NZ),WW(NX+1,NY,NZ),WE(NX+1,NY,NZ),
     & OS(NX,NY+1,NZ),ON(NX,NY+1,NZ),WS(NX,NY+1,NZ),WN(NX,NY+1,NZ),
     & OT(NX,NY,NZ+1),OB(NX,NY,NZ+1),WT(NX,NY,NZ+1),WB(NX,NY,NZ+1)
      COMMON /TERM2/ QOWG(NX,NY,NZ)
      COMMON /COMPRS/ CT(NX,NY,NZ)
      COMMON /PORE/ VP(NX,NY,NZ),POR(NX,NY,NZ),PV
C      COMMON /VIS/ ALPHA1,ALPHA2,ALPHA3,BETA1,BETA2,BETA3,CGC,
C     & DTMUW(NX,NY,NZ)
      COMMON /SWTCH/ NGRSW,NTRSW,NRESTART,NGEL
      DATA RSO1,RSO2,RSO3,RSO4,RSO5,RSO6/6*0.0/
      DATA RSW1,RSW2,RSW3,RSW4,RSW5,RSW6/6*0.0/
C
      DO 200 K=1,KK
      DO 200 J=1,JJ
      DO 200 I=1,II
C
      PP=P(I,J,K)
      BPT=PBOT(I,J,K)
      CALL INTPVT(BPT,RSLOPE,POT,RSOT,MPOT,PP,RSO)
      CALL INTPVT(BPT,VSLOPE,POT,MUOT,MPOT,PP,MUO)
      CALL INTERP(PWT,RSWT,MPWT,PP,RSW)
      CALL INTERP(PWT,MUWT,MPWT,PP,MUW)
C      IF(NGEL.EQ.1)MUW=MUW+DTMUW(I,J,K)
      CALL INTERP(PGT,MUGT,MPGT,PP,MUG)
      SSO=SO(I,J,K)
      SSW=SW(I,J,K)
      SSG=SG(I,J,K)
      CALL INTERP(SAT,PCOWT,MSAT,SSW,PCOW)
      CALL INTERP(SAT,PCGOT,MSAT,SSG,PCGO)
C
      RO=(RHOSCO + RSO*RHOSCG)/BO(I,J,K)
      RW=(RHOSCW + RSW*RHOSCG)/BW(I,J,K)
      RG=RHOSCG/BG(I,J,K)
C
      IF(I.EQ.1)GO TO 115
      P1=P(I-1,J,K)
      BPT=PBOT(I-1,J,K)
      CALL INTPVT(BPT,RSLOPE,POT,RSOT,MPOT,P1,RSO1)
      CALL INTPVT(BPT,VSLOPE,POT,MUOT,MPOT,P1,MUO1)
      CALL INTERP(PWT,RSWT,MPWT,P1,RSW1)
      CALL INTERP(PWT,MUWT,MPWT,P1,MUW1)
C      IF(NGEL.EQ.1)MUW1=MUW1+DTMUW(I-1,J,K)
      CALL INTERP(PGT,MUGT,MPGT,P1,MUG1)
      SO1S=SO(I-1,J,K)
      SW1S=SW(I-1,J,K)
      SG1S=SG(I-1,J,K)
      CALL INTERP(SAT,PCOWT,MSAT,SW1S,PCOW1)
      CALL INTERP(SAT,PCGOT,MSAT,SG1S,PCGO1)
C
C
      RO1=(RHOSCO + RSO1*RHOSCG)/BO(I-1,J,K)
      RW1=(RHOSCW + RSW1*RHOSCG)/BW(I-1,J,K)
      RG1=RHOSCG/BG(I-1,J,K)
C
      FACT=-D288*(EL(I-1,J,K)-EL(I,J,K))
      GOW1=(RO1+RO)*FACT
      GWW1=(RW1+RW)*FACT + PCOW-PCOW1
      GGW1=(RG1+RG)*FACT + PCGO1-PCGO
C
      P11=P1-PP
      HO1=P11+GOW1
      HW1=P11+GWW1
      HG1=P11+GGW1
C
      IF(HO1.GE.0.)CALL INTERP(SAT,KROT,MSAT,SO1S,KRO1)
      IF(HO1.LT.0.)CALL INTERP(SAT,KROT,MSAT,SSO,KRO1)
      IF(HW1.GE.0.)CALL INTERP(SAT,KRWT,MSAT,SW1S,KRW1)
      IF(HW1.LT.0.)CALL INTERP(SAT,KRWT,MSAT,SSW,KRW1)
      IF(HG1.GE.0.)CALL INTERP(SAT,KRGT,MSAT,SG1S,KRG1)
      IF(HG1.LT.0.)CALL INTERP(SAT,KRGT,MSAT,SSG,KRG1)
      MO1=4.0*KRO1/((BO(I-1,J,K)+BO(I,J,K)) * (MUO1+MUO))
      MW1=4.0*KRW1/((BW(I-1,J,K)+BW(I,J,K)) * (MUW1+MUW))
      MG1=4.0*KRG1/((BG(I-1,J,K)+BG(I,J,K)) * (MUG1+MUG))
C
115   AOW=TX(I,J,K)*MO1
      AWW=TX(I,J,K)*MW1
      AGW=TX(I,J,K)*MG1
C
      IF(I.EQ.II)GO TO 125
      P2=P(I+1,J,K)
      BPT=PBOT(I+1,J,K)
      CALL INTPVT(BPT,RSLOPE,POT,RSOT,MPOT,P2,RSO2)
      CALL INTPVT(BPT,VSLOPE,POT,MUOT,MPOT,P2,MUO2)
      CALL INTERP(PWT,RSWT,MPWT,P2,RSW2)
      CALL INTERP(PWT,MUWT,MPWT,P2,MUW2)
C      IF(NGEL.EQ.1)MUW2=MUW2+DTMUW(I+1,J,K)
      CALL INTERP(PGT,MUGT,MPGT,P2,MUG2)
      SO2=SO(I+1,J,K)
      SW2=SW(I+1,J,K)
      SG2=SG(I+1,J,K)
      CALL INTERP(SAT,PCOWT,MSAT,SW2,PCOW2)
      CALL INTERP(SAT,PCGOT,MSAT,SG2,PCGO2)
C
      RO2=(RHOSCO + RSO2*RHOSCG)/BO(I+1,J,K)
      RW2=(RHOSCW + RSW2*RHOSCG)/BW(I+1,J,K)
      RG2=RHOSCG/BG(I+1,J,K)
C
      FACT=-D288*(EL(I+1,J,K)-EL(I,J,K))
      GOW2=(RO2+RO)*FACT
      GWW2=(RW2+RW)*FACT + PCOW-PCOW2
      GGW2=(RG2+RG)*FACT + PCGO2-PCGO
C
      P22=P2-PP
      HO2=P22+GOW2
      HW2=P22+GWW2
      HG2=P22+GGW2
      IF(HO2.GE.0.)CALL INTERP(SAT,KROT,MSAT,SO2,KRO2)
      IF(HO2.LT.0.)CALL INTERP(SAT,KROT,MSAT,SSO,KRO2)
      IF(HW2.GE.0.)CALL INTERP(SAT,KRWT,MSAT,SW2,KRW2)
      IF(HW2.LT.0.)CALL INTERP(SAT,KRWT,MSAT,SSW,KRW2)
      IF(HG2.GE.0.)CALL INTERP(SAT,KRGT,MSAT,SG2,KRG2)
      IF(HG2.LT.0.)CALL INTERP(SAT,KRGT,MSAT,SSG,KRG2)
      MO2=4.0*KRO2/((BO(I+1,J,K)+BO(I,J,K)) * (MUO2+MUO))
      MW2=4.0*KRW2/((BW(I+1,J,K)+BW(I,J,K)) * (MUW2+MUW))
      MG2=4.0*KRG2/((BG(I+1,J,K)+BG(I,J,K)) * (MUG2+MUG))
C
125   AOE=TX(I+1,J,K)*MO2
      AWE=TX(I+1,J,K)*MW2
      AGE=TX(I+1,J,K)*MG2
C
C
      IF(J.EQ.1)GO TO 135
      P3=P(I,J-1,K)
      BPT=PBOT(I,J-1,K)
      CALL INTPVT(BPT,RSLOPE,POT,RSOT,MPOT,P3,RSO3)
      CALL INTPVT(BPT,VSLOPE,POT,MUOT,MPOT,P3,MUO3)
      CALL INTERP(PWT,RSWT,MPWT,P3,RSW3)
      CALL INTERP(PWT,MUWT,MPWT,P3,MUW3)
C      IF(NGEL.EQ.1)MUW3=MUW3+DTMUW(I,J-1,K)
      CALL INTERP(PGT,MUGT,MPGT,P3,MUG3)
      SO3=SO(I,J-1,K)
      SW3=SW(I,J-1,K)
      SG3=SG(I,J-1,K)
      CALL INTERP(SAT,PCOWT,MSAT,SW3,PCOW3)
      CALL INTERP(SAT,PCGOT,MSAT,SG3,PCGO3)
C
      RO3=(RHOSCO + RSO3*RHOSCG)/BO(I,J-1,K)
      RW3=(RHOSCW + RSW3*RHOSCG)/BW(I,J-1,K)
      RG3=RHOSCG/BG(I,J-1,K)
C
      FACT=-D288*(EL(I,J-1,K)-EL(I,J,K))
      GOW3=(RO3+RO)*FACT
      GWW3=(RW3+RW)*FACT + PCOW-PCOW3
      GGW3=(RG3+RG)*FACT + PCGO3-PCGO
C
      P33=P3-PP
      HO3=P33+GOW3
      HW3=P33+GWW3
      HG3=P33+GGW3
      IF(HO3.GE.0.)CALL INTERP(SAT,KROT,MSAT,SO3,KRO3)
      IF(HO3.LT.0.)CALL INTERP(SAT,KROT,MSAT,SSO,KRO3)
      IF(HW3.GE.0.)CALL INTERP(SAT,KRWT,MSAT,SW3,KRW3)
      IF(HW3.LT.0.)CALL INTERP(SAT,KRWT,MSAT,SSW,KRW3)
      IF(HG3.GE.0.)CALL INTERP(SAT,KRGT,MSAT,SG3,KRG3)
      IF(HG3.LT.0.)CALL INTERP(SAT,KRGT,MSAT,SSG,KRG3)
      MO3=4.0*KRO3/((BO(I,J-1,K)+BO(I,J,K)) * (MUO3+MUO))
      MW3=4.0*KRW3/((BW(I,J-1,K)+BW(I,J,K)) * (MUW3+MUW))
      MG3=4.0*KRG3/((BG(I,J-1,K)+BG(I,J,K)) * (MUG3+MUG))
C
135   AOS=TY(I,J,K)*MO3
      AWS=TY(I,J,K)*MW3
      AGS=TY(I,J,K)*MG3
C
      IF(J.EQ.JJ)GO TO 140
      P4=P(I,J+1,K)
      BPT=PBOT(I,J+1,K)
      CALL INTPVT(BPT,RSLOPE,POT,RSOT,MPOT,P4,RSO4)
      CALL INTPVT(BPT,VSLOPE,POT,MUOT,MPOT,P4,MUO4)
      CALL INTERP(PWT,RSWT,MPWT,P4,RSW4)
      CALL INTERP(PWT,MUWT,MPWT,P4,MUW4)
C      IF(NGEL.EQ.1)MUW4=MUW4+DTMUW(I,J+1,K)
      CALL INTERP(PGT,MUGT,MPGT,P4,MUG4)
      SO4=SO(I,J+1,K)
      SW4=SW(I,J+1,K)
      SG4=SG(I,J+1,K)
      CALL INTERP(SAT,PCOWT,MSAT,SW4,PCOW4)
      CALL INTERP(SAT,PCGOT,MSAT,SG4,PCGO4)
C
      RO4=(RHOSCO + RSO4*RHOSCG)/BO(I,J+1,K)
      RW4=(RHOSCW + RSW4*RHOSCG)/BW(I,J+1,K)
      RG4=RHOSCG/BG(I,J+1,K)
C
      FACT=-D288*(EL(I,J+1,K)-EL(I,J,K))
      GOW4=(RO4+RO)*FACT
      GWW4=(RW4+RW)*FACT + PCOW-PCOW4
      GGW4=(RG4+RG)*FACT + PCGO4-PCGO
C
      P44=P4-PP
      HO4=P44+GOW4
      HW4=P44+GWW4
      HG4=P44+GGW4
      IF(HO4.GE.0.)CALL INTERP(SAT,KROT,MSAT,SO4,KRO4)
      IF(HO4.LT.0.)CALL INTERP(SAT,KROT,MSAT,SSO,KRO4)
      IF(HW4.GE.0.)CALL INTERP(SAT,KRWT,MSAT,SW4,KRW4)
      IF(HW4.LT.0.)CALL INTERP(SAT,KRWT,MSAT,SSW,KRW4)
      IF(HG4.GE.0.)CALL INTERP(SAT,KRGT,MSAT,SG4,KRG4)
      IF(HG4.LT.0.)CALL INTERP(SAT,KRGT,MSAT,SSG,KRG4)
      MO4=4.0*KRO4/((BO(I,J+1,K)+BO(I,J,K)) * (MUO4+MUO))
      MW4=4.0*KRW4/((BW(I,J+1,K)+BW(I,J,K)) * (MUW4+MUW))
      MG4=4.0*KRG4/((BG(I,J+1,K)+BG(I,J,K)) * (MUG4+MUG))
C
140   AON=TY(I,J+1,K)*MO4
      AWN=TY(I,J+1,K)*MW4
      AGN=TY(I,J+1,K)*MG4
C
C
      IF(K.EQ.1)GO TO 145
      P5=P(I,J,K-1)
      BPT=PBOT(I,J,K-1)
      CALL INTPVT(BPT,RSLOPE,POT,RSOT,MPOT,P5,RSO5)
      CALL INTPVT(BPT,VSLOPE,POT,MUOT,MPOT,P5,MUO5)
      CALL INTERP(PWT,RSWT,MPWT,P5,RSW5)
      CALL INTERP(PWT,MUWT,MPWT,P5,MUW5)
C      IF(NGEL.EQ.1)MUW5=MUW5+DTMUW(I,J,K-1)
      CALL INTERP(PGT,MUGT,MPGT,P5,MUG5)
      SO5=SO(I,J,K-1)
      SW5=SW(I,J,K-1)
      SG5=SG(I,J,K-1)
      CALL INTERP(SAT,PCOWT,MSAT,SW5,PCOW5)
      CALL INTERP(SAT,PCGOT,MSAT,SG5,PCGO5)
      RO5=(RHOSCO + RSO5*RHOSCG)/BO(I,J,K-1)
      RW5=(RHOSCW + RSW5*RHOSCG)/BW(I,J,K-1)
      RG5=RHOSCG/BG(I,J,K-1)
C
      FACT=-D288*(EL(I,J,K-1)-EL(I,J,K))
      GOW5=(RO5+RO)*FACT
      GWW5=(RW5+RW)*FACT + PCOW-PCOW5
      GGW5=(RG5+RG)*FACT + PCGO5-PCGO
      P55=P5-PP
      HO5=P55+GOW5
      HW5=P55+GWW5
      HG5=P55+GGW5
      IF(HO5.GE.0.)CALL INTERP(SAT,KROT,MSAT,SO5,KRO5)
      IF(HO5.LT.0.)CALL INTERP(SAT,KROT,MSAT,SSO,KRO5)
      IF(HW5.GE.0.)CALL INTERP(SAT,KRWT,MSAT,SW5,KRW5)
      IF(HW5.LT.0.)CALL INTERP(SAT,KRWT,MSAT,SSW,KRW5)
      IF(HG5.GE.0.)CALL INTERP(SAT,KRGT,MSAT,SG5,KRG5)
      IF(HG5.LT.0.)CALL INTERP(SAT,KRGT,MSAT,SSG,KRG5)
      MO5=4.0*KRO5/((BO(I,J,K-1)+BO(I,J,K)) * (MUO5+MUO))
      MW5=4.0*KRW5/((BW(I,J,K-1)+BW(I,J,K)) * (MUW5+MUW))
      MG5=4.0*KRG5/((BG(I,J,K-1)+BG(I,J,K)) * (MUG5+MUG))
C
C
145   AOT=TZ(I,J,K)*MO5
      AWT=TZ(I,J,K)*MW5
      AGT=TZ(I,J,K)*MG5
C
      IF(K.EQ.KK)GO TO 150
      P6=P(I,J,K+1)
      BPT=PBOT(I,J,K+1)
      CALL INTPVT(BPT,RSLOPE,POT,RSOT,MPOT,P6,RSO6)
      CALL INTPVT(BPT,VSLOPE,POT,MUOT,MPOT,P6,MUO6)
      CALL INTERP(PWT,RSWT,MPWT,P6,RSW6)
      CALL INTERP(PWT,MUWT,MPWT,P6,MUW6)
C      IF(NGEL.EQ.1)MUW6=MUW6+DTMUW(I,J,K+1)
      CALL INTERP(PGT,MUGT,MPGT,P6,MUG6)
      SO6=SO(I,J,K+1)
      SW6=SW(I,J,K+1)
      SG6=SG(I,J,K+1)
C
      CALL INTERP(SAT,PCOWT,MSAT,SW6,PCOW6)
      CALL INTERP(SAT,PCGOT,MSAT,SG6,PCGO6)
      RO6=(RHOSCO + RSO6*RHOSCG)/BO(I,J,K+1)
      RW6=(RHOSCW + RSW6*RHOSCG)/BW(I,J,K+1)
      RG6=RHOSCG/BG(I,J,K+1)
C
      FACT=-D288*(EL(I,J,K+1)-EL(I,J,K))
      GOW6=(RO6+RO)*FACT
      GWW6=(RW6+RW)*FACT + PCOW-PCOW6
      GGW6=(RG6+RG)*FACT + PCGO6-PCGO
C
      P66=P6-PP
      HO6=P66+GOW6
      HW6=P66+GWW6
      HG6=P66+GGW6
      IF(HO6.GE.0.)CALL INTERP(SAT,KROT,MSAT,SO6,KRO6)
      IF(HO6.LT.0.)CALL INTERP(SAT,KROT,MSAT,SSO,KRO6)
      IF(HW6.GE.0.)CALL INTERP(SAT,KRWT,MSAT,SW6,KRW6)
      IF(HW6.LT.0.)CALL INTERP(SAT,KRWT,MSAT,SSW,KRW6)
      IF(HG6.GE.0.)CALL INTERP(SAT,KRGT,MSAT,SG6,KRG6)
      IF(HG6.LT.0.)CALL INTERP(SAT,KRGT,MSAT,SSG,KRG6)
      MO6=4.0*KRO6/((BO(I,J,K+1)+BO(I,J,K)) * (MUO6+MUO))
      MW6=4.0*KRW6/((BW(I,J,K+1)+BW(I,J,K)) * (MUW6+MUW))
      MG6=4.0*KRG6/((BG(I,J,K+1)+BG(I,J,K)) * (MUG6+MUG))
C
150   AOB=TZ(I,J,K+1)*MO6
      AWB=TZ(I,J,K+1)*MW6
      AGB=TZ(I,J,K+1)*MG6
C
      RSO1A=0.5*(RSO1+RSO)
      RSO2A=0.5*(RSO2+RSO)
      RSO3A=0.5*(RSO3+RSO)
      RSO4A=0.5*(RSO4+RSO)
      RSO5A=0.5*(RSO5+RSO)
      RSO6A=0.5*(RSO6+RSO)
      RSW1A=0.5*(RSW1+RSW)
      RSW2A=0.5*(RSW2+RSW)
      RSW3A=0.5*(RSW3+RSW)
      RSW4A=0.5*(RSW4+RSW)
      RSW5A=0.5*(RSW5+RSW)
      RSW6A=0.5*(RSW6+RSW)
      AO1=AOW*GOW1
      AO2=AOE*GOW2
      AO3=AOS*GOW3
      AO4=AON*GOW4
      AO5=AOT*GOW5
      AO6=AOB*GOW6
      AW1=AWW*GWW1
      AW2=AWE*GWW2
      AW3=AWS*GWW3
      AW4=AWN*GWW4
      AW5=AWT*GWW5
      AW6=AWB*GWW6
C
      GOWT(I,J,K)= AO1 + AO2 + AO3 + AO4 + AO5 + AO6
      GWWT(I,J,K)= AW1 + AW2 + AW3 + AW4 + AW5 + AW6
      GGWT(I,J,K)=AGW*GGW1+AGE*GGW2+AGS*GGW3+AGN*GGW4+AGT*GGW5+AGB*GGW6
     &+RSO1A*AO1+RSO2A*AO2+RSO3A*AO3+RSO4A*AO4+RSO5A*AO5+RSO6A*AO6
     &+RSW1A*AW1+RSW2A*AW2+RSW3A*AW3+RSW4A*AW4+RSW5A*AW5+RSW6A*AW6
C
      QOWG(I,J,K)=(BO(I,J,K)-BG(I,J,K)*RSO)*(-GOWT(I,J,K)+QO(I,J,K)) +
     &           (BW(I,J,K)-BG(I,J,K)*RSW)*(-GWWT(I,J,K)+QW(I,J,K)) +
     &            BG(I,J,K)*(-GGWT(I,J,K)+QG(I,J,K))
C
      AW(I,J,K)=(BO(I,J,K) + 0.5*BG(I,J,K)*(RSO1-RSO)) * AOW +
     &         (BW(I,J,K) + 0.5*BG(I,J,K)*(RSW1-RSW)) * AWW +
     &          BG(I,J,K)*AGW
      AE(I,J,K)=(BO(I,J,K) + 0.5*BG(I,J,K)*(RSO2-RSO)) * AOE +
     &         (BW(I,J,K) + 0.5*BG(I,J,K)*(RSW2-RSW)) * AWE +
     &          BG(I,J,K)*AGE
      AS(I,J,K)=(BO(I,J,K) + 0.5*BG(I,J,K)*(RSO3-RSO)) * AOS +
     &         (BW(I,J,K) + 0.5*BG(I,J,K)*(RSW3-RSW)) * AWS +
     &          BG(I,J,K)*AGS
      AN(I,J,K)=(BO(I,J,K) + 0.5*BG(I,J,K)*(RSO4-RSO)) * AON +
     &         (BW(I,J,K) + 0.5*BG(I,J,K)*(RSW4-RSW)) * AWN +
     &          BG(I,J,K)*AGN
      AT(I,J,K)=(BO(I,J,K) + 0.5*BG(I,J,K)*(RSO5-RSO)) * AOT +
     &         (BW(I,J,K) + 0.5*BG(I,J,K)*(RSW5-RSW)) * AWT +
     &          BG(I,J,K)*AGT
      AB(I,J,K)=(BO(I,J,K) + 0.5*BG(I,J,K)*(RSO6-RSO)) * AOB +
     &         (BW(I,J,K) + 0.5*BG(I,J,K)*(RSW6-RSW)) * AWB +
     &          BG(I,J,K)*AGB
      OW(I,J,K)=AOW
      OE(I,J,K)=AOE
      OS(I,J,K)=AOS
      ON(I,J,K)=AON
      OT(I,J,K)=AOT
      OB(I,J,K)=AOB
      WW(I,J,K)=AWW
      WE(I,J,K)=AWE
      WS(I,J,K)=AWS
      WN(I,J,K)=AWN
      WT(I,J,K)=AWT
      WB(I,J,K)=AWB
      IF(KCOFF.EQ.0)GO TO 200
      WRITE(NO,33)
      WRITE(NO,2)I,J,K,MO1,MO2,MO3,MO4,MO5,MO6
      WRITE(NO,2)I,J,K,MW1,MW2,MW3,MW4,MW5,MW6
      WRITE(NO,2)I,J,K,MG1,MG2,MG3,MG4,MG5,MG6
      WRITE(NO,2)I,J,K,AOW,AOE,AOS,AON,AOT,AOB,BO(I,J,K),RSO
      WRITE(NO,2)I,J,K,AWW,AWE,AWS,AWN,AWT,AWB,BW(I,J,K),RSW
      WRITE(NO,2)I,J,K,AGW,AGE,AGS,AGN,AGT,AGB,BG(I,J,K)
      WRITE(NO,2)I,J,K,GOWT(I,J,K),QO(I,J,K),GWWT(I,J,K),QW(I,J,K),
     &            GGWT(I,J,K),QG(I,J,K),QOWG(I,J,K)
200   CONTINUE
C
C**** CALCULATE MAIN DIAGONAL AND RHS VECTOR
C
      DO 300 K=1,KK
      DO 300 J=1,JJ
      DO 300 I=1,II
C
      SUM(I,J,K)=AW(I,J,K)+AE(I,J,K)+AS(I,J,K)+AN(I,J,K)+
     &    AT(I,J,K)+AB(I,J,K)
      GAM(I,J,K)=VP(I,J,K)*CT(I,J,K)*DIV1
      E(I,J,K)=-SUM(I,J,K) - GAM(I,J,K)
      B(I,J,K)= QOWG(I,J,K) - GAM(I,J,K)*P(I,J,K)
300   CONTINUE
      IF(KSM1.EQ.0)RETURN
      IF(N.NE.1.AND.N.NE.NN.AND.N.NE.KSM)RETURN
      WRITE(NO,4)
      DO 404 K=1,KK
      DO 404 J=1,JJ
      DO 404 I=1,II
      WRITE(NO,2)I,J,K,AT(I,J,K),AS(I,J,K),AW(I,J,K),E(I,J,K),
     & AE(I,J,K)   ,AN(I,J,K),AB(I,J,K),B(I,J,K)
404   CONTINUE
4     FORMAT(//T3,'NODE      AT(I,J,K)     AS(I,J,K)      AW(I,J,K)',
     &'      E(I,J,K)     AE(I,J,K)      AN(I,J,K)      AB(I,J,K)',
     &'      B(I,J,K)'/)
2     FORMAT(1X,3I3,8E15.6)
33    FORMAT(//)
C
      RETURN
      END

      SUBROUTINE PRATEI(IWELTYPE,NVQN,NVQNH)
C
C==================================================================QRATE
C
C   COMPUTE WELL RATES WHEN RATE OR EXPLICIT PRESSURE CONSTRAIN
C   ACTIVATED;
C        PRATEI: REVISES PRESSURE EQUATION COEFFICENTS WHEN IMPLICIT
C                PRESSURE CONSTRAIN ACTIVATED;
C        PRATEO: COMPUTE RATES WHEN IMPLICIT PRESSURE CONSTRAIN
C                ACTIVATE.
C
C       (IWELTYPE = 1 FOR VERTICAL WELL, 2 FOR HORIZON./SLANT WELL)
C=====================================================================
C
      INCLUDE 'MEOR.PAR' 
      REAL KROT,KRWT,KRGT,MUWT,MUOT,MUGT
     & ,MUO,MUW,MUG,KRO,KRW,KRG
      COMMON /BUBBLE/ PBO,VSLOPE,BSLOPE,RSLOPE,PMAXT,IREPRS,RHOROCK,
     & RHOSCO,RHOSCG,RHOSCW,MSAT,MPOT,MPWT,MPGT,PBOT(NX,NY,NZ)
      COMMON /COEF/ AW(NX,NY,NZ),AE(NX,NY,NZ),AN(NX,NY,NZ),
     & AS(NX,NY,NZ),AB(NX,NY,NZ),AT(NX,NY,NZ),E(NX,NY,NZ),B(NX,NY,NZ)
      COMMON /SARRAY/ PN(NX,NY,NZ),
     & SON(NX,NY,NZ),SWN(NX,NY,NZ),SGN(NX,NY,NZ),
     & SO1(NX,NY,NZ),SW1(NX,NY,NZ),SG1(NX,NY,NZ),
     & A1(NX,NY,NZ),A2(NX,NY,NZ),A3(NX,NY,NZ),
     & SUM(NX,NY,NZ),GAM(NX,NY,NZ),QS(NX,NY,NZ)
      COMMON /SPVT/ SAT(NTE),KROT(NTE),KRWT(NTE),KRGT(NTE),PCOWT(NTE),
     & PCGOT(NTE),POT(NTE),MUOT(NTE),BOT(NTE),BOPT(NTE),RSOT(NTE),RSOPT
     & (NTE),PWT(NTE),MUWT(NTE),BWT(NTE),BWPT(NTE),RSWT(NTE),RSWPT(NTE),
     & PGT(NTE),MUGT(NTE),BGT(NTE),BGPT(NTE),CRT(NTE)
      COMMON /SRATE/ PID(NW,NL),PWF(NW,NL),PWFC(NW,NL),KIP(NW),
     & GMO(NW,NL),GMW(NW,NL),GMG(NW,NL),LAYER(NW),QVO(NW),
     & QVW(NW),QVG(NW),QVT(NW),CUMO(NW,NL),CUMW(NW,NL),CUMG(NW,NL)
      COMMON /IQN/ IQN1(NW),IQN2(NW),IQN3(NW)
      COMMON /IQH/ IQH1(NW,NL),IQH2(NW,NL),IQH3(NW,NL),COND(NW)
C      COMMON /ADSORB/ AA(5),BB(5),CL(5),GAMA(5),RF(NX,NY,NZ),RFT

      COMMON /MEORB/ C(NX,NY,NZC),SIGMA(NX,NY,NZ),RF(NX,NY,NZ),AKC,
     & AKD,AKY,AKS,AMUM,YIELD,RHOMIC,CQI(NW,NC),MAPWI(NX,NY,NZ),RFT
C
      IF(IWELTYPE.EQ.1)THEN
       N1=1
       N2=NVQN
      ELSE
       N1=NVQN+1
       N2=NVQN+NVQNH
      ENDIF
C
      DO 205 J=N1,N2
      IF(KIP(J).GE.-10) GO TO 205
      IF(IWELTYPE.EQ.1)THEN
       IQ1=IQN1(J)
       IQ2=IQN2(J)
       IQ3=IQN3(J)
       LAY=IQ3+(LAYER(J)-1)
      ELSE
       IQ3=1
       LAY=LAYER(J)
      ENDIF
      DO 203 KKK=IQ3,LAY
      K=KKK
      IF(IWELTYPE.EQ.2)THEN
       IQ1=IQH1(J,KKK)
       IQ2=IQH2(J,KKK)
       K=IQH3(J,KKK)
      ENDIF
      P56=PID(J,KKK)*5.615/RF(IQ1,IQ2,K)
      PPN=PN(IQ1,IQ2,K)
      BPT=PBOT(IQ1,IQ2,K)
      CALL INTPVT(BPT,BSLOPE,POT,BOT,MPOT,PPN,BBO)
      CALL INTPVT(BPT,RSLOPE,POT,RSOT,MPOT,PPN,RSO)
      CALL INTERP(PWT,BWT,MPWT,PPN,BBW)
      CALL INTERP(PGT,BGT,MPGT,PPN,BBG)
      CALL INTERP(PWT,RSWT,MPWT,PPN,RSW)
      CPIO=GMO(J,KKK)*P56*(BBO-BBG*RSO)/BBO
      CPIW=GMW(J,KKK)*P56*(BBW-BBG*RSW)/BBW
      CPIG=GMG(J,KKK)*P56
      CPI=CPIO+CPIW+CPIG
      B(IQ1,IQ2,K)=B(IQ1,IQ2,K)-CPI*PWF(J,KKK)
      E(IQ1,IQ2,K)=E(IQ1,IQ2,K)-CPI
  203 CONTINUE
  205 CONTINUE
      RETURN
      END
C
      SUBROUTINE PRATEO(IWELTYPE,NVQN,NVQNH)
C
C==================================================================QRATE
C
C   COMPUTE WELL RATES WHEN RATE OR EXPLICIT PRESSURE CONSTRAIN
C   ACTIVATED;
C        PRATEI: REVISES PRESSURE EQUATION COEFFICENTS WHEN IMPLICIT
C                PRESSURE CONSTRAIN ACTIVATED;
C        PRATEO: COMPUTE RATES WHEN IMPLICIT PRESSURE CONSTRAIN
C                ACTIVATE.
C
C        (IWELTYPE = 1 FOR VERTICAL WELL, 2 FOR HORIZON/SLANT WELL)
C=====================================================================
C
      INCLUDE 'MEOR.PAR' 
      REAL KROT,KRWT,KRGT,MUWT,MUOT,MUGT
     & ,MUO,MUW,MUG,KRO,KRW,KRG
      COMMON /BUBBLE/ PBO,VSLOPE,BSLOPE,RSLOPE,PMAXT,IREPRS,RHOROCK,
     & RHOSCO,RHOSCG,RHOSCW,MSAT,MPOT,MPWT,MPGT,PBOT(NX,NY,NZ)
      COMMON /COEF/ AW(NX,NY,NZ),AE(NX,NY,NZ),AN(NX,NY,NZ),
     & AS(NX,NY,NZ),AB(NX,NY,NZ),AT(NX,NY,NZ),E(NX,NY,NZ),B(NX,NY,NZ)
      COMMON /SARRAY/ PN(NX,NY,NZ),
     & SON(NX,NY,NZ),SWN(NX,NY,NZ),SGN(NX,NY,NZ),
     & SO1(NX,NY,NZ),SW1(NX,NY,NZ),SG1(NX,NY,NZ),
     & A1(NX,NY,NZ),A2(NX,NY,NZ),A3(NX,NY,NZ),
     & SUM(NX,NY,NZ),GAM(NX,NY,NZ),QS(NX,NY,NZ)
      COMMON /PRTP/ P(NX,NY,NZ)
      COMMON /SPVT/ SAT(NTE),KROT(NTE),KRWT(NTE),KRGT(NTE),PCOWT(NTE),
     & PCGOT(NTE),POT(NTE),MUOT(NTE),BOT(NTE),BOPT(NTE),RSOT(NTE),RSOPT
     & (NTE),PWT(NTE),MUWT(NTE),BWT(NTE),BWPT(NTE),RSWT(NTE),RSWPT(NTE),
     & PGT(NTE),MUGT(NTE),BGT(NTE),BGPT(NTE),CRT(NTE)
      COMMON /SRATE/ PID(NW,NL),PWF(NW,NL),PWFC(NW,NL),KIP(NW),
     & GMO(NW,NL),GMW(NW,NL),GMG(NW,NL),LAYER(NW),QVO(NW),
     & QVW(NW),QVG(NW),QVT(NW),CUMO(NW,NL),CUMW(NW,NL),CUMG(NW,NL)
      COMMON /VOLFAC/ BO(NX,NY,NZ),BW(NX,NY,NZ),BG(NX,NY,NZ)
      COMMON /RATE/ QO(NX,NY,NZ),QW(NX,NY,NZ),QG(NX,NY,NZ)
      COMMON /IQN/ IQN1(NW),IQN2(NW),IQN3(NW)
      COMMON /IQH/ IQH1(NW,NL),IQH2(NW,NL),IQH3(NW,NL),COND(NW)
C      COMMON /ADSORB/ AA(5),BB(5),CL(5),GAMA(5),RF(NX,NY,NZ),RFT

      COMMON /MEORB/ C(NX,NY,NZC),SIGMA(NX,NY,NZ),RF(NX,NY,NZ),AKC,
     & AKD,AKY,AKS,AMUM,YIELD,RHOMIC,CQI(NW,NC),MAPWI(NX,NY,NZ),RFT
C
      IF(IWELTYPE.EQ.1)THEN 
       N1=1
       N2=NVQN
      ELSE
       N1=NVQN+1
       N2=NVQN+NVQNH
      ENDIF
C
      DO 2059 J=N1,N2
      IF(KIP(J).GE.-10) GO TO 2059
      IF(IWELTYPE.EQ.1)THEN
       IQ1=IQN1(J)
       IQ2=IQN2(J)
       IQ3=IQN3(J)
       LAY=IQ3+(LAYER(J)-1)
      ELSE
       IQ3=1
       LAY=LAYER(J)
      ENDIF
      DO 2057 KKK=IQ3,LAY
      K=KKK
      IF(IWELTYPE.EQ.2)THEN
       IQ1=IQH1(J,KKK)
       IQ2=IQH2(J,KKK)
       K=IQH3(J,KKK)
      ENDIF
      PP=P(IQ1,IQ2,K)
      PPN=PN(IQ1,IQ2,K)
      BPT=PBOT(IQ1,IQ2,K)
      CALL INTPVT(BPT,RSLOPE,POT,RSOT,MPOT,PPN,RSON)
      CALL INTPVT(BPT,RSLOPE,POT,RSOT,MPOT,PP,RSO)
      CALL INTERP(PWT,RSWT,MPWT,PPN,RSWN)
      CALL INTERP(PWT,RSWT,MPWT,PP,RSW)
      RSOAV=0.5*(RSO+RSON)
      RSWAV=0.5*(RSW+RSWN)
      FACTOR=PID(J,KKK)*5.615*(PP-PWF(J,KKK))/RF(IQ1,IQ2,K)
      IF(KIP(J).EQ.-13) GO TO 2053
      QW(IQ1,IQ2,K)=GMW(J,KKK)/BW(IQ1,IQ2,K)*FACTOR
      IF(KIP(J).EQ.-12)QW(IQ1,IQ2,K)=
     & (GMO(J,KKK)+GMW(J,KKK)+GMG(J,KKK))/BW(IQ1,IQ2,K)*FACTOR
      IF(KIP(J).EQ.-12) GO TO 2057
      QO(IQ1,IQ2,K)=GMO(J,KKK)/BO(IQ1,IQ2,K)*FACTOR
      IF(FACTOR.LE.0.)QO(IQ1,IQ2,K)=0.
      QG(IQ1,IQ2,K)=GMG(J,KKK)/BG(IQ1,IQ2,K)*FACTOR
     & +RSOAV*QO(IQ1,IQ2,K)+RSWAV*QW(IQ1,IQ2,K)
      GO TO 2057
 2053 QG(IQ1,IQ2,K)=(GMO(J,KKK)+GMW(J,KKK)+GMG(J,KKK))
     & /BG(IQ1,IQ2,K)*FACTOR
 2057 CONTINUE
 2059 CONTINUE
      RETURN
      END
C
      SUBROUTINE MATBAL(DELT0,D5615)
C
C=================================================================MATBAL
C
C   COMPUTE SIMPLE MATERIAL BALANCE.
C
C=======================================================================
C
      INCLUDE 'MEOR.PAR' 
      REAL MBEO,MBEW,MBEG,KX,KY,KZ,MCFG,MCFG1,MCFGT,MCFGI,K1,K2
      COMMON /NUMBER/ II,JJ,KK
      COMMON /VOL/ SCFO,SCFW,SCFG,SCFG1,STBO,STBW,MCFG,MCFG1,MCFGT,
     & MCFGI,STBOI,STBWI,RESVOL
      COMMON /ADD2/ COP,CWP,CGP,CWI,CGI,CPOI,PVWI,POIR
      COMMON /MBE/ MBEO,MBEW,MBEG
      COMMON /SARRAY/ PN(NX,NY,NZ),
     & SON(NX,NY,NZ),SWN(NX,NY,NZ),SGN(NX,NY,NZ),
     & SO1(NX,NY,NZ),SW1(NX,NY,NZ),SG1(NX,NY,NZ),
     & A1(NX,NY,NZ),A2(NX,NY,NZ),A3(NX,NY,NZ),
     & SUM(NX,NY,NZ),GAM(NX,NY,NZ),QS(NX,NY,NZ)
      COMMON /PRTP/ P(NX,NY,NZ)
C      COMMON /GEL/ DDX,DDY,DDZ,K1,K2,NRX,C(NX,NY,NZC),
C     & UX(NX,NY,NZ),UY(NX,NY,NZ),UZ(NX,NY,NZ),MAPWI(NX,NY,NZ),
C     & CQI(NW,5),MORDER,FIPV(NZ,5),UW(NX,NY,NZ),UE(NX,NY,NZ),
C     & US(NX,NY,NZ),UN(NX,NY,NZ),UT(NX,NY,NZ),UB(NX,NY,NZ)
      COMMON /RATE/ QO(NX,NY,NZ),QW(NX,NY,NZ),QG(NX,NY,NZ)
      COMMON /PORE/ VP(NX,NY,NZ),POR(NX,NY,NZ),PV
      COMMON /BAL/ OP,WP,GP,WI,GI,PAVG0,PAVG,OPR,WPR,GPR,WIR,GIR,CWOR,
     & WOR,CGOR,GOR

      COMMON /MEORB/ C(NX,NY,NZC),SIGMA(NX,NY,NZ),RF(NX,NY,NZ),AKC,
     & AKD,AKY,AKS,AMUM,YIELD,RHOMIC,CQI(NW,NC),MAPWI(NX,NY,NZ),RFT
C
      FACT=D5615*DELT0
      PAVG0=0.0
      PAVG=0.0
      OP=0.0
      WP=0.0
      GP=0.0
      WI=0.0
      POI=0.0
      GI=0.0
      DO 100 K=1,KK
      DO 100 J=1,JJ
      DO 100 I=1,II
      PAVG0=PAVG0+PN(I,J,K)*VP(I,J,K)
      PAVG=PAVG+P(I,J,K)*VP(I,J,K)
      OP=OP+QO(I,J,K)*FACT
      IF(QW(I,J,K).GT.0.0)WP=WP+QW(I,J,K)*FACT
      IF(QW(I,J,K).LT.0.0)WI=WI-QW(I,J,K)*FACT
      IF(QG(I,J,K).GT.0.0)GP=GP+QG(I,J,K)*DELT0
      IF(QG(I,J,K).LT.0.0)GI=GI+QG(I,J,K)*DELT0
100   CONTINUE
      COP=COP+OP
      CWP=CWP+WP
      CGP=CGP+GP*.001
      CWI=CWI+WI
      CPOI=CPOI+POI*0.000001
      PVWI=CWI*5.615/PV
      CGI=CGI+GI*.001
C****CONVERT SCF TO MCF.
      GP=GP*.001
      GI=GI*.001
      DIV=1.0/DELT0
      OPR=OP*DIV*5.615
      WPR=WP*DIV*5.615
      GPR=GP*DIV
      WIR=WI*DIV
      POIR=POI*DIV*0.000001
      GIR=GI*DIV
      PAVG=PAVG/RESVOL
      PAVG0=PAVG0/RESVOL
C
      DENOM1=STBOI - OP
      IF(DENOM1.LT.1.E-7) GO TO 200
      MBEO=(STBO/(STBOI-OP) - 1.0)*100.0
 200  CONTINUE
      DENOM2=STBWI-WP-WI
      IF(DENOM2.LT.1.E-7) GO TO 201
      MBEW=(STBW/(STBWI-WP-WI) - 1.0)*100.0
 201  CONTINUE
      DENOM3=MCFGI-GP-GI
      IF(DENOM3.LT.1.E-7) GO TO 203
      MBEG=(MCFGT/(MCFGI-GP-GI) - 1.0)*100.0
 203  CONTINUE
C
      IF(OP.EQ.0.0)GOR=0.0
      IF(OP.EQ.0.0)WOR=0.0
      IF(OP.EQ.0.0)GO TO 333
      GOR=GP/OP
      WOR=WP/OP
333   IF(COP.EQ.0.0)CGOR=0.0
      IF(COP.EQ.0.0)CWOR=0.0
      IF(COP.EQ.0.0)GO TO 666
      CGOR=CGP/COP*1000.0
      CWOR=CWP/COP
666   CONTINUE
C
      GP=GP*0.001
      GI=GI*0.001
      RETURN
      END
      SUBROUTINE PRTPS(N,DELT0)
C
C==================================================================PRTPS
C
C   WRITE SUMMARY REPORT.
C
C======================================================================
C
      INCLUDE 'MEOR.PAR' 
      REAL MBEO,MBEW,MBEG,MCFG,MCFG1,MCFGT,MCFGI,K1,K2
      COMMON /IO/ NI,NO
      COMMON /ADD1/ IM,JM,KM,ETI,FT,FTMAX
      COMMON /ADD2/ COP,CWP,CGP,CWI,CGI,CPOI,PVWI,POIR
      COMMON /PSCNTL/ KPI,KSI
      COMMON /MBE/ MBEO,MBEW,MBEG
      COMMON /NUMBER/ II,JJ,KK
      COMMON /VOL/ SCFO,SCFW,SCFG,SCFG1,STBO,STBW,MCFG,MCFG1,MCFGT,
     & MCFGI,STBOI,STBWI,RESVOL
      COMMON /BAL/ OP,WP,GP,WI,GI,PAVG0,PAVG,OPR,WPR,GPR,WIR,GIR,CWOR,
     & WOR,CGOR,GOR
      COMMON /PRTCNT/ IWLCNG,ICHANG,IWLREP,ISUMRY,
     & IPMAP,ISOMAP,ISWMAP,ISGMAP,IPBMAP,ICHMAP,CHEMAP
      COMMON /BUBBLE/ PBO,VSLOPE,BSLOPE,RSLOPE,PMAXT,IREPRS,RHOROCK,
     & RHOSCO,RHOSCG,RHOSCW,MSAT,MPOT,MPWT,MPGT,PBOT(NX,NY,NZ)
      COMMON /SARRAY/ PN(NX,NY,NZ),
     & SON(NX,NY,NZ),SWN(NX,NY,NZ),SGN(NX,NY,NZ),
     & SO1(NX,NY,NZ),SW1(NX,NY,NZ),SG1(NX,NY,NZ),
     & A1(NX,NY,NZ),A2(NX,NY,NZ),A3(NX,NY,NZ),
     & SUM(NX,NY,NZ),GAM(NX,NY,NZ),QS(NX,NY,NZ)
      COMMON /PRTP/ P(NX,NY,NZ)
      COMMON /PRTS/ SO(NX,NY,NZ),SW(NX,NY,NZ),SG(NX,NY,NZ)
      COMMON /RATE/ QO(NX,NY,NZ),QW(NX,NY,NZ),QG(NX,NY,NZ)

      COMMON /MEORB/ C(NX,NY,NZC),SIGMA(NX,NY,NZ),RF(NX,NY,NZ),AKC,
     & AKD,AKY,AKS,AMUM,YIELD,RHOMIC,CQI(NW,NC),MAPWI(NX,NY,NZ),RFT
      COMMON /CONC/ CC(NX,NY,NZ),QG1(NX,NY,NZ)

C      COMMON /GEL/ DDX,DDY,DDZ,K1,K2,NRX,C(NX,NY,NZC),
C     & UX(NX,NY,NZ),UY(NX,NY,NZ),UZ(NX,NY,NZ),MAPWI(NX,NY,NZ),
C     & CQI(NW,5),MORDER,FIPV(NZ,5),UW(NX,NY,NZ),UE(NX,NY,NZ),
C     & US(NX,NY,NZ),UN(NX,NY,NZ),UT(NX,NY,NZ),UB(NX,NY,NZ)
      PPM=0.
      SOM=0.
      SWM=0.
      SGM=0.
      I1=II/10
      IF(I1.EQ.0)I1=1
      IF(N.EQ.1) GO TO 300
      DO 240 K=1,KK
      DO 240 J=1,JJ
      DO 240 I=1,II
      DPO=P(I,J,K)-PN(I,J,K)
      DSO=SO(I,J,K)-SON(I,J,K)
      DSW=SW(I,J,K)-SWN(I,J,K)
      DSG=SG(I,J,K)-SGN(I,J,K)
      IF(ABS(DPO).LE.ABS(PPM))GO TO 210
      PPM=DPO
      IPM=I
      JPM=J
      KPM=K
  210 IF(ABS(DSO).LE.ABS(SOM))GO TO 220
      SOM=DSO
      IOM=I
      JOM=J
      KOM=K
  220 IF(ABS(DSW).LE.ABS(SWM))GO TO 230
      SWM=DSW
      IWM=I
      JWM=J
      KWM=K
  230 IF(ABS(DSG).LE.ABS(SGM))GO TO 240
      SGM=DSG
      IGM=I
      JGM=J
      KGM=K
  240 CONTINUE
      WRITE(NO,5)
      WRITE(NO,105)
      WRITE(NO,6)
      NLM=N-1
      GORM=1000.*GOR
      WRITE(NO,110)ETI,NLM,DELT0,PAVG,PAVG0,IPM,JPM,KPM,PPM,
     & IOM,JOM,KOM,SOM,IGM,JGM,KGM,SGM,IWM,JWM,KWM,SWM,
     & MBEO,MBEG,MBEW,OPR,COP,GPR,CGP,WPR,CWP
      WRITE(NO,111) GIR,CGI,WIR,CWI,WOR,CWOR,GORM,CGOR
  110 FORMAT(/,1X,'ELAPSED TIME (DAYS)        =',F9.2,3X,
     & 'TIME STEP NUMBER            =',I5,7X,
     & 'TIME STEP SIZE (DAYS)       =',F9.2,//,1X,
     & 'CURRENT AVG RES PRESSURE    =',F9.1,3X,
     & 'PREVIOUS AVG RES PRESSURE    =',F9.1,3X,
     & 'PRESSURE DPMAX(',I3,',',I3,',',I3,')  =',F9.1,/,1X,
     & 'OIL DSMAX(',I3,',',I3,',',I3,')      =',E10.4,3X,
     & 'GAS DSMAX(',I3,',',I3,',',I3,')      =',E10.4,3X,
     & 'WATER DSMAX(',I3,',',I3,',',I3,')     =',E10.4,/,1X,
     & 'OIL MATERIAL BALANCE (%)    =',E10.4,3X,
     & 'GAS MATERIAL BALANCE (%)     =',E10.4,3X,
     & 'WATER MATERIAL BALANCE (%)   =',E10.4,//,1X,
     & 'OIL PRODUCTION RATE (STB/D) =',F9.1,3X,
     & 'CUM. OIL PRODUCTION (STB)    =',E10.4,/,1X,
     & 'GAS PRODUCTION RATE (MSCF/D)=',F9.1,3X,
     & 'CUM. GAS PRODUCTION (MSCF)   =',E10.4,/,1X,
     & 'WATER PRODUCTION RATE(STB/D)=',F9.1,3X,
     & 'CUM. WATER PRODUCTION (STB)  =',E10.4)
  111  FORMAT(/1X,'GAS INJECTION RATE (MSCF/D) =',F9.1,3X,
     & 'CUM. GAS INJECTION (MSCF)    =',E10.4,/,1X,
     & 'WATER INJECTION RATE (STB/D)=',F9.1,3X,
     & 'CUM. WATER INJECTION (STB)   =',E11.4,//,1X,
     & 'PRODUCING WOR (STB/STB)     =',F9.3,3X,
     & 'CUM. WOR (STB/STB)          =',F9.3,/,1X,
     & 'PRODUCING GOR (SCF/STB)     =',F9.0,3X,
     & 'CUM. GOR (SCF/STB)          =',F9.0,//)
  300 IF(N.EQ.1.AND.KPI.EQ.0) WRITE(NO,304)
  304 FORMAT(//T15,7('*'),' INITIAL ARRAYS ',7('*')//)
      IF(IPMAP.EQ.0.AND.N.NE.1)GO TO 315
      WRITE(NO,61)
      DO 310 K=1,KK
      WRITE(NO,51)K
      DO 310 J=1,JJ
      WRITE(NO,41)(P(I,J,K),I=1,II)
C      WRITE(NO,41)(P(I,J,K),I=1,II,I1),P(II,J,K)
  310   CONTINUE
C
  315 IF(ISOMAP.EQ.0.AND.N.NE.1)GO TO 422
      WRITE(NO,71)
      DO 420 K=1,KK
      WRITE(NO,51)K
      DO 420 J=1,JJ
      WRITE(NO,101)(SO(I,J,K),I=1,II)
C      WRITE(NO,101)(SO(I,J,K),I=1,II,I1),SO(II,J,K)
420   CONTINUE
C
  422 IF(ISWMAP.EQ.0.AND.N.NE.1)GO TO 432
      WRITE(NO,81)
      DO 430 K=1,KK
      WRITE(NO,51)K
      DO 430 J=1,JJ
      WRITE(NO,101)(SW(I,J,K),I=1,II)
C      WRITE(NO,101)(SW(I,J,K),I=1,II,I1),SW(II,J,K)
430   CONTINUE
C
  432 IF(ISGMAP.EQ.0.AND.N.NE.1)GO TO 4400
      WRITE(NO,91)
      DO 440 K=1,KK
      WRITE(NO,51)K
      DO 440 J=1,JJ
      WRITE(NO,101)(SG(I,J,K),I=1,II)
C      WRITE(NO,101)(SG(I,J,K),I=1,II,I1),SG(II,J,K)
  440 CONTINUE
C      DO 441 K=1,KK
C      DO 441 J=1,JJ
C      WRITE(NO,44)(QG1(I,J,K),I=1,II)
C      WRITE(NO,*)
C      WRITE(NO,44)(QG(I,J,K),I=1,II)
C  441 CONTINUE
4400  CONTINUE
      IF(IPBMAP.EQ.0)GO TO 4500
      WRITE(NO,102)
  102 FORMAT(//T15,'***** BUBBLE POINT PRESSURE DISTRIBUTION *****'/)
      DO 450 K=1,KK
      WRITE(NO,51)K
      DO 450 J=1,JJ
      WRITE(NO,41)(PBOT(I,J,K),I=1,II)
C      WRITE(NO,41)(PBOT(I,J,K),I=1,II,I1),PBOT(II,J,K)
  450 CONTINUE
4500  CONTINUE
      IF(ICHMAP.EQ.0)GO TO 4600
      WRITE(NO,103)
  103 FORMAT(//T15,'***** CHEMICAL CONCENTRATION DISTRIBUTION *****'/)
      DO 460 MC=1,2
       IF(MC.EQ.1)WRITE(NO,116)
       IF(MC.EQ.2)WRITE(NO,112)
      DO 460 K=(MC-1)*KK+1,MC*KK
      DO 460 J=1,JJ
       WRITE(NO,42)(C(I,J,K),I=1,II)
C       WRITE(NO,42)(C(I,J,K),I=1,II,I1),C(II,J,K)
  460 CONTINUE
      WRITE(NO,114)
      DO 470 K=1,KK
      DO 470 J=1,JJ
       WRITE(NO,43)(SIGMA(I,J,K),I=1,II)
C       WRITE(NO,43)(SIGMA(I,J,K),I=1,II,I1),SIGMA(II,J,K)
  470 CONTINUE

4600  CONTINUE
      IF(N.NE.1)WRITE(NO,7)
C
5     FORMAT(//T30,69('*'),/T30,'*',T98,'*'/T30,'*',T98,'*')
6     FORMAT(T30,'*',T98,'*'/T30,'*',T98,'*'/T30,69('*'),///)
7     FORMAT(///T5,54('*'),'  END OF REPORT  ',54('*'),6(/))
105   FORMAT(T30,'*',T45,'SUMMARY REPORT: MICROBIAL TRANSPORT
     & SIMULATION',T98,'*')
41    FORMAT(5X,20F6.0)
42    FORMAT(1X,11F11.3)
43    FORMAT(1X,11F11.4)
44    FORMAT(1X,10E12.2)
51    FORMAT(/1X,'K =',I2/)
61    FORMAT(//T15,'***** RESERVOIR PRESSURE DISTRIBUTION *****'/)
71    FORMAT(//T15,'*********  OIL SATURATION  *********'/)
81    FORMAT(//T15,'******** WATER SATURATION *********'/)
91    FORMAT(//T15,'*********  GAS SATURATION  *********'/)
101   FORMAT(5X,20F6.3)
116   FORMAT(//T5,'=== NUTRIENT CONCENTRATION (MG/ML) ==='/)
112   FORMAT(//T5,'=== MICROBE CONCENTRATION (MG/ML) ==='/)
114   FORMAT(//T5,'=== POROSITY REDUCTION (FRACTION) ==='/)
      RETURN
      END
      
      SUBROUTINE LSOR(DELT,DELT0,N)
C
C===================================================================LSOR
C
C     THIS PROGRAM SOLVES A LINEAR SYSTEM OF THREE-DIMENSIONAL FINITE-
C     DIFFERENCE EQUATIONS.
C     ( LINEAR SUCCESSIVE OVERRELAXATION METHOD )
C
C======================================================================
C
      INCLUDE 'MEOR.PAR' 
      COMMON /IO/ NI,NO
      COMMON /NUMBER/ II,JJ,KK
      COMMON /CODE/ KSM1,KSN1,KCO1,NN,FACT1,FACT2,TMAX,KSOL,MITER,
     & OMEGA,TOL,TOL1,KSN,KSM,KCO,KTR,KCOFF,DSMAX,DPMAX,WORMAX,
     & GORMAX,PAMIN,PAMAX
      COMMON /COEF/ AW(NX,NY,NZ),AE(NX,NY,NZ),AN(NX,NY,NZ),
     & AS(NX,NY,NZ),AB(NX,NY,NZ),AT(NX,NY,NZ),E(NX,NY,NZ),B(NX,NY,NZ)
      COMMON /PRTP/ P(NX,NY,NZ)
      DIMENSION UM(NX),AZL(NX),BZL(NX),CZL(NX),DZL(NX),UZL(NX)
C
      DIV=DELT/DELT0
      NITER=0
      DMAX=1.0
      RHO1=0.0
      THETA=0.0
C
   11 CONTINUE
      TW = 1.0 - OMEGA
      DMAX0=DMAX
      THETA0=THETA
      IF(NITER.GE.MITER)WRITE(NO,30)NITER,TOL,DMAX
      IF(NITER.GE.MITER)RETURN
      NITER = NITER +1
      DMAX=0.0
C
   2  DO 20 K=1,KK
      DO 20 J=1,JJ
      DO 15 I=1,II
      UM(I) = P(I,J,K)
C
27    AZL(I) = AW(I,J,K)
      BZL(I)=E(I,J,K)
      CZL(I)=AE(I,J,K)
      DZL(I)=B(I,J,K)
      IF(JJ.EQ.1) GO TO 14
      JM=J-1
      JP=J+1
      IF(J.EQ.1) JM=1
      IF(J.EQ.JJ) JP=JJ
      DZL(I)=DZL(I) - AS(I,J,K)*P(I,JM,K) - AN(I,J,K)*P(I,JP,K)
   14 IF(KK.EQ.1) GO TO 15
      KM=K-1
      KP=K+1
      IF(K.EQ.1)KM=1
      IF(K.EQ.KK) KP=KK
      DZL(I)=DZL(I) - AT(I,J,K)*P(I,J,KM) - AB(I,J,K)*P(I,J,KP)
15    CONTINUE
C
      CALL LTRI(II,AZL,BZL,CZL,DZL,UZL)
C
      DO 16 I=1,II
      GSLSOR=UZL(I)
      P(I,J,K) = TW*UM(I) + OMEGA*GSLSOR
      ARG=P(I,J,K) - UM(I)
      DM=ABS(ARG)
      IF(DM.GT.DMAX) DMAX = DM
16    CONTINUE
C
20    CONTINUE
   3  IF(TOL1.EQ.0.0)GO TO 25
      THETA=DMAX/DMAX0
      DELTA=THETA-THETA0
      ARG=DELTA
      ARG=ABS(ARG)
      IF(ARG.GT.TOL1)GO TO 25
      OM=OMEGA-1.0
      RHO1=(THETA+OM)*(THETA+OM)/(THETA*OMEGA*OMEGA)
      IF(RHO1.GE.1.0)GO TO 25
      ARG=1.0-RHO1
      OMEGA=2.0/(1.0+SQRT(ARG))
C
25    IF(DMAX.GT.TOL)GO TO 11
      IF(N.NE.KSN) GO TO 300
      WRITE(NO,40)NITER,OMEGA,DMAX,THETA,RHO1
 300  CONTINUE
40    FORMAT(T5,'CONVERGENCE(LSOR)  HAS BEEN REACHED AFTER ',I3,
     &' ITERATIONS',5X,'OMEGA = ',F6.3/
     &T5,'DMAX = ',F10.6,5X,'THETA = ',F10.6,5X,'RHO1 = ',F10.6/)
30    FORMAT(T15,'CONVERGENCE(LSOR)  WAS NOT REACHED IN ',I5,
     &' ITERATIONS'/T15,'TOL = ',F10.7,10X,'DMAX = ',F15.7)
C
      RETURN
      END
      SUBROUTINE LTRI(N,A,BI,C,D,X)
C
C===================================================================LTRI
C
C     THIS PR0GRAM SOLVES THE TRIDIAGONAL SYSTEM
C     GENERATED BY THE SYSTEM OF N EQUATIONS
C
C     A(I)*U(I-1) + BI(I)*U(I) + C(I)*U(I+1) = D(I)
C
C=======================================================================
C
      INCLUDE 'MEOR.PAR' 
      DIMENSION A(NX),BI(NX),C(NX),D(NX),
     & X(NX),BETA(NX),GAMMA(NX),W(NX)
      BETA(1)=BI(1)
      GAMMA(1)=D(1)/BI(1)
      NM=N-1
C      COMPUTE FORWARD SOLUTION.
      DO 10 I=1,NM
      W(I)=C(I)/BETA(I)
      IP=I+1
   10 BETA(IP)=BI(IP)-A(IP)*W(I)
      DO 20 I=2,N
      IM=I-1
   20 GAMMA(I)=(D(I)-A(I)*GAMMA(IM))/BETA(I)
C      COMPUTE BACK SOLUTION
      X(N)=GAMMA(N)
      DO 30 J=1,NM
      I=N-J
      IP=I+1
   30 X(I)=GAMMA(I)-W(I)*X(IP)
      RETURN
      END
C
C
C
      SUBROUTINE GRINT
C
C======================================================GRINT
C
C   READS DATA FOR GRAPHICS INITIALIZATION PURPOSES.
C
C===========================================================
C
      INCLUDE 'MEOR.PAR' 
      CHARACTER*2 TITLE(80),FNAME,MNAME,TAG
      CHARACTER*4 LNAME
      COMMON /CHRCTR/ FNAME,MNAME(NUM),LNAME,TAG
      COMMON /TTEST/ NUMPRD,SONTVL
      COMMON /IO/ NI,NO
      COMMON /COUNT/ N1READ,N2READ
      READ(NI,69) (TITLE(IH),IH=1,40)
      N1READ=N1READ+1
  69  FORMAT(40A2)
      READ(NI,70) TAG
      N1READ=N1READ+1
  70  FORMAT(A2)
      READ(NI,*) SONTVL
      N1READ=N1READ+1
      RETURN
      END
C
C
C
      SUBROUTINE GRPHCS
C
C=====================================================GRPHCS
C
C   WRITES THE OIL SATURATION FILES.
C
C===========================================================
C
      INCLUDE 'MEOR.PAR' 
      CHARACTER*2 FNAME,MNAME,TAG
      CHARACTER*4 LNAME
      CHARACTER*10 TNAME
      COMMON /CHRCTR/ FNAME,MNAME(NUM),LNAME,TAG
      COMMON /TTEST/ NUMPRD,SONTVL
      COMMON /IO2/ NO2
      COMMON /NUMBER/ II,JJ,KK
      COMMON /PRTS/ SO(NX,NY,NZ),SW(NX,NY,NZ),SG(NX,NY,NZ)
      TNAME=TAG//(FNAME//(MNAME(NUMPRD)//LNAME))
      OPEN(NO2,FILE=TNAME,STATUS='UNKNOWN')
      DO 10 K=1,KK
      DO 10 J=1,JJ
      WRITE(NO2,20) (SO(I,J,K),I=1,II)
  20  FORMAT(10F7.3)
  10  CONTINUE
      CLOSE(NO2,STATUS='KEEP')
      NUMPRD=NUMPRD+1
      RETURN
      END
C
C
C
      SUBROUTINE SHALE
C
C========================================================SHALE
C
C    ALLOWS BROAD ZEROING OF TRANSMISSIBILITIES FOR THE
C    PURPOSE OF SIMULATING SHALES.
C
C=============================================================
C
      INCLUDE 'MEOR.PAR' 
      CHARACTER*2 TITLE(80)
      COMMON /IO/ NI,NO
      COMMON /TRAN/ TX(NX+1,NY,NZ),TY(NX,NY+1,NZ),TZ(NX,NY,NZ+1)
      COMMON /NUMBER/ II,JJ,KK
      COMMON /COUNT/ N1READ,N2READ
      READ(NI,69) (TITLE(IH),IH=1,40)
      N1READ=N1READ+1
  69  FORMAT(40A2)
      READ(NI,*) NSHOPS
      N1READ=N1READ+1
      READ(NI,*) NTLAYR
      N1READ=N1READ+1
      IF(NSHOPS.EQ.1) THEN
      DO 1 LZ=1,NTLAYR
      READ(NI,*) KT
      N1READ=N1READ+1
      DO 1 JLZ=1,JJ
      DO 1 ILZ=1,II
      TZ(ILZ,JLZ,KT)=0.0
  1   CONTINUE
      ELSE
      DO 2 LZ=1,NTLAYR
      READ(NI,*) KT,NUTM
      N1READ=N1READ+1
      DO 2 LZF=1,NUTM
      READ(NI,*) IGBL
      N1READ=N1READ+1
      DO 2 JLZ=1,JJ
      TZ(IGBL,JLZ,KT)=0.0
  2   CONTINUE
      ENDIF
      RETURN
      END
C
      SUBROUTINE SLANT(NVQN,NVQNH,NVQNS)
C
C=================================================================SLANT
C
C   READ WELL INFORMATION AND CALCULATE PRODUCTIVITY INDEX FOR EACH
C     WELL BLOCK
C
C   (NVQN, NVQNH, NVQNS ARE # OF VERTICAL, HORIZON., & SLANT WELL)
C=======================================================================
C
C   TWO SLANT WELL OPTIONS ARE AVAILABLE :
C        OPTION 1 -- X,Y,Z COORDINATES OF STARTING WELLBLOCK, 
C                    WELL LENGTH, VERTICAL & HORIZONTAL ANGLES
C        OPTION 2 -- X,Y,Z COORDINATES OF STARTING WELLBLOCK
C                    AND X,Y,Z COORDINATES OF ENDING WELLBLOCK
C
      INCLUDE 'MEOR.PAR' 
      REAL KX,KY,KZ,KXN,KYN,KZN,K1,K2
      CHARACTER*5 WELLID
      DIMENSION ELS(NZ),PNS(NZ)
      COMMON /IO/ NI,NO
      COMMON /SWTCH/ NGRSW,NTRSW,NRESTART,NGEL
      COMMON /IDEN/ WELLID(NW)
      COMMON /SRATE/ PID(NW,NL),PWF(NW,NL),PWFC(NW,NL),KIP(NW),
     & GMO(NW,NL),GMW(NW,NL),GMG(NW,NL),LAYER(NW),QVO(NW),
     & QVW(NW),QVG(NW),QVT(NW),CUMO(NW,NL),CUMW(NW,NL),CUMG(NW,NL)
      COMMON /IQN/ IQN1(NW),IQN2(NW),IQN3(NW)
      COMMON /IQH/ IQH1(NW,NL),IQH2(NW,NL),IQH3(NW,NL),COND(NW)
      COMMON /PERM/ KX(NX,NY,NZ),KY(NX,NY,NZ),KZ(NX,NY,NZ)
      COMMON /VECTOR/ DX(NX,NY,NZ),DY(NX,NY,NZ),DZ(NX,NY,NZ)
      COMMON /NUMBER/ II,JJ,KK
      COMMON /PORE/ VP(NX,NY,NZ),POR(NX,NY,NZ),PV
      COMMON /R1XYZ/ R11X,R21X,R31X,R41X,R11Y,R21Y,R31Y,R41Y,
     & R11Z,R21Z,R31Z,R41Z
      COMMON /T1XYZ/ T1X,T2X,T3X,T4X,T1Y,T2Y,T3Y,T4Y,T1Z,T2Z,T3Z,T4Z
      COMMON /DXYZ/ DX0,DXP,DXM,XW,DY0,DYP,DYM,YW,DZ0,DZP,DZM,ZW
      COMMON /RXYZ/ RX,RY,RZ,AX,AY,AZ,I,J,K
      COMMON /TRAN/ TX(NX+1,NY,NZ),TY(NX,NY+1,NZ),TZ(NX,NY,NZ+1)
      COMMON /ELEV/ EL(NX,NY,NZ)
      COMMON /SARRAY/ PN(NX,NY,NZ),
     & SON(NX,NY,NZ),SWN(NX,NY,NZ),SGN(NX,NY,NZ),
     & SO1(NX,NY,NZ),SW1(NX,NY,NZ),SG1(NX,NY,NZ),
     & A1(NX,NY,NZ),A2(NX,NY,NZ),A3(NX,NY,NZ),
     & SUM(NX,NY,NZ),GAM(NX,NY,NZ),QS(NX,NY,NZ)

      COMMON /MEORB/ C(NX,NY,NZC),SIGMA(NX,NY,NZ),RF(NX,NY,NZ),AKC,
     & AKD,AKY,AKS,AMUM,YIELD,RHOMIC,CQI(NW,NC),MAPWI(NX,NY,NZ),RFT

C      COMMON /GEL/ DDX,DDY,DDZ,K1,K2,NRX,C(NX,NY,NZC),
C     & UX(NX,NY,NZ),UY(NX,NY,NZ),UZ(NX,NY,NZ),MAPWI(NX,NY,NZ),
C     & CQI(NW,5),MORDER,FIPV(NZ,5),UW(NX,NY,NZ),UE(NX,NY,NZ),
C     & US(NX,NY,NZ),UN(NX,NY,NZ),UT(NX,NY,NZ),UB(NX,NY,NZ)
C
       WRITE(NO,607)
       WRITE(NO,608)
       N1=NVQN+NVQNH+1
       N2=NVQN+NVQNH+NVQNS
C
       DO 1001 N=N1,N2
       M=0
       SUMPID=0.
       READ(NI,10) WELLID(N)
 10    FORMAT(A5)
       READ(NI,*)IFLAG,KIP(N),QVO(N),QVW(N),QVG(N),QVT(N),COND(N)
       IF(IFLAG.EQ.1)THEN
         READ(NI,*)IS,JS,KS,WELENGTH,THETA,ALPHA,IS1,JS1,KS1
        ELSE
         READ(NI,*)IS,JS,KS,IE,JE,KE,IS1,JS1,KS1
        ENDIF
       READ(NI,*)RW,S,PWF(N,1),JFLAG
       IF(IFLAG.EQ.1)GO TO 108
C ***** CALCULATE WELENGTH, THETA, ALPHA FOR SLANT WELL OPTION 2
        ISTEP=1
        JSTEP=1
        KSTEP=1
        IF(IS.GT.IE)ISTEP=-1
        IF(JS.GT.JE)JSTEP=-1
        IF(KS.GT.KE)KSTEP=-1
        DXWEL=0.
        DYWEL=0.
        DZWEL=0.
        DO 102 I=IS,IE,ISTEP
 102    DXWEL=DXWEL+DX(I,JS,KS)
        DO 104 J=JS,JE,JSTEP
 104    DYWEL=DYWEL+DY(IS,J,KS)
        DO 106 K=KS,KE,KSTEP
 106    DZWEL=DZWEL+DZ(IS,JS,K)
        WELSUM=0.
        IF(IS.NE.IE)WELSUM=WELSUM+DXWEL**2
        IF(JS.NE.JE)WELSUM=WELSUM+DYWEL**2
        IF(KS.NE.KE)WELSUM=WELSUM+DZWEL**2
        WELENGTH=WELSUM**.5
        IF(WELENGTH.EQ.0.)WELENGTH=DZ(IS,JS,KS)
        THETA=ACOS(KSTEP*DZWEL/WELENGTH)*180./3.1416
        ALPHA=ATAN(-ISTEP*JSTEP*DYWEL/DXWEL)*180./3.1416 
        IF(ALPHA.LT.0.)ALPHA=ALPHA+180.
        IF(JSTEP.EQ.1)ALPHA=ALPHA+180.
C
       IF(KS.EQ.KE)THETA=90.
       IF(IS.EQ.IE.AND.JS.EQ.JE.AND.KS.LE.KE)THETA=0.
       IF(IS.EQ.IE.AND.JS.EQ.JE.AND.KS.GT.KE)THETA=180.
       IF(JS.EQ.JE.AND.IS.LE.IE)ALPHA=0.
       IF(JS.EQ.JE.AND.IS.GT.IE)ALPHA=180.
       IF(IS.EQ.IE.AND.JS.LT.JE)ALPHA=270.
       IF(IS.EQ.IE.AND.JS.GT.JE)ALPHA=90.
C ***** DETERMINE THE WELL DIRECTION IN (I,J,K) COORDINATE
 108   IF(THETA.LT.90.)KD=1
       IF(THETA.EQ.90.)KD=0
       IF(THETA.GT.90.)KD=-1
       IF(ALPHA.NE.0.) GO TO 110
       ID=1
       JD=0
       IF(THETA.EQ.0.OR.THETA.EQ.180.)ID=0
 110   IF(ALPHA.NE.90)GO TO 120
       ID=0
       JD=-1
       IF(THETA.EQ.0.OR.THETA.EQ.180.)JD=0
 120   IF(ALPHA.NE.180)GO TO 130
       ID=-1
       JD=0
       IF(THETA.EQ.0.OR.THETA.EQ.180.)ID=0
 130   IF(ALPHA.NE.270)GO TO 140
       ID=0
       JD=1
       IF(THETA.EQ.0.OR.THETA.EQ.180.)JD=0
 140   IF(ALPHA.LE.0.OR.ALPHA.GE.90)GO TO 150
       ID=1
       JD=-1
 150   IF(ALPHA.LE.90.OR.ALPHA.GE.180)GO TO 160
       ID=-1
       JD=-1
 160   IF(ALPHA.LE.180.OR.ALPHA.GE.270)GO TO 170
       ID=-1
       JD=1
 170   IF(ALPHA.LE.270.OR.ALPHA.GE.360)GO TO 180
       ID=1
       JD=1
C  **** DEFINE THE STARTING WELL COORDINATE
 180   RL=WELENGTH
       DXI=DX(IS,JS,KS)
       DYI=DY(IS,JS,KS)
       DZI=DZ(IS,JS,KS)
       TG=THETA*3.1416/180.
       AG=ALPHA*3.1416/180.
       I=IS
       J=JS
       K=KS
C ***** 
       DP=PN(I,J,K)-PWF(N,1)
       DO 190 NK=1,KK
        ELS(NK)=EL(I,J,NK)
        PNS(NK)=PN(I,J,NK)
 190   CONTINUE  
C ***** LOOP TO CALCULATE PID VALUE IN Mth WELL BLOCK ********
 210   M=M+1
       LAYER(N)=M
       MAPWI(I,J,K)=N
       KXN=1
       KYN=1
       KZN=1
C       KYN=KY(I,J,K)/KX(I,J,K)
C       KZN=KZ(I,J,K)/KX(I,J,K)
       DX0=DX(I,J,K)
       DY0=DY(I,J,K)
       DZ0=DZ(I,J,K)
       RLX=0.
       RLY=0.
       RLZ=0.
       IF(ID.NE.0.AND.TG.NE.0.) RLX=ABS(DXI/(SIN(TG)*COS(AG)))
       IF(JD.NE.0.AND.TG.NE.0..AND.AG.NE.0.)
     &  RLY=ABS(DYI/(SIN(TG)*SIN(AG)))
       IF(KD.NE.0) RLZ=ABS(DZI/COS(TG))
C  **** CALCULATE THE X,Y,Z COMPONENT OF WELL LENGTH WITHIN WELL BLOCK
       RMIN=99999.
       IF(RLX.NE.0.AND.ABS(RLX).LT.RMIN) RMIN=RLX
       IF(RLY.NE.0.AND.ABS(RLY).LT.RMIN) RMIN=RLY
       IF(RLZ.NE.0.AND.ABS(RLZ).LT.RMIN) RMIN=RLZ
       DXX=ABS(RMIN*SIN(TG)*COS(AG))
       DYY=ABS(RMIN*SIN(TG)*SIN(AG))
       DZZ=ABS(RMIN*COS(TG))
       DL=(DXX*DXX+DYY*DYY+DZZ*DZZ)**.5
       IF(RL.GT.DL)GO TO 250
       DXX=DXX*RL/DL
       DYY=DYY*RL/DL
       DZZ=DZZ*RL/DL
       DL=RL
 250   IS2=0
       JS2=0
       KS2=0
       IF(ID.EQ.0)IS2=1
       IF(ID.EQ.1.AND.I.GE.IS1)IS2=1
       IF(ID.EQ.-1.AND.I.LE.IS1)IS2=1
       IF(JD.EQ.0)JS2=1
       IF(JD.EQ.1.AND.J.GE.JS1)JS2=1
       IF(JD.EQ.-1.AND.J.LE.JS1)JS2=1
       IF(KD.EQ.0)KS2=1
       IF(KD.EQ.1.AND.K.GE.KS1)KS2=1
       IF(KD.EQ.-1.AND.K.LE.KS1)KS2=1
       IF((IS2*JS2*KS2).EQ.1)GO TO 300
C 250   IS2=(I-IE)*(I-IS1)
C       JS2=(J-JE)*(J-JS1)
C       KS2=(K-KE)*(K-KS1)
C       IF(IS2.LE.0.AND.JS2.LE.0.AND.KS2.LE.0)GO TO 300
       M=M-1
       LAYER(N)=M
       GO TO 890
C ***** CONSTANT WELLBORE PRESSURE IF JFLAG = 1, OR 
C       CLACULATE WELLBORE PRESSURE FROM PWF(N,1) AND HYDROLIC GRADIENT 
 300    IF(KIP(N).GT.0.OR.JFLAG.EQ.1)THEN
         PWF(N,M)=PWF(N,1)
        ELSE
         ELSW=EL(I,J,K)+KD*(DZ(I,J,K)/2+DZZ/2-DZI)
         CALL INTERP(ELS,PNS,KK,ELSW,PWFS)
         PWF(N,M)=PWFS-DP
        ENDIF
C
C ***** PID CALCULATION STARTS --- BASED ON ABOU-KASSEM'S PAPER 
C       WHICH CALCULATES PID IN ONE DIRECTION (SPEJ 8/85) ......
       XW=ID*(DX(I,J,K)/2-(DXI-DXX/2))
       YW=JD*(DY(I,J,K)/2-(DYI-DYY/2))
       ZW=KD*(DZ(I,J,K)/2-(DZI-DZZ/2))
       IF(DXX.LT.DXI.AND.RLX.GT.RMIN)
     &  XW=XW+ID*(RLX-RMIN)*SIN(TG)*COS(AG)
       IF(DYY.LT.DYI.AND.RLY.GT.RMIN)
     &  YW=YW+JD*(RLY-RMIN)*SIN(TG)*SIN(AG)       
       IF(DXX.LT.DXI.AND.RLX.GT.RMIN)
     &  ZW=ZW+KD*(RLZ-RMIN)*COS(TG)
  
C ****  COUNT THE NUMBER OF BOUNDARY THIS WELL BLOCK HAS
       NBOUND=0
       IF(I.EQ.1)THEN
        T1Y=0.
        T4Z=0.
        NBOUND=NBOUND+1
       ELSE
        DXM=(DX(I,J,K)+DX(I-1,J,K))/2
        T1Y=DZ0/DXM*KXN
        T4Z=DY0/DXM*KXN
C        T1Y=TX(I,J,K)
C        T4Z=TX(I,J,K)
       ENDIF
       IF(J.EQ.1)THEN
        NBOUND=NBOUND+1
        T4X=0.
        T1Z=0.
       ELSE
        DYM=(DY(I,J,K)+DY(I,J-1,K))/2
        T4X=DZ0/DYM*KYN
        T1Z=DX0/DYM*KYN
C        T4X=TY(I,J,K)
C        T1Z=TY(I,J,K)
       ENDIF
       IF(K.EQ.1)THEN
        NBOUND=NBOUND+1
        T1X=0.
        T4Y=0.
       ELSE
        DZM=(DZ(I,J,K)+DZ(I,J,K-1))/2
        T1X=DY0/DZM*KZN
        T4Y=DX0/DZM*KZN
C        T1X=TZ(I,J,K)
C        T4Y=TZ(I,J,K)
       ENDIF
       IF(I.EQ.II)THEN
        NBOUND=NBOUND+1
        T3Y=0.
        T2Z=0.
       ELSE
        DXP=(DX(I,J,K)+DX(I+1,J,K))/2
        T3Y=DZ0/DXP*KXN
        T2Z=DY0/DXP*KXN
C        T3Y=TX(I+1,J,K)
C        T2Z=TX(I+1,J,K)
       ENDIF
       IF(J.EQ.JJ)THEN
        NBOUND=NBOUND+1
        T2X=0.
        T3Z=0.
       ELSE
        DYP=(DY(I,J,K)+DY(I,J+1,K))/2
        T2X=DZ0/DYP*KYN
        T3Z=DX0/DYP*KYN
C        T2X=TY(I,J+1,K)
C        T3Z=TY(I,J+1,K)
       ENDIF
       IF(K.EQ.KK)THEN
        NBOUND=NBOUND+1
        T3X=0.
        T2Y=0.
       ELSE
        DZP=(DZ(I,J,K)+DZ(I,J,K+1))/2
        T3X=DY0/DZP*KZN
        T2Y=DX0/DZP*KZN
C        T3X=TZ(I,J,K+1)
C        T2Y=TZ(I,J,K+1)
       ENDIF
C
       BBX=1/(T1X+T2X+T3X+T4X)
       BBY=1/(T1Y+T2Y+T3Y+T4Y)
       BBZ=1/(T1Z+T2Z+T3Z+T4Z)
C
       R11X=YW**2 + (DZM+ZW)**2
       R21X=(DYP-YW)**2 + ZW**2
       R31X=YW**2 + (DZP-ZW)**2
       R41X=(DYM+YW)**2 + ZW**2
       R11Y=ZW**2 + (DXM+XW)**2
       R21Y=(DZP-ZW)**2 + XW**2
       R31Y=ZW**2 + (DXP-XW)**2
       R41Y=(DZM+ZW)**2 + XW**2
       R11Z=XW**2 + (DYM+YW)**2
       R21Z=(DXP-XW)**2 + YW**2
       R31Z=XW**2 + (DYP-YW)**2
       R41Z=(DXM+XW)**2 + YW**2
C  **** RX, RY, RZ FOR NON-BOUNDARY WELL BLOCK
       IF(R11X.EQ.0..AND.T1X.EQ.0.)R11X=1.
       IF(R21X.EQ.0..AND.T2X.EQ.0.)R21X=1.
       IF(R31X.EQ.0..AND.T3X.EQ.0.)R31X=1.
       IF(R41X.EQ.0..AND.T4X.EQ.0.)R41X=1.
       IF(R11Y.EQ.0..AND.T1Y.EQ.0.)R11Y=1.
       IF(R21Y.EQ.0..AND.T2Y.EQ.0.)R21Y=1.
       IF(R31Y.EQ.0..AND.T3Y.EQ.0.)R31Y=1.
       IF(R41Y.EQ.0..AND.T4Y.EQ.0.)R41Y=1.
       IF(R11Z.EQ.0..AND.T1Z.EQ.0.)R11Z=1.
       IF(R21Z.EQ.0..AND.T2Z.EQ.0.)R21Z=1.
       IF(R31Z.EQ.0..AND.T3Z.EQ.0.)R31Z=1.
       IF(R41Z.EQ.0..AND.T4Z.EQ.0.)R41Z=1.
       RX=T1X*ALOG(R11X)+T2X*ALOG(R21X)+T3X*ALOG(R31X)+T4X*ALOG(R41X)
       RY=T1Y*ALOG(R11Y)+T2Y*ALOG(R21Y)+T3Y*ALOG(R31Y)+T4Y*ALOG(R41Y)
       RZ=T1Z*ALOG(R11Z)+T2Z*ALOG(R21Z)+T3Z*ALOG(R31Z)+T4Z*ALOG(R41Z)
       AX=1.
       AY=1.
       AZ=1.
C ***** IF THIS WELL BLOCK HAS NO BOUNDARY ....
       IF(NBOUND.EQ.0)GO TO 800
C ***** IF THIS WELL BLOCK HAS ONE BOUNDARY ....
 400   IF(NBOUND.GT.1)GO TO 500
       IF(I.NE.1.AND.I.NE.II)THEN
        CALL RONE(1,J,K,JJ,KK,YW,DY0,DYM,DYP,ZW,DZ0,DZM,DZP,RX,AX)
        ENDIF
      IF(J.NE.1.AND.J.NE.JJ)THEN
        CALL RONE(2,K,I,KK,II,ZW,DZ0,DZM,DZP,XW,DX0,DXM,DXP,RY,AY)
        ENDIF
       IF(K.NE.1.AND.K.NE.KK)THEN
        CALL RONE(3,I,J,II,JJ,XW,DX0,DXM,DXP,YW,DY0,DYM,DYP,RZ,AZ)
        ENDIF
       GO TO 800
 500   IF(NBOUND.EQ.2)CALL TWOBOUND
       IF(NBOUND.EQ.3)CALL THREEBOUND
       IF(NBOUND.EQ.4)CALL FOURBOUND
C
C ***** PID CALCULATION IN X, Y, AND Z COMPONENT
C     IF "NOT KX=KY=KZ", WELLBORE EQUIVALENT RADIUS IS MODIFIED BASED ON --
C       --- PEACEMAN'S FORMULA (SPEJ, JUNE 1983)
 800   RKXY=KX(I,J,K)/KY(I,J,K)
       RKYZ=KY(I,J,K)/KZ(I,J,K)
       RKXZ=KX(I,J,K)/KZ(I,J,K)
       ROX=EXP(-ALOG(AX)-2*3.1416*BBX+BBX*RX/2)
       IF(RKYZ.NE.1)THEN
        RX1=2*(DY0**2/RKYZ+DZ0**2*RKYZ)**.5
        RX2=((DY0**2+DZ0**2)**.5)*(1/(RKYZ**.25)+RKYZ**.25)
        ROX=ROX*RX1/RX2
       ENDIF
       PIDX=.00708*(KY(I,J,K)*KZ(I,J,K))**.5*DXX/(ALOG(ROX/RW)+S)
C
       ROY=EXP(-ALOG(AY)-2*3.1416*BBY+BBY*RY/2)
       IF(RKXZ.NE.1)THEN
        RY1=2*(DX0**2/RKXZ+DZ0**2*RKXZ)**.5
        RY2=((DX0**2+DZ0**2)**.5)*(1/(RKXZ**.25)+RKXZ**.25)
        ROY=ROY*RY1/RY2
       ENDIF
       PIDY=.00708*(KX(I,J,K)*KZ(I,J,K))**.5*DYY/(ALOG(ROY/RW)+S)
C
       ROZ=EXP(-ALOG(AZ)-2*3.1416*BBZ+BBZ*RZ/2)
       IF(RKXY.NE.1)THEN
        RZ1=2*(DX0**2/RKXY+DY0**2*RKXY)**.5
        RZ2=((DX0**2+DY0**2)**.5)*(1/(RKXY**.25)+RKXY**.25)
        ROZ=ROZ*RZ1/RZ2
       ENDIF
       PIDZ=.00708*(KX(I,J,K)*KY(I,J,K))**.5*DZZ/(ALOG(ROZ/RW)+S)
C
       PID(N,M)=(PIDX**2+PIDY**2+PIDZ**2)**.5
       SUMPID=SUMPID+PID(N,M)
       IQH1(N,M)=I
       IQH2(N,M)=J
       IQH3(N,M)=K
      WRITE(NO,703)IQH1(N,M),IQH2(N,M),IQH3(N,M),WELLID(N),DL,QVO(N),
     & QVW(N),QVG(N),QVT(N),PWF(N,M),PID(N,M),PIDX,PIDY,PIDZ
C
 890   RL=RL-DL
       IF(RL.LE.0.001)GO TO 1000
       DXI=DXI-DXX
       DYI=DYI-DYY
       DZI=DZI-DZZ
       IF(DXI.GT.0.1)GO TO 900
       I=I+ID
       IF(I.GT.II.OR.I.LT.1)GO TO 1000
       DXI=DX(I,J,K)
 900   IF(DYI.GT.0.1)GO TO 910
       J=J+JD
       IF(J.GT.JJ.OR.J.LT.1)GO TO 1000
       DYI=DY(I,J,K)
 910   IF(DZI.GT.0.1)GO TO 920
       K=K+KD
       IF(K.GT.KK.OR.K.LT.1)GO TO 1000
       DZI=DZ(I,J,K)
 920   GO TO 210
1000   IF(NGEL.NE.1.OR.QVW(N).GE.0.) GO TO 1001
       READ(NI,*)(CQI(N,KC),KC=1,5)
       DO 950 KL=1,M
        I1=IQH1(N,KL)
        I2=IQH2(N,KL)
        I3=IQH3(N,KL)
        DO 950 KC=1,5
         I3C=I3+KK*(KC-1)
         C(I1,I2,I3C)=(C(I1,I2,I3C)*VP(I1,I2,I3)-CQI(N,KC)
     &    *QVW(N)*PID(N,KL)/SUMPID*DELT)/VP(I1,I2,I3)
 950   CONTINUE
1001   CONTINUE
C
607   FORMAT(//T15,'RESERVOIR CONTAINS FOLLOWING RATE NODES
     & (FOR SLANT WELLS) '/)
608   FORMAT(T2,'   NODE    WELL   LONG(FT)',2X,' OIL(STBD)',
     & 2X,'WATER(STBD)',2X,'GAS(MCFD)',2X,'TOTAL(RBD)',2X,'BHFP(PSIA)'
     & ,3X,'PID',5X,'PID-X',3X,'PID-Y',3X,'PID-Z')
703   FORMAT(1X,3I3,2X,A5,F8.2,2X,F10.2,4F12.2,F10.4,3F8.3)
       RETURN
       END 
C ======================================================================
       SUBROUTINE RONE(M,I,J,II,JJ,XW,DX0,DXM,DXP,YW,DY0,DYM,DYP,RR,A2)
C ======================================================================
      COMMON /R1XYZ/ R11X,R21X,R31X,R41X,R11Y,R21Y,R31Y,R41Y,
     & R11Z,R21Z,R31Z,R41Z
       COMMON /T1XYZ/ T1X,T2X,T3X,T4X,T1Y,T2Y,T3Y,T4Y,T1Z,T2Z,T3Z,T4Z
       IF(M.EQ.1)THEN
         R11=R11X
         R21=R21X
         R31=R31X
         R41=R41X
         T1=T1X
         T2=T2X
         T3=T3X
         T4=T4X
        ENDIF
       IF(M.EQ.2)THEN
         R11=R11Y
         R21=R21Y
         R31=R31Y
         R41=R41Y
         T1=T1Y
         T2=T2Y
         T3=T3Y
         T4=T4Y
        ENDIF
       IF(M.EQ.3)THEN
         R11=R11Z
         R21=R21Z
         R31=R31Z
         R41=R41Z
         T1=T1Z
         T2=T2Z
         T3=T3Z
         T4=T4Z
        ENDIF
C
       IF(I.EQ.1)THEN
        A2Z=DX0+2*XW
        R12Z=(DX0+XW)**2+(DYM+YW)**2
        R22Z=(DXP+DX0+XW)**2+YW**2
        R32Z=(DX0+XW)**2+(DYP-YW)**2
        R42Z=1
       ENDIF
       IF(J.EQ.1)THEN
        A2Z=DY0+2*YW
        R12Z=1
        R22Z=(DXP-XW)**2+(DY0+YW)**2
        R32Z=XW**2+(DYP+DY0+YW)**2
        R42Z=(DXM+XW)**2+(DY0+YW)**2  
       ENDIF
       IF(I.EQ.II)THEN
        A2Z=DX0-2*XW
        R12Z=(DX0-XW)**2+(DYM+YW)**2
        R22Z=1
        R32Z=(DX0-XW)**2+(DYP-YW)**2
        R42Z=(DXM+DX0-XW)**2+YW**2
       ENDIF
       IF(J.EQ.JJ)THEN
        A2Z=DY0-2*YW
        R12Z=XW**2+(DY0+DYM-YW)**2
        R22Z=(DXP-XW)**2+(DY0-YW)**2
        R32Z=1
        R42Z=(DXM+XW)**2+(DY0-YW)**2
       ENDIF
 450    R1Z=R11*R12Z
        R2Z=R21*R22Z
        R3Z=R31*R32Z
        R4Z=R41*R42Z
        RZ=T1*ALOG(R1Z)+T2*ALOG(R2Z)+T3*ALOG(R3Z)+T4*ALOG(R4Z)
        RR=RZ
        A2=A2Z
C        WRITE(NO,1)R11,R21,R31,R41,R12Z,R22Z,R32Z,R42Z
  1     FORMAT(8E10.2)

        RETURN
        END
C ==============================================================
        SUBROUTINE RTWO1(DX0,DXP,XW,DY0,DYP,YW,T2,T3,RR,A)
C ==============================================================
        A2=DY0+2*YW
        A4=DX0+2*XW
        A3=(A2**2+A4**2)**.5
        A=A2*A3*A4
C        WRITE(NO,1)A2,A3,A4,A
    1   FORMAT(4F10.1)
C
        R21=(DXP-XW)**2+YW**2
        R22=(DXP-XW)**2+(A2-YW)**2
        R23=(A4+DXP-XW)**2+(A2-YW)**2
        R24=(A4+DXP-XW)**2+YW**2
        R2=R21*R22*R23*R24
C
        R31=XW**2+(DYP-YW)**2
        R32=XW**2+(DYP+A2-YW)**2
        R33=(DX0+XW)**2+(DY0+DYP+YW)**2
        R34=(DX0+XW)**2+(DYP-YW)**2
        R3=R31*R32*R33*R34
        RR=T2*ALOG(R2)+T3*ALOG(R3)
C
        RETURN
        END
C
C =============================================================
        SUBROUTINE RTWO2(DX0,XW,DYM,DYP,YW,T1,T3,RR,A)
C =============================================================
C      
        A2=DX0-2*XW
        A3=DX0+2*XW
        A=A2*A3
C
        R11=XW**2+(DYM+YW)**2
        R12=(DX0-XW)**2+(DYM+YW)**2
        R13=(DX0+XW)**2+(DYM+YW)**2
        R1=R11*R12*R13
C
        R31=XW**2+(DYP-YW)**2
        R32=(DX0-XW)**2+(DYP-YW)**2
        R33=(DX0+XW)**2+(DYP-YW)**2
        R3=R31*R32*R33
C
        RR=T1*ALOG(R1)+T3*ALOG(R3)
        RETURN
        END
C
C =========================================================
        SUBROUTINE RTHREE(DX0,DXP,XW,DY0,DYP,YW,T3,RR,A)
C ==========================================================
C
        A2=DY0+2*YW
        A3=DX0-2*XW
        A4=DX0+2*XW
        A5=(A2*A2+A3*A3)**.5
        A6=(A2*A2+A4*A4)**.5
        A=A2*A3*A4*A5*A6
C
        R31=XW**2+(DYP-YW)**2
        R32=XW**2+(DY0+DYP+YW)**2
        R33=(DX0-XW)**2+(DYP-YW)**2
        R34=(DX0+XW)**2+(DYP-YW)**2
        R35=(DX0-XW)**2+(DY0+DYP+YW)**2
        R36=(DX0+XW)**2+(DY0+DYP+YW)**2
C 
        R3=R31*R32*R33*R34*R35*R36
        RR=T3*ALOG(R3)
C
        RETURN
        END
C
C ===================================================================
       SUBROUTINE TWOBOUND
C ===================================================================
      COMMON /T1XYZ/ T1X,T2X,T3X,T4X,T1Y,T2Y,T3Y,T4Y,T1Z,T2Z,T3Z,T4Z
      COMMON /DXYZ/ DX0,DXP,DXM,XW,DY0,DYP,DYM,YW,DZ0,DZP,DZM,ZW
      COMMON /NUMBER/ II,JJ,KK
      COMMON /RXYZ/ RX,RY,RZ,AX,AY,AZ,I,J,K
       IF(I.EQ.1.AND.J.EQ.1)THEN
        CALL RTWO1(DX0,DXP,XW,DY0,DYP,YW,T2Z,T3Z,RZ,AZ)
        CALL RONE(1,J,K,JJ,KK,YW,DY0,DYM,DYP,ZW,DZ0,DZM,DZP,RX,AX)
        CALL RONE(2,K,I,KK,II,ZW,DZ0,DZM,DZP,XW,DX0,DXM,DXP,RY,AY)
        ENDIF
C
       IF(I.EQ.1.AND.K.EQ.1)THEN
        CALL RTWO1(DZ0,DZP,ZW,DX0,DXP,XW,T2Y,T3Y,RY,AY)
        CALL RONE(1,J,K,JJ,KK,YW,DY0,DYM,DYP,ZW,DZ0,DZM,DZP,RX,AX)
        CALL RONE(3,I,J,II,JJ,XW,DX0,DXM,DXP,YW,DY0,DYM,DYP,RZ,AZ)
        ENDIF
C
       IF(I.EQ.1.AND.I.EQ.II)THEN
        CALL RTWO2(DX0,XW,DYM,DYP,YW,T1Z,T3Z,RZ,AZ)
        CALL RTWO2(DX0,XW,DZP,DZM,-ZW,T2Y,T4Y,RY,AY)
        ENDIF
C
       IF(I.EQ.1.AND.J.EQ.JJ)THEN
        CALL RTWO1(DY0,DYM,-YW,DX0,DXP,XW,T1Z,T2Z,RZ,AZ)
        CALL RONE(1,J,K,JJ,KK,YW,DY0,DYM,DYP,ZW,DZ0,DZM,DZP,RX,AX)
        CALL RONE(2,K,I,KK,II,ZW,DZ0,DZM,DZP,XW,DX0,DXM,DXP,RY,AY)
        ENDIF
C
       IF(I.EQ.1.AND.K.EQ.KK)THEN
        CALL RTWO1(DX0,DXP,XW,DZ0,DZM,-ZW,T3Y,T4Y,RY,AY)
        CALL RONE(1,J,K,JJ,KK,YW,DY0,DYM,DYP,ZW,DZ0,DZM,DZP,RX,AX)
        CALL RONE(3,I,J,II,JJ,XW,DX0,DXM,DXP,YW,DY0,DYM,DYP,RZ,AZ)
        ENDIF
C
       IF(J.EQ.1.AND.K.EQ.1)THEN
        CALL RTWO1(DY0,DYP,YW,DZ0,DZP,ZW,T2X,T3X,RX,AX)
        CALL RONE(2,K,I,KK,II,ZW,DZ0,DZM,DZP,XW,DX0,DXM,DXP,RY,AY)
        CALL RONE(3,I,J,II,JJ,XW,DX0,DXM,DXP,YW,DY0,DYM,DYP,RZ,AZ)
        ENDIF
C
       IF(J.EQ.1.AND.I.EQ.II)THEN
        CALL RTWO1(DY0,DYP,YW,DX0,DXM,-XW,T3Z,T4Z,RZ,AZ)
        CALL RONE(1,J,K,JJ,KK,YW,DY0,DYM,DYP,ZW,DZ0,DZM,DZP,RX,AX)
        CALL RONE(2,K,I,KK,II,ZW,DZ0,DZM,DZP,XW,DX0,DXM,DXP,RY,AY)
        ENDIF
C
       IF(J.EQ.1.AND.J.EQ.JJ)THEN
        CALL RTWO2(DY0,YW,DXP,DXM,-XW,T2Z,T4Z,RZ,AZ)
        CALL RTWO2(DY0,YW,DZM,DZP,ZW,T1X,T3X,RX,AX)
        ENDIF
C
       IF(J.EQ.1.AND.K.EQ.KK)THEN
        CALL RTWO1(DZ0,DZM,-ZW,DY0,DYP,YW,T1X,T2X,RX,AX)
        CALL RONE(2,K,I,KK,II,ZW,DZ0,DZM,DZP,XW,DX0,DXM,DXP,RY,AY)
        CALL RONE(3,I,J,II,JJ,XW,DX0,DXM,DXP,YW,DY0,DYM,DYP,RZ,AZ)
        ENDIF

C
       IF(K.EQ.1.AND.I.EQ.II)THEN
        CALL RTWO1(DX0,DXM,-XW,DZ0,DZP,ZW,T1Y,T2Y,RY,AY)
        CALL RONE(1,J,K,JJ,KK,YW,DY0,DYM,DYP,ZW,DZ0,DZM,DZP,RX,AX)
        CALL RONE(3,I,J,II,JJ,XW,DX0,DXM,DXP,YW,DY0,DYM,DYP,RZ,AZ)
        ENDIF
C
       IF(K.EQ.1.AND.J.EQ.JJ)THEN
        CALL RTWO1(DZ0,DZP,ZW,DY0,DYM,-YW,T3X,T4X,RX,AX)
        CALL RONE(2,K,I,KK,II,ZW,DZ0,DZM,DZP,XW,DX0,DXM,DXP,RY,AY)
        CALL RONE(3,I,J,II,JJ,XW,DX0,DXM,DXP,YW,DY0,DYM,DYP,RZ,AZ)
        ENDIF
C
       IF(K.EQ.1.AND.K.EQ.KK)THEN
        CALL RTWO2(DZ0,ZW,DYP,DYM,-YW,T2X,T4X,RX,AX)
        CALL RTWO2(DZ0,ZW,DXM,DXP,XW,T1Y,T3Y,RY,AY)
        ENDIF
C
       IF(I.EQ.II.AND.J.EQ.JJ)THEN
        CALL RTWO1(DX0,DXM,-XW,DY0,DYM,-YW,T4Z,T1Z,RZ,AZ)
        CALL RONE(1,J,K,JJ,KK,YW,DY0,DYM,DYP,ZW,DZ0,DZM,DZP,RX,AX)
        CALL RONE(2,K,I,KK,II,ZW,DZ0,DZM,DZP,XW,DX0,DXM,DXP,RY,AY)
        ENDIF
C
       IF(I.EQ.II.AND.K.EQ.KK)THEN
        CALL RTWO1(DZ0,DZM,-ZW,DX0,DXM,-XW,T4Y,T1Y,RY,AY)
        CALL RONE(1,J,K,JJ,KK,YW,DY0,DYM,DYP,ZW,DZ0,DZM,DZP,RX,AX)
        CALL RONE(3,I,J,II,JJ,XW,DX0,DXM,DXP,YW,DY0,DYM,DYP,RZ,AZ)
        ENDIF
C
       IF(J.EQ.JJ.AND.K.EQ.KK)THEN
        CALL RTWO1(DY0,DYM,-YW,DZ0,DZM,-ZW,T4X,T1X,RX,AX)
        CALL RONE(2,K,I,KK,II,ZW,DZ0,DZM,DZP,XW,DX0,DXM,DXP,RY,AY)
        CALL RONE(3,I,J,II,JJ,XW,DX0,DXM,DXP,YW,DY0,DYM,DYP,RZ,AZ)
        ENDIF
C
       RETURN
       END
C
C ===================================================================
       SUBROUTINE THREEBOUND
C ===================================================================
      COMMON /T1XYZ/ T1X,T2X,T3X,T4X,T1Y,T2Y,T3Y,T4Y,T1Z,T2Z,T3Z,T4Z
      COMMON /DXYZ/ DX0,DXP,DXM,XW,DY0,DYP,DYM,YW,DZ0,DZP,DZM,ZW
      COMMON /NUMBER/ II,JJ,KK
      COMMON /RXYZ/ RX,RY,RZ,AX,AY,AZ,I,J,K
       IF(I.EQ.1.AND.J.EQ.1.AND.K.EQ.1)THEN
        CALL RTWO1(DY0,DYP,YW,DZ0,DZP,ZW,T2X,T3X,RX,AX)
        CALL RTWO1(DZ0,DZP,ZW,DX0,DXP,XW,T2Y,T3Y,RY,AY)
        CALL RTWO1(DX0,DXP,XW,DY0,DYP,YW,T2Z,T3Z,RZ,AZ)
        ENDIF
C
       IF(I.EQ.1.AND.J.EQ.1.AND.K.EQ.KK)THEN
        CALL RTWO1(DZ0,DZM,-ZW,DY0,DYP,YW,T1X,T2X,RX,AX)
        CALL RTWO1(DX0,DXP,XW,DZ0,DZM,-ZW,T3Y,T4Y,RY,AY)
        CALL RTWO1(DY0,DYP,YW,DX0,DXP,XW,T3Z,T2Z,RZ,AZ)
        ENDIF
C
       IF(I.EQ.1.AND.J.EQ.JJ.AND.K.EQ.1)THEN
        CALL RTWO1(DZ0,DZP,ZW,DY0,DYM,-YW,T3X,T4X,RX,AX)
        CALL RTWO1(DX0,DXP,XW,DZ0,DZP,ZW,T3Y,T2Y,RY,AY)
        CALL RTWO1(DY0,DYM,-YW,DX0,DXP,XW,T1Z,T2Z,RZ,AZ)
        ENDIF
C
       IF(I.EQ.1.AND.J.EQ.JJ.AND.K.EQ.KK)THEN
        CALL RTWO1(DY0,DYM,-YW,DZ0,DZM,-ZW,T4X,T1X,RX,AX)
        CALL RTWO1(DZ0,DZM,-ZW,DX0,DXP,XW,T4Y,T3Y,RY,AY)
        CALL RTWO1(DX0,DXP,XW,DY0,DYM,-YW,T2Z,T1Z,RZ,AZ)
        ENDIF
C
       IF(I.EQ.II.AND.J.EQ.1.AND.K.EQ.1)THEN
        CALL RTWO1(DZ0,DZP,ZW,DY0,DYP,YW,T3X,T2X,RX,AX)
        CALL RTWO1(DX0,DXM,-XW,DZ0,DZP,ZW,T1Y,T2Y,RY,AY)
        CALL RTWO1(DY0,DYP,YW,DX0,DXM,-XW,T3Z,T4Z,RZ,AZ)
        ENDIF
C
       IF(I.EQ.II.AND.J.EQ.1.AND.K.EQ.KK)THEN
        CALL RTWO1(DY0,DYP,YW,DZ0,DZM,-ZW,T2X,T1X,RX,AX)
        CALL RTWO1(DZ0,DZM,-ZW,DX0,DXM,-XW,T4Y,T1Y,RY,AY)
        CALL RTWO1(DX0,DXM,-XW,DY0,DYP,YW,T4Z,T3Z,RZ,AZ)
        ENDIF
C
       IF(I.EQ.II.AND.J.EQ.JJ.AND.K.EQ.1)THEN
        CALL RTWO1(DY0,DYM,-YW,DZ0,DZP,ZW,T4X,T3X,RX,AX)
        CALL RTWO1(DZ0,DZP,ZW,DX0,DXM,-XW,T2Y,T1Y,RY,AY)
        CALL RTWO1(DX0,DXM,-XW,DY0,DYM,-YW,T4Z,T1Z,RZ,AZ)
        ENDIF
C
       IF(I.EQ.II.AND.J.EQ.JJ.AND.K.EQ.KK)THEN
        CALL RTWO1(DZ0,DZM,-ZW,DY0,DYM,-YW,T1X,T4X,RX,AX)
        CALL RTWO1(DX0,DXM,-XW,DZ0,DZM,-ZW,T1Y,T4Y,RY,AY)
        CALL RTWO1(DY0,DYM,-YW,DX0,DXM,-XW,T1Z,T4Z,RZ,AZ)
        ENDIF
C
       IF(I.EQ.1.AND.I.EQ.II.AND.J.EQ.1)THEN
        CALL RONE(1,J,K,JJ,KK,YW,DY0,DYM,DYP,ZW,DZ0,DZM,DZP,RX,AX)
        CALL RTWO2(DX0,XW,DZP,DZM,-ZW,T2Y,T4Y,RY,AY)
        CALL RTHREE(DX0,DXP,XW,DY0,DYP,YW,T3Z,RZ,AZ)
        ENDIF
C
       IF(I.EQ.1.AND.I.EQ.II.AND.J.EQ.JJ)THEN
        CALL RONE(1,J,K,JJ,KK,YW,DY0,DYM,DYP,ZW,DZ0,DZM,DZP,RX,AX)
        CALL RTWO2(DX0,XW,DZP,DZM,-ZW,T2Y,T4Y,RY,AY)
        CALL RTHREE(DX0,DXP,XW,DY0,DYM,-YW,T1Z,RZ,AZ)
        ENDIF
C
       IF(I.EQ.1.AND.I.EQ.II.AND.K.EQ.1)THEN
        CALL RONE(1,J,K,JJ,KK,YW,DY0,DYM,DYP,ZW,DZ0,DZM,DZP,RX,AX)
        CALL RTWO2(DX0,XW,DYM,DYP,YW,T1Z,T3Z,RZ,AZ)
        CALL RTHREE(DX0,DXP,XW,DZ0,DZP,ZW,T2Y,RY,AY)
        ENDIF
C
       IF(I.EQ.1.AND.I.EQ.II.AND.K.EQ.KK)THEN
        CALL RONE(1,J,K,JJ,KK,YW,DY0,DYM,DYP,ZW,DZ0,DZM,DZP,RX,AX)
        CALL RTWO2(DX0,XW,DYM,DYP,YW,T1Z,T3Z,RZ,AZ)
        CALL RTHREE(DX0,DXP,XW,DZ0,DZM,-ZW,T4Y,RY,AY)
        ENDIF
C
       IF(J.EQ.1.AND.J.EQ.JJ.AND.I.EQ.1)THEN
        CALL RONE(2,K,I,KK,II,ZW,DZ0,DZM,DZP,XW,DX0,DXM,DXP,RY,AY)
        CALL RTWO2(DY0,YW,DZM,DZP,ZW,T1X,T3X,RX,AX)
        CALL RTHREE(DY0,DYP,YW,DX0,DXP,XW,T2Z,RZ,AZ)
        ENDIF
C
       IF(J.EQ.1.AND.J.EQ.JJ.AND.I.EQ.II)THEN
        CALL RONE(2,K,I,KK,II,ZW,DZ0,DZM,DZP,XW,DX0,DXM,DXP,RY,AY)
        CALL RTWO2(DY0,YW,DZM,DZP,ZW,T1X,T3X,RX,AX)
        CALL RTHREE(DY0,DYP,YW,DX0,DXM,-XW,T4Z,RZ,AZ)
        ENDIF
C
       IF(J.EQ.1.AND.J.EQ.JJ.AND.K.EQ.1)THEN
        CALL RONE(2,K,I,KK,II,ZW,DZ0,DZM,DZP,XW,DX0,DXM,DXP,RY,AY)
        CALL RTWO2(DY0,YW,DXP,DXM,-XW,T2Z,T4Z,RZ,AZ)
        CALL RTHREE(DY0,DYP,YW,DZ0,DZP,ZW,T3X,RX,AX)
        ENDIF
C
       IF(J.EQ.1.AND.J.EQ.JJ.AND.K.EQ.KK)THEN
        CALL RONE(2,K,I,KK,II,ZW,DZ0,DZM,DZP,XW,DX0,DXM,DXP,RY,AY)
        CALL RTWO2(DY0,YW,DXP,DXM,-XW,T2Z,T4Z,RZ,AZ)
        CALL RTHREE(DY0,DYP,YW,DZ0,DZM,-ZW,T1X,RX,AX)
        ENDIF
C
       IF(K.EQ.1.AND.K.EQ.KK.AND.I.EQ.1)THEN
        CALL RONE(3,I,J,II,JJ,XW,DX0,DXM,DXP,YW,DY0,DYM,DYP,RZ,AZ)
        CALL RTWO2(DZ0,ZW,DYP,DYM,-YW,T2X,T4X,RX,AX)
        CALL RTHREE(DZ0,DZP,ZW,DX0,DXP,XW,T3Y,RY,AY)
        ENDIF
C
       IF(K.EQ.1.AND.K.EQ.KK.AND.I.EQ.II)THEN
        CALL RONE(3,I,J,II,JJ,XW,DX0,DXM,DXP,YW,DY0,DYM,DYP,RZ,AZ)
        CALL RTWO2(DZ0,ZW,DYP,DYM,-YW,T2X,T4X,RX,AX)
        CALL RTHREE(DZ0,DZP,ZW,DX0,DXM,-XW,T1Y,RY,AY)
        ENDIF
C
       IF(K.EQ.1.AND.K.EQ.KK.AND.J.EQ.1)THEN
        CALL RONE(3,I,J,II,JJ,XW,DX0,DXM,DXP,YW,DY0,DYM,DYP,RZ,AZ)
        CALL RTWO2(DZ0,ZW,DXM,DXP,XW,T1Y,T3Y,RY,AY)
        CALL RTHREE(DZ0,DZP,ZW,DY0,DYP,YW,T2X,RX,AX)
        ENDIF
C
       IF(K.EQ.1.AND.K.EQ.KK.AND.J.EQ.JJ)THEN
        CALL RONE(3,I,J,II,JJ,XW,DX0,DXM,DXP,YW,DY0,DYM,DYP,RZ,AZ)
        CALL RTWO2(DZ0,ZW,DXM,DXP,XW,T1Y,T3Y,RY,AY)
        CALL RTHREE(DZ0,DZP,ZW,DY0,DYM,-YW,T4X,RX,AX)
        ENDIF
C 
       RETURN
       END
C
C ===================================================================
       SUBROUTINE FOURBOUND
C ===================================================================
       COMMON /T1XYZ/ T1X,T2X,T3X,T4X,T1Y,T2Y,T3Y,T4Y,T1Z,T2Z,T3Z,T4Z
       COMMON /DXYZ/ DX0,DXP,DXM,XW,DY0,DYP,DYM,YW,DZ0,DZP,DZM,ZW
       COMMON /RXYZ/ RX,RY,RZ,AX,AY,AZ,I,J,K
       COMMON /NUMBER/ II,JJ,KK
C
       IF(I.EQ.1.AND.I.EQ.II.AND.J.EQ.1.AND.K.EQ.1)THEN
        CALL RTWO1(DY0,DYP,YW,DZ0,DZP,ZW,T2X,T3X,RX,AX)
        CALL RTHREE(DX0,DXP,XW,DZ0,DZP,ZW,T2Y,RY,AY)
        CALL RTHREE(DX0,DXP,XW,DY0,DYP,YW,T3Z,RZ,AZ)
        ENDIF
C
       IF(I.EQ.1.AND.I.EQ.II.AND.J.EQ.1.AND.K.EQ.KK)THEN
        CALL RTWO1(DZ0,DZM,-ZW,DY0,DYP,YW,T1X,T2X,RX,AX)
        CALL RTHREE(DX0,DXP,XW,DZ0,DZM,-ZW,T4Y,RY,AY)
        CALL RTHREE(DX0,DXP,XW,DY0,DYP,YW,T3Z,RZ,AZ)
        ENDIF
C
       IF(I.EQ.1.AND.I.EQ.II.AND.J.EQ.JJ.AND.K.EQ.1)THEN
        CALL RTWO1(DZ0,DZP,ZW,DY0,DYM,-YW,T3X,T4X,RX,AX)
        CALL RTHREE(DX0,DXP,XW,DZ0,DZP,ZW,T2Y,RY,AY)
        CALL RTHREE(DX0,DXP,XW,DY0,DYM,-YW,T1Z,RZ,AZ)
        ENDIF
C
       IF(I.EQ.1.AND.I.EQ.II.AND.J.EQ.JJ.AND.K.EQ.KK)THEN
        CALL RTWO1(DY0,DYM,-YW,DZ0,DZM,-ZW,T4X,T1X,RX,AX)
        CALL RTHREE(DX0,DXP,XW,DZ0,DZM,-ZW,T4Y,RY,AY)
        CALL RTHREE(DX0,DXP,XW,DY0,DYM,-YW,T1Z,RZ,AZ)
        ENDIF
C
       IF(J.EQ.1.AND.J.EQ.JJ.AND.I.EQ.1.AND.K.EQ.1)THEN
        CALL RTWO1(DZ0,DZP,ZW,DX0,DXP,XW,T2Y,T3Y,RY,AY)
        CALL RTHREE(DY0,DYP,YW,DZ0,DZP,ZW,T3X,RX,AX)
        CALL RTHREE(DY0,DYP,YW,DX0,DXP,XW,T2Z,RZ,AZ)
        ENDIF
C
       IF(J.EQ.1.AND.J.EQ.JJ.AND.I.EQ.1.AND.K.EQ.KK)THEN
        CALL RTWO1(DX0,DXP,XW,DZ0,DZM,-ZW,T3Y,T4Y,RY,AY)
        CALL RTHREE(DY0,DYP,YW,DZ0,DZM,-ZW,T1X,RX,AX)
        CALL RTHREE(DY0,DYP,YW,DX0,DXP,XW,T2Z,RZ,AZ)
        ENDIF
C
       IF(J.EQ.1.AND.J.EQ.JJ.AND.I.EQ.II.AND.K.EQ.1)THEN
        CALL RTWO1(DX0,DXM,-XW,DZ0,DZP,ZW,T1Y,T2Y,RY,AY)
        CALL RTHREE(DY0,DYP,YW,DZ0,DZP,ZW,T3X,RX,AX)
        CALL RTHREE(DY0,DYP,YW,DX0,DXM,-XW,T4Z,RZ,AZ)
        ENDIF
C
       IF(J.EQ.1.AND.J.EQ.JJ.AND.I.EQ.II.AND.K.EQ.KK)THEN
        CALL RTWO1(DZ0,DZM,-ZW,DX0,DXM,-XW,T4Y,T1Y,RY,AY)
        CALL RTHREE(DY0,DYP,YW,DZ0,DZM,-ZW,T1X,RX,AX)
        CALL RTHREE(DY0,DYP,YW,DX0,DXM,-XW,T4Z,RZ,AZ)
        ENDIF
C
       IF(K.EQ.1.AND.K.EQ.KK.AND.I.EQ.1.AND.J.EQ.1)THEN
        CALL RTWO1(DX0,DXP,XW,DY0,DYP,YW,T2Z,T3Z,RZ,AZ)
        CALL RTHREE(DZ0,DZP,ZW,DY0,DYP,YW,T2X,RX,AX)
        CALL RTHREE(DZ0,DZP,ZW,DX0,DXP,XW,T3Y,RY,AY)
        ENDIF
C
       IF(K.EQ.1.AND.K.EQ.KK.AND.I.EQ.1.AND.J.EQ.JJ)THEN
        CALL RTWO1(DY0,DYM,-YW,DX0,DXP,XW,T1Z,T2Z,RZ,AZ)
        CALL RTHREE(DZ0,DZP,ZW,DY0,DYM,-YW,T4X,RX,AX)
        CALL RTHREE(DZ0,DZP,ZW,DX0,DXP,XW,T3Y,RY,AY)
        ENDIF
C
       IF(K.EQ.1.AND.K.EQ.KK.AND.I.EQ.II.AND.J.EQ.1)THEN
        CALL RTWO1(DY0,DYP,YW,DX0,DXM,-XW,T3Z,T4Z,RZ,AZ)
        CALL RTHREE(DZ0,DZP,ZW,DY0,DYP,YW,T2X,RX,AX)
        CALL RTHREE(DZ0,DZP,ZW,DX0,DXM,-XW,T1Y,RY,AY)
        ENDIF
C
       IF(K.EQ.1.AND.K.EQ.KK.AND.I.EQ.II.AND.J.EQ.JJ)THEN
        CALL RTWO1(DX0,DXM,-XW,DY0,DYM,-YW,T4Z,T1Z,RZ,AZ)
        CALL RTHREE(DZ0,DZP,ZW,DY0,DYM,-YW,T4X,RX,AX)
        CALL RTHREE(DZ0,DZP,ZW,DX0,DXM,-XW,T1Y,RY,AY)
        ENDIF

       RETURN
       END
C
C ====================================================================
C
      SUBROUTINE RESTART
C
C ====================================================================
C     CREATING A "RESTART.DAT" FILE FOR A FOLLOWED RUN AFTER A SPECIFIED
C      SIMULATION TIME. THE DISTRIBUTIONS OF RESERVOIR PRESSURE AND
C      OIL/WATER SATURATION ARE SAVED. 

      INCLUDE 'MEOR.PAR'
      CHARACTER DATA(80)
      COMMON /PRTP/ P(NX,NY,NZ)
      COMMON /PRTS/ SO(NX,NY,NZ),SW(NX,NY,NZ),SG(NX,NY,NZ)
      COMMON /NUMBER/ II,JJ,KK
      COMMON /COUNT/ N1READ,N2READ
      OPEN(10,FILE='RESTAR3C.DAT',STATUS='NEW')
      OPEN(5,FILE='BE3.DAT',STATUS='OLD')
      DO 100 N=1, N1READ
       READ(5,110) (DATA(I),I=1,80)
       WRITE(10,110) (DATA(I),I=1,80)
 100  CONTINUE
      WRITE(10,70)
      WRITE(10,80)
      DO 5 K=1,KK
      DO 5 J=1,JJ
       WRITE(10,60) (P(I,J,K),I=1,II)
   5  CONTINUE
      DO 10 K=1,KK
      DO 10 J=1,JJ
       WRITE(10,50) (SO(I,J,K),I=1,II)
  10  CONTINUE
      DO 20 K=1,KK
      DO 20 J=1,JJ
       WRITE(10,50) (SW(I,J,K),I=1,II)
  20  CONTINUE
      DO 115 N=1,N2READ
       READ(5,110) (DATA(I),I=1,80)
 115  CONTINUE
      DO 120 N=1,9999
       READ(5,110,END=200,ERR=200) (DATA(I),I=1,80)
       WRITE(10,110) (DATA(I),I=1,80)
 120  CONTINUE
  50  FORMAT(10F8.5)
  60  FORMAT(10F8.2)
  70  FORMAT('RESTART RUN -- PRESSURE & OIL/WATER SATURATION
     & OBTAINED FROM PREVIOUS RUN')
  80  FORMAT('    1    1')
 110  FORMAT(80A1)
 200  CLOSE(5,STATUS='KEEP')
      CLOSE(10,STATUS='KEEP')
      STOP
      END 
C
C**************************************************************************
C     3-D MODELING OF TRANSPORT AND ADSORPTION OF MICROBES    
C  -- CONCENTRATION SOLVED IMPLICITLY USING CRANK-NICOLSON NUMERICAL METHOD --
C  -- CHEMOTAXIS, CONVECTIVE DISPERSION, AND TUMBLING INCLUDED
C  -- NEEDS "SIGMAX" FOR IRREVERSIBLE ADSORPTION
C  -- ASSUMING LOG(K)= A0 + A1(POROSITY)
C  -- NEEDS INPUT DATA OF GAS PRODUCTION FROM EACH POUND OF NUTRIENT 
C
C     C(1) -- NUTRIENT
C     C(2) -- MICROBE
C
C**************************************************************************

      SUBROUTINE MEORDATA

      INCLUDE 'MEOR.PAR'

      CHARACTER*2 TITLE(80)
      COMMON /MEORB/ C(NX,NY,NZC),SIGMA(NX,NY,NZ),RF(NX,NY,NZ),AKC,
     & AKD,AKY,AKS,AMUM,YIELD,RHOMIC,CQI(NW,NC),MAPWI(NX,NY,NZ),RFT
      COMMON /MEOR2/ AKDN,AKM,DTUMB,ALPHAL,ALPHAT,SIGMAX,GASMEOR,REDK
      COMMON /DIFF/ DDX(NC),DDY(NC),DDZ(NC)
      COMMON /IO/ NI,NO
      COMMON /NUMBER/ II,JJ,KK

C **** READ RESERVOIR INFORMATION
      READ(NI,1)(TITLE(IH),IH=1,40)
      WRITE(NO,20)
      READ(NI,*) RHOMIC,YIELD,GASMEOR
      WRITE(NO,21) RHOMIC,YIELD,GASMEOR
      READ(NI,*) AKC,AKY,AKDN,SIGMAX,REDK
      WRITE(NO,22) AKC,AKY,AKDN,REDK
      READ(NI,*) AKD,AKS,AMUM
      WRITE(NO,25) AKD,AKS,AMUM
      READ(NI,*)AKM
      WRITE(NO,26) AKM
      READ(NI,*) ALPHAL,ALPHAT
      WRITE(NO,27) ALPHAL,ALPHAT
      READ(NI,*) DTUMB
      WRITE(NO,28) DTUMB
      READ(NI,*) DDX(1),DDY(1),DDZ(1)
      WRITE(NO,23) DDX(1),DDY(1),DDZ(1)
      READ(NI,*) DDX(2),DDY(2),DDZ(2)
      WRITE(NO,24) DDX(2),DDY(2),DDZ(2)
C
      DO 50 K=1,KK*NC
      DO 50 J=1,JJ
      DO 50 I=1,II
       C(I,J,K)=0.0
   50 CONTINUE

   1  FORMAT(40A2)
  20  FORMAT(//30X,20('*'),'MICROBIAL SYSTEM PARAMETERS',
     & 20('*')/)
  21  FORMAT(/15X,'MICROBE DENSITY (LB/CU.FT.):    ',F15.3,
     &       /15X,'CELL YIELD  COEFFICIENT:        ',F15.3,
     &       /15X,'GAS PRODUCED BY NUTRIENT (CU.FT./LB): ',F12.7)
  22  FORMAT(/15X,'CLOGGING RATE CONSTANT (1/DAY): ',F15.3,
     &       /15X,'DECLOGGING RATE CONSTANT (1/DAY):',F14.3,
     &       /15X,'DECLOGGING COEFFICIENT:          ',F14.3,
     &       /15X,'PERMEABILITY-POROSITY REDUCTION FACTOR:',F8.3)
  23  FORMAT(/15X,'DISPERSION COEFFICIENT (FT*FT/DAY) FOR
     & NUTRIENT IN X, Y, & Z DIRECTIONS:'/20X,3E20.5)
  24  FORMAT(/15X,'DISPERSION COEFFICIENT (FT*FT/DAY) FOR
     & MICROBE IN X, Y, & Z DIRECTIONS:'/20X,3E20.5)
  25  FORMAT(/15X,'SPECIFIC DECAY CONSTANT (1/DAY):',F15.3,
     &       /15X,'MONOD HALF GROWTH CONSTANT (MG/ML):',F12.1,
     &       /15X,'MAXIMUM GROWTH RATE (1/DAY):    ',F15.3)
  26  FORMAT(/15X,'CHEMOTATIC COEFFICIENT:         ',F15.3)
  27  FORMAT(/15X,'LONGITUDINAL DISPERSIVITY (FT): ',F15.3,
     &       /15X,'TRANSVERSE DISPERSIVITY (FT):   ',F15.3)
  28  FORMAT(/15X,'TUMBLING COEFFICIENT (FT*FT/DAY):',F14.3)

      RETURN
      END

C-----------------------------------------------------------------------------
      SUBROUTINE MEOR

      INCLUDE 'MEOR.PAR'

      COMMON /MEORB/ C(NX,NY,NZC),SIGMA(NX,NY,NZ),RF(NX,NY,NZ),AKC,
     & AKD,AKY,AKS,AMUM,YIELD,RHOMIC,CQI(NW,NC),MAPWI(NX,NY,NZ),RFT
      COMMON /MEOR2/ AKDN,AKM,DTUMB,ALPHAL,ALPHAT,SIGMAX,GASMEOR,REDK
      COMMON /DIFF/ DDX(NC),DDY(NC),DDZ(NC)
      COMMON /FLUX/ UX(NX,NY,NZ),UY(NX,NY,NZ),UZ(NX,NY,NZ)
      COMMON /CONC/ CC(NX,NY,NZ),QG1(NX,NY,NZ)

      COMMON /IO/ NI,NO
      COMMON /RATE/ QO(NX,NY,NZ),QW(NX,NY,NZ),QG(NX,NY,NZ)
      COMMON /PORE/ VP(NX,NY,NZ),POR(NX,NY,NZ),PV
      COMMON /VECTOR/ DX1(NX,NY,NZ),DY1(NX,NY,NZ),DZ1(NX,NY,NZ)
      COMMON /NUMBER/ II,JJ,KK
      COMMON /PRTS/ SO(NX,NY,NZ),SW(NX,NY,NZ),SG(NX,NY,NZ)
      COMMON /DT/ DELT,DELT0
      COMMON /COEF1/ AW(NX,NY,NZ),AE(NX,NY,NZ),AN(NX,NY,NZ),
     & AS(NX,NY,NZ),AB(NX,NY,NZ),AT(NX,NY,NZ),E(NX,NY,NZ),B(NX,NY,NZ)

C  NEUTRIANT/MICROBE TRANSPORT

       DT=DELT
      DO 1100 MC=1,2
      DO 1000 K=1,KK
       KC=K+(MC-1)*KK
      DO 1000 J=1,JJ
      DO 1000 I=1,II
       PHI=POR(I,J,K)
       DX=DX1(I,J,K)
       DY=DY1(I,J,K)
       DZ=DZ1(I,J,K)
       SAT=SW(I,J,K)
       DV=DX*DY*DZ
       THETA=PHI-SIGMA(I,J,K)
       AMU=AMUM*C(I,J,K)/(AKS+C(I,J,K))

       IF(MC.NE.2)GO TO 100
       DCDX1=0.
       DCDY1=0.
       DCDZ1=0.
       IF(I.GT.1.AND.I.LT.II)DCDX1=(C(I+1,J,K)-C(I-1,J,K))/DX/2
       IF(I.EQ.1.AND.II.NE.1)DCDX1=(C(I+1,J,K)-C(I,J,K))/DX
       IF(I.EQ.II.AND.II.NE.1)DCDX1=(C(I,J,K)-C(I-1,J,K))/DX

       IF(J.GT.1.AND.J.LT.JJ)DCDY1=(C(I,J+1,K)-C(I,J-1,K))/DY/2
       IF(J.EQ.1.AND.JJ.NE.1)DCDY1=(C(I,J+1,K)-C(I,J,K))/DY
       IF(J.EQ.JJ.AND.JJ.NE.1)DCDY1=(C(I,J,K)-C(I,J-1,K))/DY

       IF(K.GT.1.AND.K.LT.KK)DCDZ1=(C(I,J,K+1)-C(I,J,K-1))/DZ/2
       IF(K.EQ.1.AND.KK.NE.1)DCDZ1=(C(I,J,K+1)-C(I,J,K))/DZ
       IF(K.EQ.KK.AND.KK.NE.1)DCDZ1=(C(I,J,K)-C(I,J,K-1))/DZ

       UX1=UX(I,J,K)
       UY1=UY(I,J,K)
       UZ1=UZ(I,J,K)
       IF(C(I,J,K).GT.0.)THEN
         UX1=UX1+AKM*DCDX1/C(I,J,K)
         UY1=UY1+AKM*DCDY1/C(I,J,K)
         UZ1=UZ1+AKM*DCDZ1/C(I,J,K)
        ENDIF
C
 100   C1=DT/DX/DX/2.
       C2=UX1*DT/DX/4./THETA/SAT
       C3=DT/DY/DY/2.
       C4=UY1*DT/DY/4./THETA/SAT
       C5=DT/DZ/DZ/2.
       C6=UZ1*DT/DZ/4./THETA/SAT
       AW(I,J,K)=0.
       AE(I,J,K)=0.
       AS(I,J,K)=0.
       AN(I,J,K)=0.
       AT(I,J,K)=0.
       AB(I,J,K)=0.
       E(I,J,K)=-1.
       B(I,J,K)=0.
C       CALCULATING CONVECTIVE DISPERSION, TUMBLING, & DIFFUSION COEFFICIENTS
       DDX1=DDX(MC)
       DDY1=DDY(MC)
       DDZ1=DDZ(MC)
       UX2=UX(I,J,K)*UX(I,J,K)
       UY2=UY(I,J,K)*UY(I,J,K)
       UZ2=UZ(I,J,K)*UZ(I,J,K)
       UTOT=(UX2+UY2+UZ2)**0.5
       PSU=PHI*SAT*UTOT
       IF(PSU.EQ.0.) GO TO 110
       DKLT=(ALPHAL-ALPHAT)/PSU
       DKXX=(ALPHAL*UX2+ALPHAT*(UY2+UZ2))/PSU
       DKYY=(ALPHAL*UY2+ALPHAT*(UX2+UZ2))/PSU
       DKZZ=(ALPHAL*UZ2+ALPHAT*(UX2+UY2))/PSU
       DKXY=DKLT*ABS(UX(I,J,K)*UY(I,J,K))
       DKXZ=DKLT*ABS(UX(I,J,K)*UZ(I,J,K))
       DKYZ=DKLT*ABS(UY(I,J,K)*UZ(I,J,K))
       DDX1=DDX1+DKXX+DKXY+DKXZ
       DDY1=DDY1+DKXY+DKYY+DKYZ
       DDZ1=DDZ1+DKXZ+DKYZ+DKZZ
 110   IF(MC.EQ.2)THEN
         DDX1=DDX1+DTUMB
         DDY1=DDY1+DTUMB
         DDZ1=DDZ1+DTUMB
        ENDIF
C************************************************************
       IF(I.NE.1.AND.I.NE.II)THEN
         AW(I,J,K)=DDX1*C1+C2
         AE(I,J,K)=DDX1*C1-C2
         E(I,J,K)=E(I,J,K)-2*C1*DDX1
         B(I,J,K)=B(I,J,K)-AW(I,J,K)*C(I-1,J,KC)
     &     -AE(I,J,K)*C(I+1,J,KC)
        ENDIF
       IF(J.NE.1.AND.J.NE.JJ)THEN
         AS(I,J,K)=DDY1*C3+C4
         AN(I,J,K)=DDY1*C3-C4
         E(I,J,K)=E(I,J,K)-2*C3*DDY1
         B(I,J,K)=B(I,J,K)-AS(I,J,K)*C(I,J-1,KC)
     &     -AN(I,J,K)*C(I,J+1,KC)
        ENDIF
       IF(K.NE.1.AND.K.NE.KK)THEN
         AT(I,J,K)=DDZ1*C5+C6
         AB(I,J,K)=DDZ1*C5-C6
         E(I,J,K)=E(I,J,K)-2*C5*DDZ1
         B(I,J,K)=B(I,J,K)-AT(I,J,K)*C(I,J,KC-1)
     &     -AB(I,J,K)*C(I,J,KC+1)
        ENDIF
C************************************************************
       IF(I.EQ.1.AND.I.NE.II)THEN
        IF(C2.GE.0.)THEN
          AE(I,J,K)=-2*C1*DDX1
          E(I,J,K)=E(I,J,K)-2*C2+C1*DDX1
          B(I,J,K)=B(I,J,K)+2*DDX1*C1*C(I+1,J,KC)
     &     -2*C1*DDX1*C(I+2,J,KC)
         ELSE
          AE(I,J,K)=-2*C2-2*C1*DDX1
          E(I,J,K)=E(I,J,K)+C1*DDX1
          B(I,J,K)=B(I,J,K)+2*(DDX1*C1+C2)*C(I+1,J,KC)
     &     -2*C1*DDX1*C(I+2,J,KC)
         ENDIF
        ENDIF
 
       IF(J.EQ.1.AND.J.NE.JJ)THEN
        IF(C4.GE.0.)THEN
          AN(I,J,K)=-2*C3*DDY1
          E(I,J,K)=E(I,J,K)-2*C4+C3*DDY1
          B(I,J,K)=B(I,J,K)+2*DDY1*C3*C(I,J+1,KC)
     &     -2*C3*DDY1*C(I,J+2,KC)
         ELSE
          AN(I,J,K)=-2*C4-2*C3*DDY1
          E(I,J,K)=E(I,J,K)+C3*DDY1
          B(I,J,K)=B(I,J,K)+2*(DDY1*C3+C4)*C(I,J+1,KC)
     &     -2*C3*DDY1*C(I,J+2,KC)
         ENDIF
        ENDIF

       IF(K.EQ.1.AND.K.NE.KK)THEN
        IF(KK.EQ.2)THEN
         E(I,J,K)=E(I,J,K)-2*C6
        ELSE
         IF(C6.GE.0.)THEN
           AB(I,J,K)=-2*C5*DDZ1
           E(I,J,K)=E(I,J,K)-2*C6+C5*DDZ1
           B(I,J,K)=B(I,J,K)+2*DDZ1*C5*C(I,J,KC+1)
     &      -2*C5*DDZ1*C(I,J,KC+2)
          ELSE
           AB(I,J,K)=-2*C6-2*C5*DDZ1
           E(I,J,K)=E(I,J,K)+C5*DDZ1
           B(I,J,K)=B(I,J,K)+2*(DDZ1*C5+C6)*C(I,J,KC+1)
     &      -2*C5*DDZ1*C(I,J,KC+2)
          ENDIF
        ENDIF
       ENDIF
C************************************************************
       IF(I.NE.1.AND.I.EQ.II)THEN
        IF(C2.GE.0.)THEN
          AW(I,J,K)=2*C2-2*C1*DDX1
          E(I,J,K)=E(I,J,K)+C1*DDX1
          B(I,J,K)=B(I,J,K)+2*(DDX1*C1-C2)*C(I-1,J,KC)
     &     -2*C1*DDX1*C(I-2,J,KC)
         ELSE
          AW(I,J,K)=-2*C1*DDX1
          E(I,J,K)=E(I,J,K)+C1*DDX1+2*C2
          B(I,J,K)=B(I,J,K)+2*DDX1*C1*C(I-1,J,KC)
     &     -2*C1*DDX1*C(I-2,J,KC)
         ENDIF
        ENDIF

       IF(J.NE.1.AND.J.EQ.JJ)THEN
        IF(C4.GE.0.)THEN
          AS(I,J,K)=2*C4-2*C3*DDY1
          E(I,J,K)=E(I,J,K)+C3*DDY1
          B(I,J,K)=B(I,J,K)+2*(DDY1*C3-C4)*C(I,J-1,KC)
     &     -2*C3*DDY1*C(I,J-2,KC)
         ELSE
          AS(I,J,K)=-2*C3*DDY1
          E(I,J,K)=E(I,J,K)+C3*DDY1+2*C4
          B(I,J,K)=B(I,J,K)+2*DDY1*C3*C(I,J-1,KC)
     &     -2*C3*DDY1*C(I,J-2,KC)
         ENDIF
        ENDIF

       IF(K.NE.1.AND.K.EQ.KK)THEN
        IF(KK.EQ.2)THEN
         AT(I,J,K)=2*C6
         B(I,J,K)=B(I,J,K)-2*C6*C(I,J,KC-1)
        ELSE
         IF(C6.GE.0.)THEN
          AT(I,J,K)=2*C6-2*C5*DDZ1
          E(I,J,K)=E(I,J,K)+C5*DDZ1
          B(I,J,K)=B(I,J,K)+2*(DDZ1*C5-C6)*C(I,J,KC-1)
     &     -2*C5*DDZ1*C(I,J,KC-2)
         ELSE
          AT(I,J,K)=-2*C5*DDZ1
          E(I,J,K)=E(I,J,K)+C5*DDZ1+2*C6
          B(I,J,K)=B(I,J,K)+2*DDZ1*C5*C(I,J,KC-1)
     &     -2*C5*DDZ1*C(I,J,KC-2)
         ENDIF
        ENDIF
       ENDIF
C**************************************************************************

       IF(MC.EQ.2)E(I,J,K)=E(I,J,K)+.5*DT*(AMU-AKD-AKC)
       B(I,J,K)=B(I,J,K)-(E(I,J,K)+2)*C(I,J,KC)

       IF(MC.EQ.1)B(I,J,K)=B(I,J,K)
     &  +AMU*(C(I,J,KC+KK)+SIGMA(I,J,K)*RHOMIC/THETA/SAT)*DT/YIELD
       IF(MC.EQ.2.AND.SIGMA(I,J,K).NE.0.)THEN
         DEC1=DT*AKY*(SIGMA(I,J,K)/PHI)**AKDN
         IF(DEC1.GT.1.)DEC1=1.
         DSIGMA=SIGMA(I,J,K)-SIGMAX
         IF(DSIGMA.LT.0.)DSIGMA=0.
         B(I,J,K)=B(I,J,K)-DEC1*RHOMIC*DSIGMA/THETA/SAT
        ENDIF

       IF(QW(I,J,K).GT.0.)
     &  B(I,J,K)=B(I,J,K)+QW(I,J,K)/DV/THETA/SAT*C(I,J,KC)*DT
       IF(QW(I,J,K).LT.0.)B(I,J,K)=B(I,J,K)
     &  +QW(I,J,K)/DV/THETA/SAT*CQI(MAPWI(I,J,K),MC)*DT

C    ASSUMING "PISTON" TREATMENT IN INJ. WELL
C       IF(QW(I,J,K).LT.0.)THEN
C         AE(I,J,K)=0.
C         AW(I,J,K)=0.
C         AN(I,J,K)=0.
C         AS(I,J,K)=0.
C         AB(I,J,K)=0.
C         AT(I,J,K)=0.
C         E(I,J,K)=1.
C         B(I,J,K)=C(I,J,KC)-QW(I,J,K)*(CQI(MAPWI(I,J,K),MC)-C(I,J,KC))
C     &     *DT/THETA/DV/SAT
C        ENDIF

1000  CONTINUE

      CALL BANDIN(II,JJ,KK,2)

      DO 1050 K=1,KK
       KC=K+(MC-1)*KK
      DO 1050 J=1,JJ
      DO 1050 I=1,II
       C(I,J,KC)=CC(I,J,K)
       IF(C(I,J,KC).LT.0.)C(I,J,KC)=0.
1050  CONTINUE
1100  CONTINUE

C      CALCULATE ADSORPTION
      DO 500 K=1,KK
      DO 500 J=1,JJ
      DO 500 I=1,II
       KC=KK+K
       PHI=POR(I,J,K)
       THETA=PHI-SIGMA(I,J,K)
       AMU=AMUM*C(I,J,K)/(AKS+C(I,J,K))
       IF(SIGMA(I,J,K).EQ.0.)THEN
         SIGMA(I,J,K)=
     &    DT*AKC*THETA*SW(I,J,K)*C(I,J,KC)/RHOMIC
         GO TO 450
        ENDIF
       DSIGMA=SIGMA(I,J,K)-SIGMAX
       IF(DSIGMA.LT.0.)DSIGMA=0.
       DEC1=DT*AKY*DSIGMA*(SIGMA(I,J,K)/PHI)**AKDN
       IF(DEC1.GT.1.)THEN
         AKY1=1./DT
        ELSE
         AKY1=AKY*DSIGMA*(SIGMA(I,J,K)/PHI)**AKDN
        ENDIF
       SIGMA(I,J,K)=SIGMA(I,J,K)+DT*((AMU-AKD)*SIGMA(I,J,K)
     &  -AKY1+AKC*THETA*SW(I,J,K)*C(I,J,KC)/RHOMIC)
       IF(SIGMA(I,J,K).LT.0.)SIGMA(I,J,K)=0.
 450   IF(SIGMA(I,J,K).GT.0.63*PHI)SIGMA(I,J,K)=0.63*PHI
       THETA=PHI-SIGMA(I,J,K)
       RF(I,J,K)=10.0**(REDK*SIGMA(I,J,K))
       IF(RF(I,J,K).GT.1)RFT=2.

C **** Assuming nutrient contains 1% molasses, and the molasses consist of 58% 
C       glucose or disaccharide(C6H12O6), so 1 gram nutrient produces 
C       0.000067 moles CO2 & 0.000019 moles N2, i.e. 1.926 ml gas
C  or  0.03088(CU.FT/LB.nutrient)=454(G/LB)*1.926(ML/G.nutrient)/28317(ML/CU.FT)

C **** Based on experiments in NIPER, each gram nutrient, which contains 40-50% 
C      sugar, produces 32 ml gas (or 70 ml gas per gram of sugar).
C  ==> 0.513(cu.ft/Lb nutrient)=454(g/Lb)*32(ml/gm nutrient)/28317(ml/cu.ft)
C  Gas produced from metabolism is taken as source in well model for next t.s.

C      GASMEOR = cu.ft of gas produced from per Lb of nutrient

       DV=DX1(I,J,K)*DY1(I,J,K)*DZ1(I,J,K)
       QG1(I,J,K)=-GASMEOR*AMU*(C(I,J,KC)*THETA*SW(I,J,K)
     &  +SIGMA(I,J,K)*RHOMIC)/YIELD*DV
       QG(I,J,K)=QG1(I,J,K)

 500  CONTINUE


      RETURN
      END

C..........................................................................BAND
      SUBROUTINE BANDIN (NI,NJ,NK,LL)

      INCLUDE 'MEOR.PAR'
      COMMON /COEF1/ AW(NX,NY,NZ),AE(NX,NY,NZ),AN(NX,NY,NZ),
     & AS(NX,NY,NZ),AB(NX,NY,NZ),AT(NX,NY,NZ),E(NX,NY,NZ),B(NX,NY,NZ)
      COMMON /CONC/ CC(NX,NY,NZ),QG1(NX,NY,NZ)
      COMMON /PRTP/ P(NX,NY,NZ)
      COMMON /SBAND1/ BMAT(MAX,MAX),QVEC(MAX),PVEC(MAX)
      NMAX=NI*NJ*NK
C......INITIALIZE FACTOR MATRICES.
      DO 5 I=1,NMAX
      DO 5 J=1,NMAX
    5 BMAT(I,J)=0.
      IC=0
      DO 110 I=1,NI
      DO 110 J=1,NJ
      DO 110 K=1,NK
      IC=IC+1
      ICM=IC-1
      ICMM=IC-NK
      ICMMM=IC-NJ*NK
      ICP=IC+1
      ICPP=IC+NK
      ICPPP=IC+NJ*NK
      IF(ICMMM.LT.1) GO TO 115
      BMAT(IC,ICMMM)=AW(I,J,K)
  115 IF(ICMM.LT.1.OR.NJ.EQ.1)GO TO 120
      BMAT(IC,ICMM)=AS(I,J,K)
  120 IF(ICM.LT.1.OR.NK.EQ.1) GO TO 130
      BMAT(IC,ICM)=AT(I,J,K)
  130 BMAT(IC,IC)=E(I,J,K)
      IF(ICP.GT.NMAX.OR.NK.EQ.1)GO TO 140
      BMAT(IC,ICP)=AB(I,J,K)
  140 IF(ICPP.GT.NMAX.OR.NJ.EQ.1)GO TO 145
      BMAT(IC,ICPP)=AN(I,J,K)
  145 IF(ICPPP.GT.NMAX)GO TO 150
      BMAT(IC,ICPPP)=AE(I,J,K)
  150 QVEC(IC)=B(I,J,K)
  110 CONTINUE
      NBAND=2*NJ*NK+1
      CALL BAND(NMAX,NBAND)
      IC=0
      IF(LL.EQ.2)THEN
       DO 200 I=1,NI
       DO 200 J=1,NJ
       DO 200 K=1,NK
        IC=IC+1
  200   CC(I,J,K)=PVEC(IC)
       ELSE
       DO 210 I=1,NI
       DO 210 J=1,NJ
       DO 210 K=1,NK
        IC=IC+1
  210   P(I,J,K)=PVEC(IC)
      ENDIF

      RETURN
      END
C.......................................................................BAND
      SUBROUTINE BAND(NMAX,NBAND)

      INCLUDE 'MEOR.PAR'
C      PARAMETER(NX=200,NY=10,NZ=1,NC=2,NZC=NZ*NC,MAX=NX*NY*NZ)
      COMMON /SBAND1/ BMAT(MAX,MAX),QVEC(MAX),PVEC(MAX)
      DIMENSION GVEC(MAX)
C......BEGIN BAND ALGORITHM
C......NBAND IS TOTAL BAND WIDTH = 2*NY*NZ + 1
      NW1=(NBAND-1)/2
      DO 1110 I=1,NMAX
      L1=I-NW1
      IF(L1.LT.1)L1=1
      DO 1120 J=L1,I
      IF(J.EQ.1) GO TO 1120
      JM=J-1
      ADD=0.
      DO 1130 K=L1,JM
      IF(L1.GT.JM) GO TO 1125
 1130 ADD=ADD+BMAT(I,K)*BMAT(K,J)
1125  BMAT(I,J)=BMAT(I,J)-ADD
 1120 CONTINUE
      IF(I.EQ.NMAX) GO TO 1110
      IP=I+1
      IM=I-1
      L2=I+NW1
      IF(L2.GT.NMAX) L2=NMAX
      DO 1140 J=IP,L2
      ADD=0.
      IF(I.EQ.1) GO TO 1140
      L3=J-NW1
      IF(L3.LT.1)L3=1
      DO 1150 K=L3,IM
      IF(L3.GT.IM) GO TO 1140
 1150 ADD=ADD+BMAT(I,K)*BMAT(K,J)
 1140 BMAT(I,J)=(BMAT(I,J)-ADD)/BMAT(I,I)
 1110 CONTINUE
C......FORWARD SOLUTION
      GVEC(1)=QVEC(1)/BMAT(1,1)
      DO 300 I=2,NMAX
      L1=I-NW1
      IF(L1.LT.1)L1=1
      IM=I-1
      ADD=0.
      DO 310 K=L1,IM
  310 ADD=ADD+BMAT(I,K)*GVEC(K)
  300 GVEC(I)=(QVEC(I)-ADD)/BMAT(I,I)
C......BACKWARD SOLUTION.
      PVEC(NMAX)=GVEC(NMAX)
      DO 400 I=2,NMAX
      INVI=(NMAX+1)-I
      INVIP=INVI+1
      L2=INVI+NW1
      IF(L2.GT.NMAX) L2=NMAX
      ADD=0.
      DO 410 K=INVIP,L2
  410 ADD=ADD+BMAT(INVI,K)*PVEC(K)
  400 PVEC(INVI)=GVEC(INVI)-ADD
      RETURN
      END

